/* Copyright (C) 2023. Robert Bosch GmbH Copyright (C) 2023. Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved. */
class e {
  constructor(e, i, t = !0) {
    this.element = e, this.callbacks = i, this.considerPaddings = t, this.breakpointVP1 = 480, 
    this.breakpointVP2 = 768, this.containerPaddingForPhone = 14, this.containerPaddingForTablet = 16, 
    this.desktopBreakpoint = this.breakpointVP2 - 2 * this.containerPaddingForTablet, 
    this.tabletBreakpoint = this.breakpointVP1 - 2 * this.containerPaddingForPhone, 
    this.resizeObserver = new ResizeObserver((() => this.updateViewport())), this.isObserving = !1;
  }
  connect() {
    this.isObserving = !0, this.resizeObserver.observe(this.element), this.updateViewport();
  }
  disconnect() {
    this.isObserving = !1, this.resizeObserver.unobserve(this.element);
  }
  isConnected() {
    return this.isObserving;
  }
  get currentViewport() {
    return this._currentViewport;
  }
  updateViewport() {
    var e, i, t, s, r, o, h, n;
    const a = this.element.clientWidth;
    // it is 0 if the overlay is not visible
        if (0 === a) return;
    const l = a <= (this.considerPaddings ? this.tabletBreakpoint : this.breakpointVP1), d = a <= (this.considerPaddings ? this.desktopBreakpoint : this.breakpointVP2);
    l ? "vp1" !== this._currentViewport && (null === (i = (e = this.callbacks).onVp1) || void 0 === i || i.call(e), 
    this._currentViewport = "vp1") : d ? "vp2" !== this._currentViewport && (null === (s = (t = this.callbacks).onVp2) || void 0 === s || s.call(t), 
    this._currentViewport = "vp2") : "vp3" !== this._currentViewport && (null === (o = (r = this.callbacks).onVp3) || void 0 === o || o.call(r), 
    this._currentViewport = "vp3"), null === (n = (h = this.callbacks).onChange) || void 0 === n || n.call(h, a);
  }
}

class i {
  constructor(e = !1, i, t, s) {
    this._fullwidth = e, this.visible = !1, this.isFocussed = !1, 
    // event to trigger when an overlay is opened
    this.overlayOpenedEvent = new CustomEvent("OverlayOpenedEvent"), this.overlay = i, 
    this.host = t, this.dialog = s;
  }
  get overlay() {
    return this._overlay;
  }
  set overlay(e) {
    this._overlay = e, this._overlay && (this._overlay.host = this.host, this._overlay.dialog = this.dialog);
  }
  get host() {
    return this._host;
  }
  set host(i) {
    var t, s;
    if (this._host === i) return;
    this._host = i;
    const r = null !== (s = null === (t = this.widthObserver) || void 0 === t ? void 0 : t.isConnected()) && void 0 !== s && s;
    this.widthObserver && this.widthObserver.disconnect(), this._fullwidth && void 0 !== i && (this.widthObserver = new e(i, {
      onChange: e => this.updateOverlayWidth(e)
    }), r && this.widthObserver.connect()), this.overlay && (this.overlay.host = i);
  }
  get dialog() {
    return this._dialog;
  }
  set dialog(e) {
    this._dialog = e, this.overlay && (this.overlay.dialog = e);
  }
  isReady() {
    return void 0 !== this.host && void 0 !== this.overlay && void 0 !== this.dialog;
  }
  isHidden() {
    return this.isReady() && !this.visible;
  }
  isVisible() {
    return this.isReady() && this.visible;
  }
  async show() {
    var e;
    this.isHidden() && (
    // if another overlay is open, this event triggers it to close itself
    document.dispatchEvent(this.overlayOpenedEvent), null === (e = this.widthObserver) || void 0 === e || e.connect(), 
    await this.handleVisibilityChanged((() => this.overlay.show())), this.setupFocusObserver(), 
    this.setupScrollObserver(), this.setupMutationObserver(), document.addEventListener("OverlayOpenedEvent", (() => {
      this.hide();
    })));
  }
  async hide() {
    var e;
    if (null === (e = this.widthObserver) || void 0 === e || e.disconnect(), this.isVisible()) return this.removeFocusObserver(), 
    this.removeScrollObserver(), this.removeMutationObserver(), document.removeEventListener("OverlayOpenedEvent", (() => {})), 
    this.handleVisibilityChanged((() => this.overlay.hide()));
  }
  updateOverlayWidth(e) {
    this.dialog.style.width = `${e}px`, this.updateOverlay();
  }
  async handleVisibilityChanged(e) {
    var i;
    const t = this.visible;
    this.visible = await e(), t !== this.visible && (null === (i = this.visibilityChangeObserver) || void 0 === i || i.call(this, this.visible));
  }
  setupFocusObserver() {
    document.addEventListener("focusin", (e => this.handleFocus(e)));
  }
  removeFocusObserver() {
    document.removeEventListener("focusin", (e => this.handleFocus(e)));
  }
  handleFocus(e) {
    var i;
    const t = this.isFocussed;
    this.isFocussed = e.relatedTarget === this.dialog.parentNode || e.target === this.dialog.parentNode, 
    t != this.isFocussed && (null === (i = this.focusChangeObserver) || void 0 === i || i.call(this, this.isFocussed));
  }
  setupScrollObserver() {
    window.addEventListener("scroll", (() => this.updateOverlay())), window.addEventListener("wheel", (() => this.updateOverlay()));
  }
  removeScrollObserver() {
    window.removeEventListener("scroll", (() => this.updateOverlay())), window.removeEventListener("wheel", (() => this.updateOverlay()));
  }
  setupMutationObserver() {
    this.resizeObserver = new ResizeObserver((e => {
      e.forEach((e => {
        this.updateOverlay();
      }));
    })), this.resizeObserver.observe(this.dialog);
  }
  removeMutationObserver() {
    var e;
    null === (e = this.resizeObserver) || void 0 === e || e.disconnect();
  }
  updateOverlay() {
    window.requestAnimationFrame((() => this.overlay.update()));
  }
}

export { i as O, e as W }

