/* Copyright (C) 2023. Robert Bosch GmbH Copyright (C) 2023. Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved. */
import { _ as t, a as e, b as n } from "./p-c6808181.js";

import { M as o, a as i, m as a, c as r } from "./p-c5c53ac3.js";

import { M as s } from "./p-ef49fdcd.js";

/**
 * @license
 * Copyright 2016 Google Inc.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */
/**
 * @license
 * Copyright 2020 Google Inc.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */
var l, c = /** @class */ function() {
  function FocusTrap(t, e) {
    void 0 === e && (e = {}), this.root = t, this.options = e, 
    // Previously focused element before trapping focus.
    this.elFocusedBeforeTrapFocus = null;
  }
  /**
     * Traps focus in `root`. Also focuses on either `initialFocusEl` if set;
     * otherwises sets initial focus to the first focusable child element.
     */  return FocusTrap.prototype.trapFocus = function() {
    var t = this.getFocusableElements(this.root);
    if (0 === t.length) throw new Error("FocusTrap: Element must have at least one focusable child.");
    this.elFocusedBeforeTrapFocus = document.activeElement instanceof HTMLElement ? document.activeElement : null, 
    this.wrapTabFocus(this.root), this.options.skipInitialFocus || this.focusInitialElement(t, this.options.initialFocusEl);
  }, 
  /**
     * Releases focus from `root`. Also restores focus to the previously focused
     * element.
     */
  FocusTrap.prototype.releaseFocus = function() {
    [].slice.call(this.root.querySelectorAll(".mdc-dom-focus-sentinel")).forEach((function(t) {
      t.parentElement.removeChild(t);
    })), !this.options.skipRestoreFocus && this.elFocusedBeforeTrapFocus && this.elFocusedBeforeTrapFocus.focus();
  }, 
  /**
     * Wraps tab focus within `el` by adding two hidden sentinel divs which are
     * used to mark the beginning and the end of the tabbable region. When
     * focused, these sentinel elements redirect focus to the first/last
     * children elements of the tabbable region, ensuring that focus is trapped
     * within that region.
     */
  FocusTrap.prototype.wrapTabFocus = function(t) {
    var e = this, n = this.createSentinel(), o = this.createSentinel();
    n.addEventListener("focus", (function() {
      var n = e.getFocusableElements(t);
      n.length > 0 && n[n.length - 1].focus();
    })), o.addEventListener("focus", (function() {
      var n = e.getFocusableElements(t);
      n.length > 0 && n[0].focus();
    })), t.insertBefore(n, t.children[0]), t.appendChild(o);
  }, 
  /**
     * Focuses on `initialFocusEl` if defined and a child of the root element.
     * Otherwise, focuses on the first focusable child element of the root.
     */
  FocusTrap.prototype.focusInitialElement = function(t, e) {
    var n = 0;
    e && (n = Math.max(t.indexOf(e), 0)), t[n].focus();
  }, FocusTrap.prototype.getFocusableElements = function(t) {
    return [].slice.call(t.querySelectorAll("[autofocus], [tabindex], a, input, textarea, select, button")).filter((function(t) {
      var e = "true" === t.getAttribute("aria-disabled") || null != t.getAttribute("disabled") || null != t.getAttribute("hidden") || "true" === t.getAttribute("aria-hidden"), n = t.tabIndex >= 0 && t.getBoundingClientRect().width > 0 && !t.classList.contains("mdc-dom-focus-sentinel") && !e, o = !1;
      if (n) {
        var i = getComputedStyle(t);
        o = "none" === i.display || "hidden" === i.visibility;
      }
      return n && !o;
    }));
  }, FocusTrap.prototype.createSentinel = function() {
    var t = document.createElement("div");
    return t.setAttribute("tabindex", "0"), 
    // Don't announce in screen readers.
    t.setAttribute("aria-hidden", "true"), t.classList.add("mdc-dom-focus-sentinel"), 
    t;
  }, FocusTrap;
}(), u = /** @class */ function() {
  function AnimationFrame() {
    this.rafIDs = new Map;
  }
  /**
     * Requests an animation frame. Cancels any existing frame with the same key.
     * @param {string} key The key for this callback.
     * @param {FrameRequestCallback} callback The callback to be executed.
     */  return AnimationFrame.prototype.request = function(t, e) {
    var n = this;
    this.cancel(t);
    var o = requestAnimationFrame((function(o) {
      n.rafIDs.delete(t), 
      // Callback must come *after* the key is deleted so that nested calls to
      // request with the same key are not deleted.
      e(o);
    }));
    this.rafIDs.set(t, o);
  }, 
  /**
     * Cancels a queued callback with the given key.
     * @param {string} key The key for this callback.
     */
  AnimationFrame.prototype.cancel = function(t) {
    var e = this.rafIDs.get(t);
    e && (cancelAnimationFrame(e), this.rafIDs.delete(t));
  }, 
  /**
     * Cancels all queued callback.
     */
  AnimationFrame.prototype.cancelAll = function() {
    var t = this;
    // Need to use forEach because it's the only iteration method supported
    // by IE11. Suppress the underscore because we don't need it.
    // tslint:disable-next-line:enforce-name-casing
        this.rafIDs.forEach((function(e, n) {
      t.cancel(n);
    }));
  }, 
  /**
     * Returns the queue of unexecuted callback keys.
     */
  AnimationFrame.prototype.getQueue = function() {
    var t = [];
    // Need to use forEach because it's the only iteration method supported
    // by IE11. Suppress the underscore because we don't need it.
    // tslint:disable-next-line:enforce-name-casing
        return this.rafIDs.forEach((function(e, n) {
      t.push(n);
    })), t;
  }, AnimationFrame;
}(), d = {
  CLOSING: "mdc-dialog--closing",
  OPEN: "mdc-dialog--open",
  OPENING: "mdc-dialog--opening",
  SCROLLABLE: "mdc-dialog--scrollable",
  SCROLL_LOCK: "mdc-dialog-scroll-lock",
  STACKED: "mdc-dialog--stacked",
  FULLSCREEN: "mdc-dialog--fullscreen",
  // Class for showing a scroll divider on full-screen dialog header element.
  // Should only be displayed on scrollable content, when the dialog content is
  // scrolled "underneath" the header.
  SCROLL_DIVIDER_HEADER: "mdc-dialog-scroll-divider-header",
  // Class for showing a scroll divider on a full-screen dialog footer element.
  // Should only be displayed on scrolalble content, when the dialog content is
  // obscured "underneath" the footer.
  SCROLL_DIVIDER_FOOTER: "mdc-dialog-scroll-divider-footer",
  // The "surface scrim" is a scrim covering only the surface of a dialog. This
  // is used in situations where a confirmation dialog is shown over an already
  // opened full-screen dialog. On larger screen-sizes, the full-screen dialog
  // is sized as a modal and so in these situations we display a "surface scrim"
  // to prevent a "double scrim" (where the scrim from the secondary
  // confirmation dialog would overlap with the scrim from the full-screen
  // dialog).
  SURFACE_SCRIM_SHOWN: "mdc-dialog__surface-scrim--shown",
  // "Showing" animating class for the surface-scrim.
  SURFACE_SCRIM_SHOWING: "mdc-dialog__surface-scrim--showing",
  // "Hiding" animating class for the surface-scrim.
  SURFACE_SCRIM_HIDING: "mdc-dialog__surface-scrim--hiding",
  // Class to hide a dialog's scrim (used in conjunction with a surface-scrim).
  // Note that we only hide the original scrim rather than removing it entirely
  // to prevent interactions with the content behind this scrim, and to capture
  // scrim clicks.
  SCRIM_HIDDEN: "mdc-dialog__scrim--hidden"
}, h = {
  ACTION_ATTRIBUTE: "data-mdc-dialog-action",
  BUTTON_DEFAULT_ATTRIBUTE: "data-mdc-dialog-button-default",
  BUTTON_SELECTOR: ".mdc-dialog__button",
  CLOSED_EVENT: "MDCDialog:closed",
  CLOSE_ACTION: "close",
  CLOSING_EVENT: "MDCDialog:closing",
  CONTAINER_SELECTOR: ".mdc-dialog__container",
  CONTENT_SELECTOR: ".mdc-dialog__content",
  DESTROY_ACTION: "destroy",
  INITIAL_FOCUS_ATTRIBUTE: "data-mdc-dialog-initial-focus",
  OPENED_EVENT: "MDCDialog:opened",
  OPENING_EVENT: "MDCDialog:opening",
  SCRIM_SELECTOR: ".mdc-dialog__scrim",
  SUPPRESS_DEFAULT_PRESS_SELECTOR: [ "textarea", ".mdc-menu .mdc-list-item", ".mdc-menu .mdc-deprecated-list-item" ].join(", "),
  SURFACE_SELECTOR: ".mdc-dialog__surface"
}, p = {
  DIALOG_ANIMATION_CLOSE_TIME_MS: 75,
  DIALOG_ANIMATION_OPEN_TIME_MS: 150
};

/**
 * Utility to trap focus in a given root element, e.g. for modal components such
 * as dialogs. The root should have at least one focusable child element,
 * for setting initial focus when trapping focus.
 * Also tracks the previously focused element, and restores focus to that
 * element when releasing focus.
 */ !function(t) {
  t.POLL_SCROLL_POS = "poll_scroll_position", t.POLL_LAYOUT_CHANGE = "poll_layout_change";
}(l || (l = {}));

var f = /** @class */ function(n) {
  function MDCDialogFoundation(t) {
    var o = n.call(this, e(e({}, MDCDialogFoundation.defaultAdapter), t)) || this;
    return o.dialogOpen = !1, o.isFullscreen = !1, o.animationFrame = 0, o.animationTimer = 0, 
    o.escapeKeyAction = h.CLOSE_ACTION, o.scrimClickAction = h.CLOSE_ACTION, o.autoStackButtons = !0, 
    o.areButtonsStacked = !1, o.suppressDefaultPressSelector = h.SUPPRESS_DEFAULT_PRESS_SELECTOR, 
    o.animFrame = new u, o.contentScrollHandler = function() {
      o.handleScrollEvent();
    }, o.windowResizeHandler = function() {
      o.layout();
    }, o.windowOrientationChangeHandler = function() {
      o.layout();
    }, o;
  }
  return t(MDCDialogFoundation, n), Object.defineProperty(MDCDialogFoundation, "cssClasses", {
    get: function() {
      return d;
    },
    enumerable: !1,
    configurable: !0
  }), Object.defineProperty(MDCDialogFoundation, "strings", {
    get: function() {
      return h;
    },
    enumerable: !1,
    configurable: !0
  }), Object.defineProperty(MDCDialogFoundation, "numbers", {
    get: function() {
      return p;
    },
    enumerable: !1,
    configurable: !0
  }), Object.defineProperty(MDCDialogFoundation, "defaultAdapter", {
    get: function() {
      return {
        addBodyClass: function() {},
        addClass: function() {},
        areButtonsStacked: function() {
          return !1;
        },
        clickDefaultButton: function() {},
        eventTargetMatches: function() {
          return !1;
        },
        getActionFromEvent: function() {
          return "";
        },
        getInitialFocusEl: function() {
          return null;
        },
        hasClass: function() {
          return !1;
        },
        isContentScrollable: function() {
          return !1;
        },
        notifyClosed: function() {},
        notifyClosing: function() {},
        notifyOpened: function() {},
        notifyOpening: function() {},
        releaseFocus: function() {},
        removeBodyClass: function() {},
        removeClass: function() {},
        reverseButtons: function() {},
        trapFocus: function() {},
        registerContentEventHandler: function() {},
        deregisterContentEventHandler: function() {},
        isScrollableContentAtTop: function() {
          return !1;
        },
        isScrollableContentAtBottom: function() {
          return !1;
        },
        registerWindowEventHandler: function() {},
        deregisterWindowEventHandler: function() {}
      };
    },
    enumerable: !1,
    configurable: !0
  }), MDCDialogFoundation.prototype.init = function() {
    this.adapter.hasClass(d.STACKED) && this.setAutoStackButtons(!1), this.isFullscreen = this.adapter.hasClass(d.FULLSCREEN);
  }, MDCDialogFoundation.prototype.destroy = function() {
    this.animationTimer && (clearTimeout(this.animationTimer), this.handleAnimationTimerEnd()), 
    this.isFullscreen && this.adapter.deregisterContentEventHandler("scroll", this.contentScrollHandler), 
    this.animFrame.cancelAll(), this.adapter.deregisterWindowEventHandler("resize", this.windowResizeHandler), 
    this.adapter.deregisterWindowEventHandler("orientationchange", this.windowOrientationChangeHandler);
  }, MDCDialogFoundation.prototype.open = function(t) {
    var e = this;
    this.dialogOpen = !0, this.adapter.notifyOpening(), this.adapter.addClass(d.OPENING), 
    this.isFullscreen && 
    // A scroll event listener is registered even if the dialog is not
    // scrollable on open, since the window resize event, or orientation
    // change may make the dialog scrollable after it is opened.
    this.adapter.registerContentEventHandler("scroll", this.contentScrollHandler), t && t.isAboveFullscreenDialog && this.adapter.addClass(d.SCRIM_HIDDEN), 
    this.adapter.registerWindowEventHandler("resize", this.windowResizeHandler), this.adapter.registerWindowEventHandler("orientationchange", this.windowOrientationChangeHandler), 
    // Wait a frame once display is no longer "none", to establish basis for
    // animation
    this.runNextAnimationFrame((function() {
      e.adapter.addClass(d.OPEN), e.adapter.addBodyClass(d.SCROLL_LOCK), e.layout(), e.animationTimer = setTimeout((function() {
        e.handleAnimationTimerEnd(), e.adapter.trapFocus(e.adapter.getInitialFocusEl()), 
        e.adapter.notifyOpened();
      }), p.DIALOG_ANIMATION_OPEN_TIME_MS);
    }));
  }, MDCDialogFoundation.prototype.close = function(t) {
    var e = this;
    void 0 === t && (t = ""), this.dialogOpen && (this.dialogOpen = !1, this.adapter.notifyClosing(t), 
    this.adapter.addClass(d.CLOSING), this.adapter.removeClass(d.OPEN), this.adapter.removeBodyClass(d.SCROLL_LOCK), 
    this.isFullscreen && this.adapter.deregisterContentEventHandler("scroll", this.contentScrollHandler), 
    this.adapter.deregisterWindowEventHandler("resize", this.windowResizeHandler), this.adapter.deregisterWindowEventHandler("orientationchange", this.windowOrientationChangeHandler), 
    cancelAnimationFrame(this.animationFrame), this.animationFrame = 0, clearTimeout(this.animationTimer), 
    this.animationTimer = setTimeout((function() {
      e.adapter.releaseFocus(), e.handleAnimationTimerEnd(), e.adapter.notifyClosed(t);
    }), p.DIALOG_ANIMATION_CLOSE_TIME_MS));
  }, 
  /**
     * Used only in instances of showing a secondary dialog over a full-screen
     * dialog. Shows the "surface scrim" displayed over the full-screen dialog.
     */
  MDCDialogFoundation.prototype.showSurfaceScrim = function() {
    var t = this;
    this.adapter.addClass(d.SURFACE_SCRIM_SHOWING), this.runNextAnimationFrame((function() {
      t.adapter.addClass(d.SURFACE_SCRIM_SHOWN);
    }));
  }, 
  /**
     * Used only in instances of showing a secondary dialog over a full-screen
     * dialog. Hides the "surface scrim" displayed over the full-screen dialog.
     */
  MDCDialogFoundation.prototype.hideSurfaceScrim = function() {
    this.adapter.removeClass(d.SURFACE_SCRIM_SHOWN), this.adapter.addClass(d.SURFACE_SCRIM_HIDING);
  }, 
  /**
     * Handles `transitionend` event triggered when surface scrim animation is
     * finished.
     */
  MDCDialogFoundation.prototype.handleSurfaceScrimTransitionEnd = function() {
    this.adapter.removeClass(d.SURFACE_SCRIM_HIDING), this.adapter.removeClass(d.SURFACE_SCRIM_SHOWING);
  }, MDCDialogFoundation.prototype.isOpen = function() {
    return this.dialogOpen;
  }, MDCDialogFoundation.prototype.getEscapeKeyAction = function() {
    return this.escapeKeyAction;
  }, MDCDialogFoundation.prototype.setEscapeKeyAction = function(t) {
    this.escapeKeyAction = t;
  }, MDCDialogFoundation.prototype.getScrimClickAction = function() {
    return this.scrimClickAction;
  }, MDCDialogFoundation.prototype.setScrimClickAction = function(t) {
    this.scrimClickAction = t;
  }, MDCDialogFoundation.prototype.getAutoStackButtons = function() {
    return this.autoStackButtons;
  }, MDCDialogFoundation.prototype.setAutoStackButtons = function(t) {
    this.autoStackButtons = t;
  }, MDCDialogFoundation.prototype.getSuppressDefaultPressSelector = function() {
    return this.suppressDefaultPressSelector;
  }, MDCDialogFoundation.prototype.setSuppressDefaultPressSelector = function(t) {
    this.suppressDefaultPressSelector = t;
  }, MDCDialogFoundation.prototype.layout = function() {
    var t = this;
    this.animFrame.request(l.POLL_LAYOUT_CHANGE, (function() {
      t.layoutInternal();
    }));
  }, 
  /** Handles click on the dialog root element. */
  MDCDialogFoundation.prototype.handleClick = function(t) {
    // Check for scrim click first since it doesn't require querying ancestors.
    if (this.adapter.eventTargetMatches(t.target, h.SCRIM_SELECTOR) && "" !== this.scrimClickAction) this.close(this.scrimClickAction); else {
      var e = this.adapter.getActionFromEvent(t);
      e && this.close(e);
    }
  }, 
  /** Handles keydown on the dialog root element. */
  MDCDialogFoundation.prototype.handleKeydown = function(t) {
    var e = "Enter" === t.key || 13 === t.keyCode;
    if (e && !this.adapter.getActionFromEvent(t)) {
      // `composedPath` is used here, when available, to account for use cases
      // where a target meant to suppress the default press behaviour
      // may exist in a shadow root.
      // For example, a textarea inside a web component:
      // <mwc-dialog>
      //   <horizontal-layout>
      //     #shadow-root (open)
      //       <mwc-textarea>
      //         #shadow-root (open)
      //           <textarea></textarea>
      //       </mwc-textarea>
      //   </horizontal-layout>
      // </mwc-dialog>
      var n = t.composedPath ? t.composedPath()[0] : t.target, o = !this.suppressDefaultPressSelector || !this.adapter.eventTargetMatches(n, this.suppressDefaultPressSelector);
      e && o && this.adapter.clickDefaultButton();
    }
  }, 
  /** Handles keydown on the document. */
  MDCDialogFoundation.prototype.handleDocumentKeydown = function(t) {
    ("Escape" === t.key || 27 === t.keyCode) && "" !== this.escapeKeyAction && this.close(this.escapeKeyAction);
  }, 
  /**
     * Handles scroll event on the dialog's content element -- showing a scroll
     * divider on the header or footer based on the scroll position. This handler
     * should only be registered on full-screen dialogs with scrollable content.
     */
  MDCDialogFoundation.prototype.handleScrollEvent = function() {
    var t = this;
    // Since scroll events can fire at a high rate, we throttle these events by
    // using requestAnimationFrame.
        this.animFrame.request(l.POLL_SCROLL_POS, (function() {
      t.toggleScrollDividerHeader(), t.toggleScrollDividerFooter();
    }));
  }, MDCDialogFoundation.prototype.layoutInternal = function() {
    this.autoStackButtons && this.detectStackedButtons(), this.toggleScrollableClasses();
  }, MDCDialogFoundation.prototype.handleAnimationTimerEnd = function() {
    this.animationTimer = 0, this.adapter.removeClass(d.OPENING), this.adapter.removeClass(d.CLOSING);
  }, 
  /**
     * Runs the given logic on the next animation frame, using setTimeout to
     * factor in Firefox reflow behavior.
     */
  MDCDialogFoundation.prototype.runNextAnimationFrame = function(t) {
    var e = this;
    cancelAnimationFrame(this.animationFrame), this.animationFrame = requestAnimationFrame((function() {
      e.animationFrame = 0, clearTimeout(e.animationTimer), e.animationTimer = setTimeout(t, 0);
    }));
  }, MDCDialogFoundation.prototype.detectStackedButtons = function() {
    // Remove the class first to let us measure the buttons' natural positions.
    this.adapter.removeClass(d.STACKED);
    var t = this.adapter.areButtonsStacked();
    t && this.adapter.addClass(d.STACKED), t !== this.areButtonsStacked && (this.adapter.reverseButtons(), 
    this.areButtonsStacked = t);
  }, MDCDialogFoundation.prototype.toggleScrollableClasses = function() {
    // Remove the class first to let us measure the natural height of the
    // content.
    this.adapter.removeClass(d.SCROLLABLE), this.adapter.isContentScrollable() && (this.adapter.addClass(d.SCROLLABLE), 
    this.isFullscreen && (
    // If dialog is full-screen and scrollable, check if a scroll divider
    // should be shown.
    this.toggleScrollDividerHeader(), this.toggleScrollDividerFooter()));
  }, MDCDialogFoundation.prototype.toggleScrollDividerHeader = function() {
    this.adapter.isScrollableContentAtTop() ? this.adapter.hasClass(d.SCROLL_DIVIDER_HEADER) && this.adapter.removeClass(d.SCROLL_DIVIDER_HEADER) : this.adapter.addClass(d.SCROLL_DIVIDER_HEADER);
  }, MDCDialogFoundation.prototype.toggleScrollDividerFooter = function() {
    this.adapter.isScrollableContentAtBottom() ? this.adapter.hasClass(d.SCROLL_DIVIDER_FOOTER) && this.adapter.removeClass(d.SCROLL_DIVIDER_FOOTER) : this.adapter.addClass(d.SCROLL_DIVIDER_FOOTER);
  }, MDCDialogFoundation;
}(o), C = f.strings, m = /** @class */ function(e) {
  function MDCDialog() {
    return null !== e && e.apply(this, arguments) || this;
  }
  return t(MDCDialog, e), Object.defineProperty(MDCDialog.prototype, "isOpen", {
    get: function() {
      return this.foundation.isOpen();
    },
    enumerable: !1,
    configurable: !0
  }), Object.defineProperty(MDCDialog.prototype, "escapeKeyAction", {
    get: function() {
      return this.foundation.getEscapeKeyAction();
    },
    set: function(t) {
      this.foundation.setEscapeKeyAction(t);
    },
    enumerable: !1,
    configurable: !0
  }), Object.defineProperty(MDCDialog.prototype, "scrimClickAction", {
    get: function() {
      return this.foundation.getScrimClickAction();
    },
    set: function(t) {
      this.foundation.setScrimClickAction(t);
    },
    enumerable: !1,
    configurable: !0
  }), Object.defineProperty(MDCDialog.prototype, "autoStackButtons", {
    get: function() {
      return this.foundation.getAutoStackButtons();
    },
    set: function(t) {
      this.foundation.setAutoStackButtons(t);
    },
    enumerable: !1,
    configurable: !0
  }), MDCDialog.attachTo = function(t) {
    return new MDCDialog(t);
  }, MDCDialog.prototype.initialize = function(t) {
    var e, o;
    void 0 === t && (t = function(t, e) {
      return new c(t, e);
    });
    var i = this.root.querySelector(C.CONTAINER_SELECTOR);
    if (!i) throw new Error("Dialog component requires a " + C.CONTAINER_SELECTOR + " container element");
    this.container = i, this.content = this.root.querySelector(C.CONTENT_SELECTOR), 
    this.buttons = [].slice.call(this.root.querySelectorAll(C.BUTTON_SELECTOR)), this.defaultButton = this.root.querySelector("[" + C.BUTTON_DEFAULT_ATTRIBUTE + "]"), 
    this.focusTrapFactory = t, this.buttonRipples = [];
    try {
      for (var a = n(this.buttons), r = a.next(); !r.done; r = a.next()) {
        var l = r.value;
        this.buttonRipples.push(new s(l));
      }
    } catch (t) {
      e = {
        error: t
      };
    } finally {
      try {
        r && !r.done && (o = a.return) && o.call(a);
      } finally {
        if (e) throw e.error;
      }
    }
  }, MDCDialog.prototype.initialSyncWithDOM = function() {
    var t, e, n, o = this;
    this.focusTrap = (t = this.container, e = this.focusTrapFactory, n = this.getInitialFocusEl() || void 0, 
    e(t, {
      initialFocusEl: n
    })), this.handleClick = this.foundation.handleClick.bind(this.foundation), this.handleKeydown = this.foundation.handleKeydown.bind(this.foundation), 
    this.handleDocumentKeydown = this.foundation.handleDocumentKeydown.bind(this.foundation), 
    // this.handleLayout = this.layout.bind(this);
    this.handleOpening = function() {
      document.addEventListener("keydown", o.handleDocumentKeydown);
    }, this.handleClosing = function() {
      document.removeEventListener("keydown", o.handleDocumentKeydown);
    }, this.listen("click", this.handleClick), this.listen("keydown", this.handleKeydown), 
    this.listen(C.OPENING_EVENT, this.handleOpening), this.listen(C.CLOSING_EVENT, this.handleClosing);
  }, MDCDialog.prototype.destroy = function() {
    this.unlisten("click", this.handleClick), this.unlisten("keydown", this.handleKeydown), 
    this.unlisten(C.OPENING_EVENT, this.handleOpening), this.unlisten(C.CLOSING_EVENT, this.handleClosing), 
    this.handleClosing(), this.buttonRipples.forEach((function(t) {
      t.destroy();
    })), e.prototype.destroy.call(this);
  }, MDCDialog.prototype.layout = function() {
    this.foundation.layout();
  }, MDCDialog.prototype.open = function() {
    this.foundation.open();
  }, MDCDialog.prototype.close = function(t) {
    void 0 === t && (t = ""), this.foundation.close(t);
  }, MDCDialog.prototype.getDefaultFoundation = function() {
    var t = this;
    // DO NOT INLINE this variable. For backward compatibility, foundations take a Partial<MDCFooAdapter>.
    // To ensure we don't accidentally omit any methods, we need a separate, strongly typed adapter variable.
        return new f({
      addBodyClass: function(t) {
        return document.body.classList.add(t);
      },
      addClass: function(e) {
        return t.root.classList.add(e);
      },
      areButtonsStacked: function() {
        return e = t.buttons, n = new Set, [].forEach.call(e, (function(t) {
          return n.add(t.offsetTop);
        })), n.size > 1;
        var e, n;
      },
      clickDefaultButton: function() {
        t.defaultButton && !t.defaultButton.disabled && t.defaultButton.click();
      },
      eventTargetMatches: function(t, e) {
        return !!t && a(t, e);
      },
      getActionFromEvent: function(t) {
        if (!t.target) return "";
        var e = r(t.target, "[" + C.ACTION_ATTRIBUTE + "]");
        return e && e.getAttribute(C.ACTION_ATTRIBUTE);
      },
      getInitialFocusEl: function() {
        return t.getInitialFocusEl();
      },
      hasClass: function(e) {
        return t.root.classList.contains(e);
      },
      isContentScrollable: function() {
        return !!(e = t.content) && e.scrollHeight > e.offsetHeight;
        var e;
        /**
 * For scrollable content, returns true if the content has not been scrolled
 * (that is, the scroll content is as the "top"). This is used in full-screen
 * dialogs, where the scroll divider is expected only to appear once the
 * content has been scrolled "underneath" the header bar.
 */      },
      notifyClosed: function(e) {
        return t.emit(C.CLOSED_EVENT, e ? {
          action: e
        } : {});
      },
      notifyClosing: function(e) {
        return t.emit(C.CLOSING_EVENT, e ? {
          action: e
        } : {});
      },
      notifyOpened: function() {
        return t.emit(C.OPENED_EVENT, {});
      },
      notifyOpening: function() {
        return t.emit(C.OPENING_EVENT, {});
      },
      releaseFocus: function() {
        t.focusTrap.releaseFocus();
      },
      removeBodyClass: function(t) {
        return document.body.classList.remove(t);
      },
      removeClass: function(e) {
        return t.root.classList.remove(e);
      },
      reverseButtons: function() {
        t.buttons.reverse(), t.buttons.forEach((function(t) {
          t.parentElement.appendChild(t);
        }));
      },
      trapFocus: function() {
        t.focusTrap.trapFocus();
      },
      registerContentEventHandler: function(e, n) {
        t.content instanceof HTMLElement && t.content.addEventListener(e, n);
      },
      deregisterContentEventHandler: function(e, n) {
        t.content instanceof HTMLElement && t.content.removeEventListener(e, n);
      },
      isScrollableContentAtTop: function() {
        return !!(e = t.content) && 0 === e.scrollTop;
        var e;
        /**
 * For scrollable content, returns true if the content has been scrolled all the
 * way to the bottom. This is used in full-screen dialogs, where the footer
 * scroll divider is expected only to appear when the content is "cut-off" by
 * the footer bar.
 */      },
      isScrollableContentAtBottom: function() {
        return !!(e = t.content) && Math.ceil(e.scrollHeight - e.scrollTop) === e.clientHeight;
        var e;
      },
      registerWindowEventHandler: function(t, e) {
        window.addEventListener(t, e);
      },
      deregisterWindowEventHandler: function(t, e) {
        window.removeEventListener(t, e);
      }
    });
  }, MDCDialog.prototype.getInitialFocusEl = function() {
    return this.root.querySelector("[" + C.INITIAL_FOCUS_ATTRIBUTE + "]");
  }, MDCDialog;
}(i);

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */ export { m as M }

