/* Copyright (C) 2023. Robert Bosch GmbH Copyright (C) 2023. Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved. */
import { Component, h, Host, Prop, State } from '@stencil/core';
export class BciTreelistItem {
  constructor() {
    this.show = false;
  }
  render() {
    if (this.item) {
      return (h(Host, null,
        h("div", { class: "tree-item" },
          h("span", { class: "item-container", onClick: () => (this.show = !this.show), "data-test": "webcore.webcomponents.bci-treelist-item.show.span" },
            h("span", { class: "expand-icon" }, this.item.children && (h("button", { "data-test": "webcore.webcomponents.bci-treelist-item.expand-icon1", class: 'bci-treelist-item-icon bosch-ic bosch-ic-forward-right' + (!this.show ? '' : ' rotated') }))),
            h("span", { class: "title" },
              this.item.iconName && h("span", { class: `bci-treelist-item-icon-category bosch-ic ${this.item.iconName}` }),
              this.item.title),
            this.item.action && (h("span", { class: "actions" },
              h("span", null,
                h("button", { class: 'bci-treelist-item-icon-category bosch-ic bosch-ic-' + String(this.item.action) }))))),
          h("span", null, this.show && this.item.children && this.item.children.map((child) => h("bci-treelist-item", { item: child }))))));
    }
    else {
      return (h(Host, null,
        h("div", { class: "tree-item" },
          h("span", { class: "item-container", onClick: () => (this.show = !this.show), "data-test": "webcore.webcomponents.bci-treelist-item.show.span" },
            h("span", { class: "expand-icon" }, this.hasChildren && (h("span", null,
              h("button", { "data-test": "webcore.webcomponents.bci-treelist-item.expand-icon2", class: 'bci-treelist-item-icon bosch-ic bosch-ic-forward-right' + (!this.show ? '' : ' rotated') })))),
            h("span", { class: "title" },
              this.itemIconName && h("span", { class: `bci-treelist-item-icon-category bosch-ic ${this.itemIconName}` }),
              this.itemTitle)),
          h("span", null, this.hasChildren && this.show ? (h("span", null,
            h("slot", null))) : (h("template", null,
            h("slot", null)))))));
    }
  }
  static get is() { return "bci-treelist-item"; }
  static get encapsulation() { return "shadow"; }
  static get originalStyleUrls() { return {
    "$": ["bci-treelist-item.scss"]
  }; }
  static get styleUrls() { return {
    "$": ["bci-treelist-item.css"]
  }; }
  static get properties() { return {
    "item": {
      "type": "unknown",
      "mutable": false,
      "complexType": {
        "original": "TreelistItem",
        "resolved": "TreelistItem",
        "references": {
          "TreelistItem": {
            "location": "import",
            "path": "../treelist-Item.interface"
          }
        }
      },
      "required": false,
      "optional": false,
      "docs": {
        "tags": [],
        "text": ""
      }
    },
    "itemTitle": {
      "type": "string",
      "mutable": false,
      "complexType": {
        "original": "string",
        "resolved": "string",
        "references": {}
      },
      "required": false,
      "optional": false,
      "docs": {
        "tags": [],
        "text": ""
      },
      "attribute": "item-title",
      "reflect": false
    },
    "hasChildren": {
      "type": "boolean",
      "mutable": false,
      "complexType": {
        "original": "boolean",
        "resolved": "boolean",
        "references": {}
      },
      "required": false,
      "optional": false,
      "docs": {
        "tags": [],
        "text": ""
      },
      "attribute": "has-children",
      "reflect": false
    },
    "itemIconName": {
      "type": "string",
      "mutable": false,
      "complexType": {
        "original": "string",
        "resolved": "string",
        "references": {}
      },
      "required": false,
      "optional": false,
      "docs": {
        "tags": [],
        "text": ""
      },
      "attribute": "item-icon-name",
      "reflect": false
    }
  }; }
  static get states() { return {
    "show": {}
  }; }
}

