/* Copyright (C) 2023. Robert Bosch GmbH Copyright (C) 2023. Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved. */
import { Component, h, Host, Prop, State, Watch } from '@stencil/core';
export class CardIcon {
  constructor() {
    /** Icon to be displayed inside the tile icon element. By default Bosch-Ic-delete.s */
    this.icon = 'Bosch-Ic-delete';
    this.iconState = '';
  }
  watchTypeHandler(newValue) {
    this.iconState = newValue;
  }
  componentWillLoad() {
    this.iconState = this.icon;
  }
  render() {
    return (h(Host, null,
      h("span", { class: `bosch-ic ${this.iconState}` })));
  }
  static get is() { return "bci-card-icon"; }
  static get encapsulation() { return "shadow"; }
  static get originalStyleUrls() { return {
    "$": ["card-icon.scss"]
  }; }
  static get styleUrls() { return {
    "$": ["card-icon.css"]
  }; }
  static get properties() { return {
    "icon": {
      "type": "string",
      "mutable": false,
      "complexType": {
        "original": "string",
        "resolved": "string",
        "references": {}
      },
      "required": false,
      "optional": false,
      "docs": {
        "tags": [],
        "text": "Icon to be displayed inside the tile icon element. By default Bosch-Ic-delete.s"
      },
      "attribute": "icon",
      "reflect": false,
      "defaultValue": "'Bosch-Ic-delete'"
    }
  }; }
  static get states() { return {
    "iconState": {}
  }; }
  static get watchers() { return [{
      "propName": "icon",
      "methodName": "watchTypeHandler"
    }]; }
}

