/* Copyright (C) 2023. Robert Bosch GmbH Copyright (C) 2023. Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved. */
import { Component, h, Host, Prop, State, Watch } from '@stencil/core';
export class Card {
  constructor() {
    /** Color used for the tile header. Options are grey, green, blue, yellow, orange and red.  By default grey. */
    this.headerColor = 'grey';
    this.color = '';
  }
  watchHeaderColorHandler(newValue) {
    this.color = newValue;
  }
  componentWillLoad() {
    this.color = this.headerColor;
  }
  render() {
    return (h(Host, null,
      h("div", { class: `bci-tile tile-border-${this.color}` },
        h("slot", { name: "title" }),
        h("div", { class: "tile-slotted-content" },
          h("slot", null)))));
  }
  static get is() { return "bci-card"; }
  static get encapsulation() { return "shadow"; }
  static get originalStyleUrls() { return {
    "$": ["card.scss"]
  }; }
  static get styleUrls() { return {
    "$": ["card.css"]
  }; }
  static get properties() { return {
    "headerColor": {
      "type": "string",
      "mutable": false,
      "complexType": {
        "original": "string",
        "resolved": "string",
        "references": {}
      },
      "required": false,
      "optional": false,
      "docs": {
        "tags": [],
        "text": "Color used for the tile header. Options are grey, green, blue, yellow, orange and red.  By default grey."
      },
      "attribute": "header-color",
      "reflect": false,
      "defaultValue": "'grey'"
    }
  }; }
  static get states() { return {
    "color": {}
  }; }
  static get watchers() { return [{
      "propName": "headerColor",
      "methodName": "watchHeaderColorHandler"
    }]; }
}

