/* Copyright (C) 2023. Robert Bosch GmbH Copyright (C) 2023. Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved. */
/*
 * Copyright (C) 2019 Robert Bosch GmbH Copyright (C) 2019 Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved.
 */
import { Component, Element, h, State } from '@stencil/core';
export class ExpandToggleComponent {
  constructor() {
    this.expanded = false;
  }
  toggle() {
    this.expanded = !this.expanded;
    this.el.shadowRoot.host.parentElement.parentElement.setAttribute('expanded', String(this.expanded));
  }
  render() {
    return (h("button", { class: "mdc-icon-button", "data-test": "webcore.webcomponents.expand-toogle.toggle.button" },
      h("i", { "data-test": "webcore.webcomponents.expand-toggle.toggle-icon", class: "material-icons bosch-ic bosch-ic-down", onClick: () => this.toggle() })));
  }
  static get is() { return "bci-portal-expand-toggle"; }
  static get encapsulation() { return "shadow"; }
  static get originalStyleUrls() { return {
    "$": ["expand-toggle.component.scss"]
  }; }
  static get styleUrls() { return {
    "$": ["expand-toggle.component.css"]
  }; }
  static get states() { return {
    "expanded": {}
  }; }
  static get elementRef() { return "el"; }
}

