/* Copyright (C) 2023. Robert Bosch GmbH Copyright (C) 2023. Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved. */
/*
 * Copyright (C) 2021 Robert Bosch GmbH Copyright (C) 2021 Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved.
 */
import { tap } from '../../../../../../utils/utils';
export class LoadingHandlerService {
  constructor(dataSource, onLoadingChange) {
    this.dataSource = dataSource;
    this.onLoadingChange = onLoadingChange;
    this._isLoading = false;
  }
  get isLoading() {
    return this._isLoading;
  }
  async getChildren(nodeId) {
    return this.wrapper(() => this.dataSource.getChildren(nodeId));
  }
  async getRoots() {
    return this.wrapper(this.dataSource.getRoots);
  }
  setIsLoading(value) {
    this._isLoading = value;
    this.notify();
  }
  async wrapper(func) {
    this.setIsLoading(true);
    return func().finally(tap(() => this.setIsLoading(false)));
  }
  notify() {
    this.onLoadingChange(this.isLoading);
  }
}

