/* Copyright (C) 2023. Robert Bosch GmbH Copyright (C) 2023. Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved. */
/*
 * Copyright (C) 2019 Robert Bosch GmbH Copyright (C) 2019 Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved.
 */
import { Component, h, State, Listen } from '@stencil/core';
import { translate } from '../../utils/utils';
import { setLocale } from '../../utils/locale-store';
export class PageInfoComponent {
  onErrorOccurred(event) {
    this.event = event;
  }
  onErrorResolved() {
    this.event = null;
  }
  async componentWillLoad() {
    await setLocale();
  }
  render() {
    return (h("div", { class: 'bci-portal-page-info ' + (!this.event ? 'bci-portal-page-info-hidden' : '') },
      h("div", { class: "bci-portal-page-info-icon" },
        h("span", { class: "bosch-ic bosch-ic-problem-frame" })),
      h("div", { class: "bci-protal-page-info-text" },
        h("p", null, this.event != null ? translate(this.event.detail.title) : ''),
        this.event != null ? translate(this.event.detail.description) : '')));
  }
  static get is() { return "bci-portal-page-info"; }
  static get encapsulation() { return "shadow"; }
  static get originalStyleUrls() { return {
    "$": ["page-info.component.scss"]
  }; }
  static get styleUrls() { return {
    "$": ["page-info.component.css"]
  }; }
  static get states() { return {
    "event": {}
  }; }
  static get listeners() { return [{
      "name": "bci.portal.page-info.created",
      "method": "onErrorOccurred",
      "target": "window",
      "capture": false,
      "passive": false
    }, {
      "name": "bci.portal.page-info.resolved",
      "method": "onErrorResolved",
      "target": "window",
      "capture": false,
      "passive": false
    }]; }
}

