/* Copyright (C) 2023. Robert Bosch GmbH Copyright (C) 2023. Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved. */
import { Component, Event, h, Host } from '@stencil/core';
export class Toolbar {
  clicked(event) {
    const toolbarItem = this.getToolbarItem(event);
    if (toolbarItem && toolbarItem.dataset.value) {
      this.itemClick.emit(toolbarItem.dataset.value);
    }
  }
  getToolbarItem(target) {
    return target.composedPath().find((el) => el.nodeName && el.nodeName.toLowerCase() === 'bci-toolbar-item');
  }
  render() {
    return (h(Host, { "data-test": "webcore.webcomponents.toolbar.bci-toolbar-event", class: "toolbar", onClick: (event) => this.clicked(event) },
      h("slot", null)));
  }
  static get is() { return "bci-toolbar"; }
  static get encapsulation() { return "shadow"; }
  static get originalStyleUrls() { return {
    "$": ["toolbar.scss"]
  }; }
  static get styleUrls() { return {
    "$": ["toolbar.css"]
  }; }
  static get events() { return [{
      "method": "itemClick",
      "name": "itemClick",
      "bubbles": true,
      "cancelable": true,
      "composed": true,
      "docs": {
        "tags": [],
        "text": "Event emitted when any child is clicked of this container is clicked."
      },
      "complexType": {
        "original": "string",
        "resolved": "string",
        "references": {}
      }
    }]; }
}

