/* Copyright (C) 2023. Robert Bosch GmbH Copyright (C) 2023. Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved. */
/**
 * Copyright (C) 2021. Robert Bosch GmbH Copyright (C) 2021. Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved.
 */
import { FacilitySelectionContoller } from './facility-selection.controller';
export class FacilitySelectionState {
  constructor(facilitySelectorController) {
    this.facilitySelectorController = facilitySelectorController;
    this._columns = [];
  }
  get columnCache() {
    return this._columns;
  }
  get selectionStateCache() {
    return this._selectionState;
  }
  setDefaultState(checkedItems) {
    if (!checkedItems || !Array.isArray(checkedItems)) {
      return;
    }
    this.facilitySelectorController.checkAll(checkedItems);
    this.facilitySelectorController.loadColumnsBasedOn(checkedItems).then(() => {
      this.setStateCache();
    });
  }
  updateDefaultState() {
    this.setStateCache();
  }
  setStateCache() {
    this.setColumnCache([...(this.facilitySelectorController.getColumns() || [])]);
    this.setSelectionStateCache(this.facilitySelectorController.selectionState);
  }
  setColumnCache(columns) {
    this._columns = columns;
  }
  setSelectionStateCache(selectionState) {
    this._selectionState = new FacilitySelectionContoller(selectionState.selectedItemPerLevel, selectionState.checkedItemPerLevel, selectionState.selectedItems, selectionState.checkedItems, selectionState.indeterminateItems, selectionState.isMultiSelectEnabled);
  }
}

