/* Copyright (C) 2023. Robert Bosch GmbH Copyright (C) 2023. Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved. */
/*
 * Copyright (C) 2019 Robert Bosch GmbH Copyright (C) 2019 Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved.
 */
import { de, enUS, es, fr, it, pl, pt, tr, zhCN } from 'date-fns/locale';
export const DEFAULT_LOCALE = {
  language: 'en',
  dateFormat: 'MM/dd/y',
  timeFormat: 'H:mm a',
};
export const LOCALE_MAP = {
  de: de,
  en: enUS,
  fr: fr,
  tr: tr,
  it: it,
  pl: pl,
  pt: pt,
  es: es,
  zh: zhCN,
};
export const localization = {
  showFooter: {
    en: 'Expand',
    de: 'Ausklappen',
    es: 'Ampliar',
    it: 'Espandi',
  },
  hideFooter: {
    en: 'Collapse',
    de: 'Einklappen',
    es: 'Colapso',
    it: 'Crollo',
  },
  messages: {
    en: 'Messages',
    de: 'Meldungen',
    es: 'Mensajes',
    it: 'Messaggi',
  },
  messageFilters: {
    en: 'Filter and Sort',
    de: 'Filtern und Sortieren',
    es: 'Filtrar y clasificar',
    it: 'Filtra e Ordina',
  },
  emptyMessageSearchResult: {
    en: 'There are no results for the selected filter criteria.',
    de: 'Für die gewählten Filterkriterien liegen keine Ergebnisse vor.',
    es: 'No hay resultados para los criterios de filtro seleccionados.',
    it: 'Non ci sono risultati per il criterio di filtro selezionato.',
  },
  emptyMessageSearchFacility: {
    en: 'There are no facilities for the given search string.',
    de: 'Es gibt keine Einrichtungen zu dieser Suche',
    it: 'Non ci sono risultati per questa stringa di ricerca.',
  },
  emptyMessageList: {
    en: 'There are no messages. Look here for new messages.',
    de: 'Es liegen keine Meldungen vor. Neue Meldungen sind hier zu finden.',
    es: 'No hay mensajes. Los nuevos mensajes se pueden encontrar aquí.',
    it: 'Non ci sono messaggi. Guarda qui per nuovi messaggi.',
  },
  seeAllMessages: {
    en: 'View all messages',
    de: 'Alle Meldungen anzeigen',
    es: 'Ver todos los mensajes',
    it: 'Visualizza tutti i messaggi',
  },
  today: {
    en: 'Today',
    de: 'Heute',
    es: 'Hoy',
    it: 'Oggi',
  },
  yesterday: {
    en: 'Yesterday',
    de: 'Gestern',
    es: 'Ayer',
    it: 'Ieri',
  },
  last: {
    en: 'Last',
    de: 'Letzter',
    es: 'Último',
    it: 'Ultimo',
  },
  search: {
    en: 'Search',
    de: 'Suche',
    es: 'Buscar',
    it: 'Cerca',
  },
  searchOrSelect: {
    en: 'Search or select',
    de: 'Suche or wähle aus',
    es: 'Buscar u seleccionar',
    it: 'Cerca o seleziona',
  },
  searchType: {
    en: 'Search type',
    de: 'Suchtyp',
    es: 'Tipo de búsqueda',
    it: 'Tipo di ricerca',
  },
  allTypes: {
    en: 'All message types',
    de: 'Alle Meldungstypen',
    es: 'Todos los tipos de mensajes',
    it: 'Tutti i tipi di messaggi',
  },
  information: {
    en: 'Information',
    de: 'Information',
    es: 'Información',
    it: 'Informazioni',
  },
  success: {
    en: 'Completed',
    de: 'Abgeschlossen',
    es: 'Completado',
    it: 'Completato',
  },
  warning: {
    en: 'Warning',
    de: 'Warnung',
    es: 'Advertencia',
    it: 'Avviso',
  },
  error: {
    en: 'Error',
    de: 'Fehler',
    es: 'Error',
    it: 'Errore',
  },
  descending: {
    en: 'Descending',
    de: 'Absteigend',
    es: 'Descendiendo',
    it: 'Discendente',
  },
  ascending: {
    en: 'Ascending',
    de: 'Aufsteigend',
    es: 'Ascendiendo',
    it: 'Ascendente',
  },
  messageTypes: {
    en: 'Message types',
    de: 'Meldungstypen',
    es: 'Tipos de mensajes',
    it: 'Tipi di messaggi',
  },
  showMoreDetails: {
    en: 'Show more',
    de: 'Mehr Details',
    es: 'Más detalles',
    it: 'Mostra di più',
  },
  discardAll: {
    en: 'Delete all',
    de: 'Alle löschen',
    es: 'Borrar todo',
    it: 'Elimina tutti',
  },
  entities: {
    en: 'Entries',
    de: 'Einträge',
    es: 'Entradas',
    it: 'Elementi',
  },
  title: {
    en: 'Title',
    de: 'Titel',
    es: 'Título',
    it: 'Titolo',
  },
  description: {
    en: 'Description',
    de: 'Beschreibung',
    es: 'Descripción',
    it: 'Descrizione',
  },
  dateTime: {
    en: 'Date/time',
    de: 'Datum/Zeit',
    es: 'Fecha/Hora',
    it: 'Data/Ora',
  },
  messageClass: {
    en: 'Category',
    de: 'Kategorie',
    es: 'Categoría',
    it: 'Categoria',
  },
  goTo: {
    en: 'Go to',
    de: 'Gehe zu',
    es: 'Ir a',
    it: 'Vai a',
  },
  close: {
    en: 'Close',
    de: 'Schließen',
    es: 'Cerrar',
    it: 'Chiudi',
  },
  documentation: {
    en: 'Documentation',
    de: 'Dokumentation',
    es: 'Documentación',
    it: 'Documenti',
  },
  didYouMean: {
    en: 'Suggestions',
    de: 'Vorschläge',
    es: 'Propuestas',
    it: 'Indicazioni',
  },
  mostRelevant: {
    en: 'Matching results',
    de: 'Passende Ergebnisse',
    es: 'Resultados coincidentes',
    it: 'Risultati',
  },
  dismiss: {
    en: 'Discard',
    de: 'Verwerfen',
    es: 'Descartar',
    it: 'Elimina',
  },
  setDate: {
    en: 'Set date',
    de: 'Datum festlegen',
    es: 'Fijar fecha',
    it: 'Imposta data',
  },
  setTime: {
    en: 'Set time',
    de: 'Zeit festlegen',
    es: 'Fijar hora',
    it: 'Imposta tempo',
  },
  range: {
    en: 'Time span',
    de: 'Zeitraum',
    es: 'Período',
    it: 'Periodo',
  },
  setDateTime: {
    en: 'Set date & time',
    de: 'Datum & Uhrzeit festlegen',
    es: 'Fijar la fecha y la hora',
    it: 'Imposta data e ora',
  },
  setRange: {
    en: 'Set time span',
    de: 'Zeitraum festlegen',
    es: 'Establece el período',
    it: 'Imposta periodo',
  },
  save: {
    en: 'Save',
    de: 'Speichern',
    es: 'Guardar',
    it: 'Salva',
  },
  templates: {
    en: 'Templates',
    de: 'Vorlagen',
    es: 'Plantillas',
    it: 'Tempi',
  },
  calendar: {
    en: 'Calendar',
    de: 'Kalendar',
    es: 'Calendario',
    it: 'Calendario',
  },
  time: {
    en: 'Time',
    de: 'Uhrzeit',
    es: 'aeg',
    it: 'Ora',
  },
  startTime: {
    en: 'Start Time',
    de: 'Startzeit',
    es: 'Start Time',
    it: 'Ora di inizio',
  },
  endTime: {
    en: 'End Time',
    de: 'Endzeit',
    es: 'End Time',
    it: 'Ora di fine',
  },
  listItemsPerPage: {
    en: 'Elements per page',
    de: 'Elemente pro Seite',
    es: 'Elementos por página',
    it: 'Elementi per pagina',
  },
  recentSearch: {
    en: 'Recent searches',
    de: 'Letzte Suchanfragen',
    es: 'Búsquedas recientes',
    it: 'Ricerche recenti',
  },
  back: {
    en: 'Back',
    de: 'Zurück',
    es: 'Atrás',
    it: 'Indietro',
  },
  'reset-selection': {
    en: 'Reset selection',
    de: 'Zurücksetzen',
    es: 'Resetear',
    it: 'Resetta selezione',
  },
  reset: {
    en: 'Reset',
    de: 'Zurücksetzen',
    es: 'Resetear',
    it: 'Resetta',
  },
  faclities: {
    en: 'Facilities',
    de: 'Einrichtungen',
    es: 'Equipos',
    it: 'Impianti',
  },
  selectSomething: {
    en: 'Select {{search-type-label}}',
    de: '{{search-type-label}} auswählen',
    es: 'Seleccione {search-type-label}}',
    it: 'Seleziona {{ricerca-tipo-label}}',
  },
  noFilterResults: {
    en: 'No items to display.',
    de: 'Keine Elemente zum Anzeigen.',
    es: 'No hay artículos para mostrar.',
    it: 'Nessun elemento da visualizzare.',
  },
};

