/* Copyright (C) 2023. Robert Bosch GmbH Copyright (C) 2023. Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved. */
/*
 * Copyright (C) 2020 Robert Bosch GmbH Copyright (C) 2020 Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved.
 */
import { FacilitySelectorController, RecentSearchController } from '../..';
export let recentSearchList = [
  {
    checkedItemsByLevel: [
      [],
      [],
      [],
      [
        {
          type: 'WorkCenter',
          id: 'cb3320b8-c163-4b8c-8ec7-095099072272',
          parentLocationId: 'c6e3be68-9d70-46f2-9fb6-605a623e8ac4',
          typeId: '37D6ED6F-1114-4DE9-AA2D-AB032F3D39F5',
          name: 'Site 3.1 Area1 Line1',
          hasChildren: false,
        },
      ],
    ],
  },
];
export let searchResults = {
  WorkCenter: [
    {
      type: 'WorkCenter',
      id: 'cb3320b8-c163-4b8c-8ec7-095099072272',
      parentLocationId: 'c6e3be68-9d70-46f2-9fb6-605a623e8ac4',
      typeId: '37D6ED6F-1114-4DE9-AA2D-AB032F3D39F5',
      name: 'Site 3.1 Area1 Line1',
      hasChildren: false,
    },
  ],
};
export const facilityTree = [
  {
    type: 'Enterprise',
    id: 'c9aa73a7-c387-4b78-a5e3-d527e1c3b80c',
    typeId: '04FD4088-2111-4829-B4A1-512811133D34',
    name: 'Generic Enterprise 3',
    hasChildren: true,
    children: [
      {
        type: 'Site',
        id: '05dcae81-adf5-422c-8749-a52837a11e31',
        parentLocationId: 'c9aa73a7-c387-4b78-a5e3-d527e1c3b80c',
        typeId: '212AB8E1-2112-4943-A323-2A8AE5BDDDCA',
        name: 'Generic Site 3.1',
        hasChildren: true,
        children: [
          {
            type: 'Area',
            id: 'c6e3be68-9d70-46f2-9fb6-605a623e8ac4',
            parentLocationId: '05dcae81-adf5-422c-8749-a52837a11e31',
            typeId: 'F2BFFBF3-1113-4F99-81BC-C782458AD8A2',
            name: 'Site 3.1 Area1',
            hasChildren: true,
            children: [
              {
                type: 'WorkCenter',
                id: 'c98f123b-c1d9-4b39-84b7-c841abc65be6',
                parentLocationId: 'c6e3be68-9d70-46f2-9fb6-605a623e8ac4',
                typeId: '37D6ED6F-1114-4DE9-AA2D-AB032F3D39F5',
                name: 'Site 3.1 Area1 Line2',
                hasChildren: false,
              },
              {
                type: 'WorkCenter',
                id: 'cb3320b8-c163-4b8c-8ec7-095099072272',
                parentLocationId: 'c6e3be68-9d70-46f2-9fb6-605a623e8ac4',
                typeId: '37D6ED6F-1114-4DE9-AA2D-AB032F3D39F5',
                name: 'Site 3.1 Area1 Line1',
                hasChildren: false,
              },
            ],
          },
          {
            type: 'Area',
            id: 'cba57464-232b-405b-a87e-bc9052bec454',
            parentLocationId: '05dcae81-adf5-422c-8749-a52837a11e31',
            typeId: 'F2BFFBF3-1113-4F99-81BC-C782458AD8A2',
            name: 'Site 3.1 Area2',
            hasChildren: false,
          },
        ],
      },
      {
        type: 'Site',
        id: 'b07de796-57f8-40d9-b946-17665ff3923d',
        parentLocationId: 'c9aa73a7-c387-4b78-a5e3-d527e1c3b80c',
        typeId: '212AB8E1-2112-4943-A323-2A8AE5BDDDCA',
        name: 'Generic Site 3.2',
        hasChildren: false,
      },
    ],
  },
  {
    type: 'Enterprise',
    id: 'd54fcfbd-4eb5-427b-a00b-8d0955e2e6f9',
    typeId: '04FD4088-2111-4829-B4A1-512811133D34',
    name: 'Generic Enterprise 2',
    hasChildren: false,
  },
  {
    type: 'Enterprise',
    id: 'f14bfe88-ecdc-4034-a8ef-468302f2c03c',
    typeId: '04FD4088-2111-4829-B4A1-512811133D34',
    name: 'Generic Enterprise 1',
    hasChildren: false,
  },
];
const getRoot = () => {
  return Promise.resolve(facilityTree);
};
const getChildren = (facility, data = facilityTree) => {
  if (!facility) {
    return Promise.resolve([]);
  }
  const tempData = [];
  for (let i = 0; i < data.length; i++) {
    if (data[i].id === facility.id) {
      return Promise.resolve(data[i].children || []);
    }
    else {
      tempData.push(...(data[i].children || []));
    }
  }
  return getChildren(facility, tempData);
};
const getParent = (facility, data = facilityTree) => {
  // breadth-first search for parent in facilityTree
  if (!facility || data.length == 0) {
    return Promise.resolve(null);
  }
  const tempData = [];
  for (let i = 0; i < data.length; i++) {
    if (data[i].id === facility.parentLocationId) {
      return Promise.resolve(data[i] || null);
    }
    else {
      tempData.push(...(data[i].children || []));
    }
  }
  return getParent(facility, tempData);
};
// @ts-ignore
const getSearchResults = (searchQuery, data = searchQuery.searchRoot ? searchQuery.searchRoot.children : facilityTree, searchResults = {}) => {
  if (!searchQuery) {
    return Promise.resolve(null);
  }
  for (let i = 0; i < data.length; i++) {
    if (data[i].name.toLowerCase().includes(searchQuery.searchString.toLowerCase())) {
      if (!searchResults[data[i].type]) {
        searchResults[data[i].type] = [];
        searchResults[data[i].type].push(data[i]);
      }
      else {
        searchResults[data[i].type].push(data[i]);
      }
    }
    if (data[i].hasChildren) {
      return getSearchResults(searchQuery, data[i].children, searchResults);
    }
  }
  return Promise.resolve(searchResults);
};
const getRecentSearches = () => {
  return Promise.resolve(recentSearchList);
};
const saveRecentSearches = (recentSearches) => {
  recentSearchList = [...recentSearches];
  return Promise.resolve(true);
};
export function getFacilityControllerInstance() {
  return new FacilitySelectorController(getRoot, getChildren, getParent, getSearchResults);
}
export function getRecentSearchControllerInstance() {
  return new RecentSearchController(getRecentSearches, saveRecentSearches);
}

