/* Copyright (C) 2023. Robert Bosch GmbH Copyright (C) 2023. Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved. */
import { p as proxyCustomElement, H, c as createEvent, h, b as Host } from './p-6fc5b736.js';
import { d as setLocale } from './p-d4c86b19.js';
import { O as OverlayHandler } from './p-25e1a37f.js';
import { e as tap, g as getLogger, t as translate } from './p-9dead869.js';
import { W as WidthObserver } from './p-9d5ad484.js';
import { c as createCommonjsModule } from './p-3e8ff66b.js';
import { d as defineCustomElement$c } from './p-184dda00.js';
import { d as defineCustomElement$b } from './p-5edba148.js';
import { d as defineCustomElement$a } from './p-c405d0fe.js';
import { d as defineCustomElement$9 } from './p-23c43ed6.js';
import { d as defineCustomElement$8 } from './p-96f3a770.js';
import { d as defineCustomElement$7 } from './p-35ec6403.js';
import { d as defineCustomElement$6 } from './p-1c466661.js';
import { d as defineCustomElement$5 } from './p-09640a8e.js';
import { d as defineCustomElement$4 } from './p-2f28739c.js';
import { d as defineCustomElement$3 } from './p-ccea786d.js';
import { d as defineCustomElement$2 } from './p-43c2dbdf.js';

var Key_enum = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", { value: true });
(function (Key) {
    /**
     * The user agent wasn't able to map the event's virtual keycode to a
     * specific key value.
     * This can happen due to hardware or software constraints, or because of
     * constraints around the platform on which the user agent is running.
     */
    Key["Unidentified"] = "Unidentified";
    /** The Alt (Alternative) key. */
    Key["Alt"] = "Alt";
    /**
     * The AltGr or AltGraph (Alternate Graphics) key.
     * Enables the ISO Level 3 shift modifier (where Shift is the
     * level 2 modifier).
     */
    Key["AltGraph"] = "AltGraph";
    /**
     * The Caps Lock key. Toggles the capital character lock on and
     * off for subsequent input.
     */
    Key["CapsLock"] = "CapsLock";
    /**
     * The Control, Ctrl, or Ctl key. Allows
     * typing control characters.
     */
    Key["Control"] = "Control";
    /**
     * The Fn (Function modifier) key. Used to allow generating
     * function key (F1–F15, for instance) characters on
     * keyboards without a dedicated function key area. Often handled in
     * hardware so that events aren't generated for this key.
     */
    Key["Fn"] = "Fn";
    /**
     * The FnLock or F-Lock (Function Lock) key.Toggles
     * the function key mode described by "Fn" on and off. Often
     * handled in hardware so that events aren't generated for this key.
     */
    Key["FnLock"] = "FnLock";
    /** The Hyper key. */
    Key["Hyper"] = "Hyper";
    /**
     * The Meta key. Allows issuing special command inputs. This is
     * the Windows logo key, or the Command or
     * ⌘ key on Mac keyboards.
     */
    Key["Meta"] = "Meta";
    /**
     * The NumLock (Number Lock) key. Toggles the numeric keypad
     * between number entry some other mode (often directional arrows).
     */
    Key["NumLock"] = "NumLock";
    /**
     * The Scroll Lock key. Toggles between scrolling and cursor
     * movement modes.
     */
    Key["ScrollLock"] = "ScrollLock";
    /**
     * The Shift key. Modifies keystrokes to allow typing upper (or
     * other) case letters, and to support typing punctuation and other special
     * characters.
     */
    Key["Shift"] = "Shift";
    /** The Super key. */
    Key["Super"] = "Super";
    /** The Symbol modifier key (found on certain virtual keyboards). */
    Key["Symbol"] = "Symbol";
    /** The Symbol Lock key. */
    Key["SymbolLock"] = "SymbolLock";
    /**
     * The Enter or ↵ key (sometimes labeled
     * Return).
     */
    Key["Enter"] = "Enter";
    /** The Horizontal Tab key, Tab. */
    Key["Tab"] = "Tab";
    /** The down arrow key. */
    Key["ArrowDown"] = "ArrowDown";
    /** The left arrow key. */
    Key["ArrowLeft"] = "ArrowLeft";
    /** The right arrow key. */
    Key["ArrowRight"] = "ArrowRight";
    /** The up arrow key. */
    Key["ArrowUp"] = "ArrowUp";
    /** The End key. Moves to the end of content. */
    Key["End"] = "End";
    /** The Home key. Moves to the start of content. */
    Key["Home"] = "Home";
    /**
     * The Page Down (or PgDn) key. Scrolls down or
     * displays the next page of content.
     */
    Key["PageDown"] = "PageDown";
    /**
     * The Page Up (or PgUp) key. Scrolls up or displays
     * the previous page of content.
     */
    Key["PageUp"] = "PageUp";
    /**
     * The Backspace key. This key is labeled Delete on
     * Mac keyboards.
     */
    Key["Backspace"] = "Backspace";
    /** The Clear key. Removes the currently selected input. */
    Key["Clear"] = "Clear";
    /** The Copy key (on certain extended keyboards). */
    Key["Copy"] = "Copy";
    /** The Cursor Select key, CrSel. */
    Key["CrSel"] = "CrSel";
    /** The Cut key (on certain extended keyboards). */
    Key["Cut"] = "Cut";
    /** The Delete key, Del. */
    Key["Delete"] = "Delete";
    /**
     * Erase to End of Field. Deletes all characters from the current cursor
     * position to the end of the current field.
     */
    Key["EraseEof"] = "EraseEof";
    /** The ExSel (Extend Selection) key. */
    Key["ExSel"] = "ExSel";
    /**
     * The Insert key, Ins. Toggles between inserting and
     * overwriting text.
     */
    Key["Insert"] = "Insert";
    /** Paste from the clipboard. */
    Key["Paste"] = "Paste";
    /** Redo the last action. */
    Key["Redo"] = "Redo";
    /** Undo the last action. */
    Key["Undo"] = "Undo";
    /**
     * The Accept, Commit, or OK key or
     * button. Accepts the currently selected option or input method sequence
     * conversion.
     */
    Key["Accept"] = "Accept";
    /** The Again key. Redoes or repeats a previous action. */
    Key["Again"] = "Again";
    /** The Attn (Attention) key. */
    Key["Attn"] = "Attn";
    /** The Cancel key. */
    Key["Cancel"] = "Cancel";
    /**
     * Shows the context menu. Typically found between the
     * Windows (or OS) key and the Control key
     * on the right side of the keyboard.
     */
    Key["ContextMenu"] = "ContextMenu";
    /**
     * The Esc (Escape) key. Typically used as an exit, cancel, or
     * "escape this operation" button. Historically, the Escape character was
     * used to signal the start of a special control sequence of characters
     * called an "escape sequence."
     */
    Key["Escape"] = "Escape";
    /** The Execute key. */
    Key["Execute"] = "Execute";
    /**
     * The Find key. Opens an interface (typically a dialog box) for
     * performing a find/search operation.
     */
    Key["Find"] = "Find";
    /** The Finish key. */
    Key["Finish"] = "Finish";
    /**
     * The Help key. Opens or toggles the display of help
     * information.
     */
    Key["Help"] = "Help";
    /**
     * The Pause key. Pauses the current application or state, if
     * applicable.
     * Note: This shouldn't be confused with the
     * "MediaPause" key value, which is used for media
     * controllers, rather than to control applications and processes.
     */
    Key["Pause"] = "Pause";
    /**
     * The Play key. Resumes a previously paused application, if
     * applicable.
     * Note: This shouldn't be confused with the
     * "MediaPlay" key value, which is used for media
     * controllers, rather than to control applications and processes.
     */
    Key["Play"] = "Play";
    /** The Props (Properties) key. */
    Key["Props"] = "Props";
    /** The Select key. */
    Key["Select"] = "Select";
    /** The ZoomIn key. */
    Key["ZoomIn"] = "ZoomIn";
    /** The ZoomOut key. */
    Key["ZoomOut"] = "ZoomOut";
    /**
     * The Brightness Down key. Typically used to reduce the brightness of the
     * display.
     */
    Key["BrightnessDown"] = "BrightnessDown";
    /**
     * The Brightness Up key. Typically increases the brightness of the
     * display.
     */
    Key["BrightnessUp"] = "BrightnessUp";
    /**
     * The Eject key. Ejects removable media (or toggles an optical
     * storage device tray open and closed).
     */
    Key["Eject"] = "Eject";
    /** The LogOff key. */
    Key["LogOff"] = "LogOff";
    /**
     * The Power button or key, to toggle power on and off.
     * Note: Not all systems pass this key through to the
     * user agent.
     */
    Key["Power"] = "Power";
    /**
     * The PowerOff or PowerDown key. Shuts off the
     * system.
     */
    Key["PowerOff"] = "PowerOff";
    /**
     * The PrintScreen or PrtScr key. Sometimes
     * SnapShot. Captures the screen and prints it or saves it to
     * disk.
     */
    Key["PrintScreen"] = "PrintScreen";
    /**
     * The Hibernate key. This saves the state of the computer to
     * disk and then shuts down; the computer can be returned to its previous
     * state by restoring the saved state information.
     */
    Key["Hibernate"] = "Hibernate";
    /**
     * The Standby key. (Also known as Suspend or
     * Sleep.) This turns off the display and puts the computer in a
     * low power consumption mode, without completely powering off.
     */
    Key["Standby"] = "Standby";
    /**
     * The WakeUp key. Used to wake the computer from the
     * hibernation or standby modes.
     */
    Key["WakeUp"] = "WakeUp";
    /**
     * The All Candidates key, which starts multi-candidate mode, in
     * which multiple candidates are displayed for the ongoing input.
     */
    Key["AllCandidates"] = "AllCandidates";
    /** The Alphanumeric key. */
    Key["Alphanumeric"] = "Alphanumeric";
    /**
     * The Code Input key, which enables code input mode, which lets
     * the user enter characters by typing their code points (their Unicode
     * character numbers, typically).
     */
    Key["CodeInput"] = "CodeInput";
    /** The Compose key. */
    Key["Compose"] = "Compose";
    /**
     * The Convert key, which instructs the IME to convert the
     * current input method sequence into the resulting character.
     */
    Key["Convert"] = "Convert";
    /**
     * A dead "combining" key; that is, a key which is used in tandem with
     * other keys to generate accented and other modified characters. If
     * pressed by itself, it doesn't generate a character.
     * If you wish to identify which specific dead key was pressed (in cases
     * where more than one exists), you can do so by examining the
     * KeyboardEvent's associated
     * compositionupdate event's
     * data property.
     */
    Key["Dead"] = "Dead";
    /**
     * The Final (Final Mode) key is used on some Asian keyboards to
     * enter final mode when using IMEs.
     */
    Key["FinalMode"] = "FinalMode";
    /**
     * Switches to the first character group on an
     * ISO/IEC 9995 keyboard. Each key may have multiple groups of characters, each in its own
     * column. Pressing this key instructs the device to interpret keypresses
     * as coming from the first column on subsequent keystrokes.
     */
    Key["GroupFirst"] = "GroupFirst";
    /**
     * Switches to the last character group on an
     * ISO/IEC 9995 keyboard.
     */
    Key["GroupLast"] = "GroupLast";
    /**
     * Switches to the next character group on an
     * ISO/IEC 9995 keyboard.
     */
    Key["GroupNext"] = "GroupNext";
    /**
     * Switches to the previous character group on an
     * ISO/IEC 9995 keyboard.
     */
    Key["GroupPrevious"] = "GroupPrevious";
    /** The Mode Change key. Toggles or cycles among input modes of IMEs. */
    Key["ModeChange"] = "ModeChange";
    /**
     * The Next Candidate function key. Selects the next possible match for the
     * ongoing input.
     */
    Key["NextCandidate"] = "NextCandidate";
    /**
     * The NonConvert ("Don't convert") key. This accepts the
     * current input method sequence without running conversion when using an
     * IME.
     */
    Key["NonConvert"] = "NonConvert";
    /**
     * The Previous Candidate key. Selects the previous possible match for the
     * ongoing input.
     */
    Key["PreviousCandidate"] = "PreviousCandidate";
    /** The Process key. Instructs the IME to process the conversion. */
    Key["Process"] = "Process";
    /**
     * The Single Candidate key. Enables single candidate mode (as opposed to
     * multi-candidate mode); in this mode, only one candidate is displayed at
     * a time.
     */
    Key["SingleCandidate"] = "SingleCandidate";
    /**
     * The Hangul (Korean character set) mode key, which toggles
     * between Hangul and English entry modes.
     */
    Key["HangulMode"] = "HangulMode";
    /**
     * Selects the Hanja mode, for converting Hangul characters to the more
     * specific Hanja characters.
     */
    Key["HanjaMode"] = "HanjaMode";
    /**
     * Selects the Junja mode, in which Korean is represented using single-byte
     * Latin characters.
     */
    Key["JunjaMode"] = "JunjaMode";
    /**
     * The Eisu key. This key's purpose is defined by the IME, but
     * may be used to close the IME.
     */
    Key["Eisu"] = "Eisu";
    /** The Hankaku (half-width characters) key. */
    Key["Hankaku"] = "Hankaku";
    /** The Hiragana key; selects Kana characters mode. */
    Key["Hiragana"] = "Hiragana";
    /** Toggles between the Hiragana and Katakana writing systems. */
    Key["HiraganaKatakana"] = "HiraganaKatakana";
    /** The Kana Mode (Kana Lock) key. */
    Key["KanaMode"] = "KanaMode";
    /**
     * The Kanji Mode key. Enables entering Japanese text using the
     * ideographic characters of Chinese origin.
     */
    Key["KanjiMode"] = "KanjiMode";
    /** The Katakana key. */
    Key["Katakana"] = "Katakana";
    /** The Romaji key; selects the Roman character set. */
    Key["Romaji"] = "Romaji";
    /** The Zenkaku (full width) characters key. */
    Key["Zenkaku"] = "Zenkaku";
    /** The Zenkaku/Hankaku (full width/half width) toggle key. */
    Key["ZenkakuHanaku"] = "ZenkakuHanaku";
    /** The first general-purpose function key, F1. */
    Key["F1"] = "F1";
    /** The F2 key. */
    Key["F2"] = "F2";
    /** The F3 key. */
    Key["F3"] = "F3";
    /** The F4 key. */
    Key["F4"] = "F4";
    /** The F5 key. */
    Key["F5"] = "F5";
    /** The F6 key. */
    Key["F6"] = "F6";
    /** The F7 key. */
    Key["F7"] = "F7";
    /** The F8 key. */
    Key["F8"] = "F8";
    /** The F9 key. */
    Key["F9"] = "F9";
    /** The F10 key. */
    Key["F10"] = "F10";
    /** The F11 key. */
    Key["F11"] = "F11";
    /** The F12 key. */
    Key["F12"] = "F12";
    /** The F13 key. */
    Key["F13"] = "F13";
    /** The F14 key. */
    Key["F14"] = "F14";
    /** The F15 key. */
    Key["F15"] = "F15";
    /** The F16 key. */
    Key["F16"] = "F16";
    /** The F17 key. */
    Key["F17"] = "F17";
    /** The F18 key. */
    Key["F18"] = "F18";
    /** The F19 key. */
    Key["F19"] = "F19";
    /** The F20 key. */
    Key["F20"] = "F20";
    /** The first general-purpose virtual function key. */
    Key["Soft1"] = "Soft1";
    /** The second general-purpose virtual function key. */
    Key["Soft2"] = "Soft2";
    /** The third general-purpose virtual function key. */
    Key["Soft3"] = "Soft3";
    /** The fourth general-purpose virtual function key. */
    Key["Soft4"] = "Soft4";
    /**
     * Presents a list of recently-used applications which lets the user change
     * apps quickly.
     */
    Key["AppSwitch"] = "AppSwitch";
    /** The Call key. Dials the number which has been entered. */
    Key["Call"] = "Call";
    /** The Camera key. Activates the camera. */
    Key["Camera"] = "Camera";
    /** The Focus key. Focuses the camera. */
    Key["CameraFocus"] = "CameraFocus";
    /** The End Call or Hang Up button. */
    Key["EndCall"] = "EndCall";
    /** The Back button. */
    Key["GoBack"] = "GoBack";
    /**
     * The Home button. Returns the user to the phone's main screen
     * (usually an application launcher).
     */
    Key["GoHome"] = "GoHome";
    /**
     * The Headset Hook key. This is typically actually a button on
     * the headset which is used to hang up calls and play or pause media.
     */
    Key["HeadsetHook"] = "HeadsetHook";
    /** The Redial button. Redials the last-called number. */
    Key["LastNumberRedial"] = "LastNumberRedial";
    /** The Notification key. */
    Key["Notification"] = "Notification";
    /**
     * A button which cycles among the notification modes: silent, vibrate,
     * ring, and so forth.
     */
    Key["MannerMode"] = "MannerMode";
    /** The Voice Dial key. Initiates voice dialing. */
    Key["VoiceDial"] = "VoiceDial";
    /** Switches to the previous channel. */
    Key["ChannelDown"] = "ChannelDown";
    /** Switches to the next channel. */
    Key["ChannelUp"] = "ChannelUp";
    /** Starts, continues, or increases the speed of fast forwarding the media. */
    Key["MediaFastForward"] = "MediaFastForward";
    /**
     * Pauses the currently playing media.
     * Note: Some older applications use
     * "Pause", but this is not correct.
     */
    Key["MediaPause"] = "MediaPause";
    /**
     * Starts or continues playing media at normal speed, if not already doing
     * so. Has no effect otherwise.
     */
    Key["MediaPlay"] = "MediaPlay";
    /** Toggles between playing and pausing the current media. */
    Key["MediaPlayPause"] = "MediaPlayPause";
    /** Starts or resumes recording media. */
    Key["MediaRecord"] = "MediaRecord";
    /** Starts, continues, or increases the speed of rewinding the media. */
    Key["MediaRewind"] = "MediaRewind";
    /**
     * Stops the current media activity (such as playing, recording, pausing,
     * forwarding, or rewinding). Has no effect if the media is currently
     * stopped already.
     */
    Key["MediaStop"] = "MediaStop";
    /** Seeks to the next media or program track. */
    Key["MediaTrackNext"] = "MediaTrackNext";
    /** Seeks to the previous media or program track. */
    Key["MediaTrackPrevious"] = "MediaTrackPrevious";
    /** Adjusts audio balance toward the left. */
    Key["AudioBalanceLeft"] = "AudioBalanceLeft";
    /** Adjusts audio balance toward the right. */
    Key["AudioBalanceRight"] = "AudioBalanceRight";
    /** Decreases the amount of bass. */
    Key["AudioBassDown"] = "AudioBassDown";
    /**
     * Reduces bass boosting or cycles downward through bass boost modes or
     * states.
     */
    Key["AudioBassBoostDown"] = "AudioBassBoostDown";
    /** Toggles bass boosting on and off. */
    Key["AudioBassBoostToggle"] = "AudioBassBoostToggle";
    /**
     * Increases the amount of bass boosting, or cycles upward through a set of
     * bass boost modes or states.
     */
    Key["AudioBassBoostUp"] = "AudioBassBoostUp";
    /** Increases the amount of bass. */
    Key["AudioBassUp"] = "AudioBassUp";
    /** Adjusts the audio fader toward the front. */
    Key["AudioFaderFront"] = "AudioFaderFront";
    /** Adjusts the audio fader toward the rear. */
    Key["AudioFaderRear"] = "AudioFaderRear";
    /** Selects the next available surround sound mode. */
    Key["AudioSurroundModeNext"] = "AudioSurroundModeNext";
    /** Decreases the amount of treble. */
    Key["AudioTrebleDown"] = "AudioTrebleDown";
    /** Increases the amount of treble. */
    Key["AudioTrebleUp"] = "AudioTrebleUp";
    /** Decreases the audio volume. */
    Key["AudioVolumeDown"] = "AudioVolumeDown";
    /** Mutes the audio. */
    Key["AudioVolumeMute"] = "AudioVolumeMute";
    /** Increases the audio volume. */
    Key["AudioVolumeUp"] = "AudioVolumeUp";
    /** Toggles the microphone on and off. */
    Key["MicrophoneToggle"] = "MicrophoneToggle";
    /** Decreases the microphone's input volume. */
    Key["MicrophoneVolumeDown"] = "MicrophoneVolumeDown";
    /** Mutes the microphone input. */
    Key["MicrophoneVolumeMute"] = "MicrophoneVolumeMute";
    /** Increases the microphone's input volume. */
    Key["MicrophoneVolumeUp"] = "MicrophoneVolumeUp";
    /** Switches into TV viewing mode. */
    Key["TV"] = "TV";
    /** Toggles 3D TV mode on and off. */
    Key["TV3DMode"] = "TV3DMode";
    /** Toggles between antenna and cable inputs. */
    Key["TVAntennaCable"] = "TVAntennaCable";
    /** Toggles audio description mode on and off. */
    Key["TVAudioDescription"] = "TVAudioDescription";
    /**
     * Decreases the audio description's mixing volume; reduces the volume of
     * the audio descriptions relative to the program sound.
     */
    Key["TVAudioDescriptionMixDown"] = "TVAudioDescriptionMixDown";
    /**
     * Increases the audio description's mixing volume; increases the volume of
     * the audio descriptions relative to the program sound.
     */
    Key["TVAudioDescriptionMixUp"] = "TVAudioDescriptionMixUp";
    /**
     * Displays or hides the media contents available for playback (this may be
     * a channel guide showing the currently airing programs, or a list of
     * media files to play).
     */
    Key["TVContentsMenu"] = "TVContentsMenu";
    /** Displays or hides the TV's data service menu. */
    Key["TVDataService"] = "TVDataService";
    /** Cycles the input mode on an external TV. */
    Key["TVInput"] = "TVInput";
    /** Switches to the input "Component 1." */
    Key["TVInputComponent1"] = "TVInputComponent1";
    /** Switches to the input "Component 2." */
    Key["TVInputComponent2"] = "TVInputComponent2";
    /** Switches to the input "Composite 1." */
    Key["TVInputComposite1"] = "TVInputComposite1";
    /** Switches to the input "Composite 2." */
    Key["TVInputComposite2"] = "TVInputComposite2";
    /** Switches to the input "HDMI 1." */
    Key["TVInputHDMI1"] = "TVInputHDMI1";
    /** Switches to the input "HDMI 2." */
    Key["TVInputHDMI2"] = "TVInputHDMI2";
    /** Switches to the input "HDMI 3." */
    Key["TVInputHDMI3"] = "TVInputHDMI3";
    /** Switches to the input "HDMI 4." */
    Key["TVInputHDMI4"] = "TVInputHDMI4";
    /** Switches to the input "VGA 1." */
    Key["TVInputVGA1"] = "TVInputVGA1";
    /** The Media Context menu key. */
    Key["TVMediaContext"] = "TVMediaContext";
    /** Toggle the TV's network connection on and off. */
    Key["TVNetwork"] = "TVNetwork";
    /** Put the TV into number entry mode. */
    Key["TVNumberEntry"] = "TVNumberEntry";
    /** The device's power button. */
    Key["TVPower"] = "TVPower";
    /** Radio button. */
    Key["TVRadioService"] = "TVRadioService";
    /** Satellite button. */
    Key["TVSatellite"] = "TVSatellite";
    /** Broadcast Satellite button. */
    Key["TVSatelliteBS"] = "TVSatelliteBS";
    /** Communication Satellite button. */
    Key["TVSatelliteCS"] = "TVSatelliteCS";
    /** Toggles among available satellites. */
    Key["TVSatelliteToggle"] = "TVSatelliteToggle";
    /**
     * Selects analog terrestrial television service (analog cable or antenna
     * reception).
     */
    Key["TVTerrestrialAnalog"] = "TVTerrestrialAnalog";
    /**
     * Selects digital terrestrial television service (digital cable or antenna
     * reception).
     */
    Key["TVTerrestrialDigital"] = "TVTerrestrialDigital";
    /** Timer programming button. */
    Key["TVTimer"] = "TVTimer";
    /** Changes the input mode on an external audio/video receiver (AVR) unit. */
    Key["AVRInput"] = "AVRInput";
    /** Toggles the power on an external AVR unit. */
    Key["AVRPower"] = "AVRPower";
    /**
     * General-purpose media function key, color-coded red. This has index
     * 0 among the colored keys.
     */
    Key["ColorF0Red"] = "ColorF0Red";
    /**
     * General-purpose media function key, color-coded green. This has index
     * 1 among the colored keys.
     */
    Key["ColorF1Green"] = "ColorF1Green";
    /**
     * General-purpose media function key, color-coded yellow. This has index
     * 2 among the colored keys.
     */
    Key["ColorF2Yellow"] = "ColorF2Yellow";
    /**
     * General-purpose media function key, color-coded blue. This has index
     * 3 among the colored keys.
     */
    Key["ColorF3Blue"] = "ColorF3Blue";
    /**
     * General-purpose media function key, color-coded grey. This has index
     * 4 among the colored keys.
     */
    Key["ColorF4Grey"] = "ColorF4Grey";
    /**
     * General-purpose media function key, color-coded brown. This has index
     * 5 among the colored keys.
     */
    Key["ColorF5Brown"] = "ColorF5Brown";
    /** Toggles closed captioning on and off. */
    Key["ClosedCaptionToggle"] = "ClosedCaptionToggle";
    /**
     * Adjusts the brightness of the device by toggling between two brightness
     * levels or by cycling among multiple brightness levels.
     */
    Key["Dimmer"] = "Dimmer";
    /** Cycles among video sources. */
    Key["DisplaySwap"] = "DisplaySwap";
    /** Switches the input source to the Digital Video Recorder (DVR). */
    Key["DVR"] = "DVR";
    /** The Exit button, which exits the current application or menu. */
    Key["Exit"] = "Exit";
    /** Clears the program or content stored in the first favorites list slot. */
    Key["FavoriteClear0"] = "FavoriteClear0";
    /** Clears the program or content stored in the second favorites list slot. */
    Key["FavoriteClear1"] = "FavoriteClear1";
    /** Clears the program or content stored in the third favorites list slot. */
    Key["FavoriteClear2"] = "FavoriteClear2";
    /** Clears the program or content stored in the fourth favorites list slot. */
    Key["FavoriteClear3"] = "FavoriteClear3";
    /**
     * Selects (recalls) the program or content stored in the first favorites
     * list slot.
     */
    Key["FavoriteRecall0"] = "FavoriteRecall0";
    /**
     * Selects (recalls) the program or content stored in the second favorites
     * list slot.
     */
    Key["FavoriteRecall1"] = "FavoriteRecall1";
    /**
     * Selects (recalls) the program or content stored in the third favorites
     * list slot.
     */
    Key["FavoriteRecall2"] = "FavoriteRecall2";
    /**
     * Selects (recalls) the program or content stored in the fourth favorites
     * list slot.
     */
    Key["FavoriteRecall3"] = "FavoriteRecall3";
    /**
     * Stores the current program or content into the first favorites list
     * slot.
     */
    Key["FavoriteStore0"] = "FavoriteStore0";
    /**
     * Stores the current program or content into the second favorites list
     * slot.
     */
    Key["FavoriteStore1"] = "FavoriteStore1";
    /**
     * Stores the current program or content into the third favorites list
     * slot.
     */
    Key["FavoriteStore2"] = "FavoriteStore2";
    /**
     * Stores the current program or content into the fourth favorites list
     * slot.
     */
    Key["FavoriteStore3"] = "FavoriteStore3";
    /** Toggles the display of the program or content guide. */
    Key["Guide"] = "Guide";
    /**
     * If the guide is currently displayed, this button tells the guide to
     * display the next day's content.
     */
    Key["GuideNextDay"] = "GuideNextDay";
    /**
     * If the guide is currently displayed, this button tells the guide to
     * display the previous day's content.
     */
    Key["GuidePreviousDay"] = "GuidePreviousDay";
    /**
     * Toggles the display of information about the currently selected content,
     * program, or media.
     */
    Key["Info"] = "Info";
    /**
     * Tells the device to perform an instant replay (typically some form of
     * jumping back a short amount of time then playing it again, possibly but
     * not usually in slow motion).
     */
    Key["InstantReplay"] = "InstantReplay";
    /** Opens content linked to the current program, if available and possible. */
    Key["Link"] = "Link";
    /** Lists the current program. */
    Key["ListProgram"] = "ListProgram";
    /** Toggles a display listing currently available live content or programs. */
    Key["LiveContent"] = "LiveContent";
    /** Locks or unlocks the currently selected content or pgoram. */
    Key["Lock"] = "Lock";
    /**
     * Presents a list of media applications, such as photo viewers, audio and
     * video players, and games. [1]
     */
    Key["MediaApps"] = "MediaApps";
    /** The Audio Track key. */
    Key["MediaAudioTrack"] = "MediaAudioTrack";
    /** Jumps back to the last-viewed content, program, or other media. */
    Key["MediaLast"] = "MediaLast";
    /** Skips backward to the previous content or program. */
    Key["MediaSkipBackward"] = "MediaSkipBackward";
    /** Skips forward to the next content or program. */
    Key["MediaSkipForward"] = "MediaSkipForward";
    /** Steps backward to the previous content or program. */
    Key["MediaStepBackward"] = "MediaStepBackward";
    /** Steps forward to the next content or program. */
    Key["MediaStepForward"] = "MediaStepForward";
    /**
     * Top Menu button. Opens the media's main menu (e.g., for a DVD or Blu-Ray
     * disc).
     */
    Key["MediaTopMenu"] = "MediaTopMenu";
    /** Navigates into a submenu or option. */
    Key["NavigateIn"] = "NavigateIn";
    /** Navigates to the next item. */
    Key["NavigateNext"] = "NavigateNext";
    /** Navigates out of the current screen or menu. */
    Key["NavigateOut"] = "NavigateOut";
    /** Navigates to the previous item. */
    Key["NavigatePrevious"] = "NavigatePrevious";
    /** Cycles to the next channel in the favorites list. */
    Key["NextFavoriteChannel"] = "NextFavoriteChannel";
    /**
     * Cycles to the next saved user profile, if this feature is supported and
     * multiple profiles exist.
     */
    Key["NextUserProfile"] = "NextUserProfile";
    /**
     * Opens the user interface for selecting on demand content or programs to
     * watch.
     */
    Key["OnDemand"] = "OnDemand";
    /** Starts the process of pairing the remote with a device to be controlled. */
    Key["Pairing"] = "Pairing";
    /** A button to move the picture-in-picture view downward. */
    Key["PinPDown"] = "PinPDown";
    /** A button to control moving the picture-in-picture view. */
    Key["PinPMove"] = "PinPMove";
    /** Toggles display of the picture-in-picture view on and off. */
    Key["PinPToggle"] = "PinPToggle";
    /** A button to move the picture-in-picture view upward. */
    Key["PinPUp"] = "PinPUp";
    /** Decreases the media playback rate. */
    Key["PlaySpeedDown"] = "PlaySpeedDown";
    /** Returns the media playback rate to normal. */
    Key["PlaySpeedReset"] = "PlaySpeedReset";
    /** Increases the media playback rate. */
    Key["PlaySpeedUp"] = "PlaySpeedUp";
    /** Toggles random media (also known as "shuffle mode") on and off. */
    Key["RandomToggle"] = "RandomToggle";
    /**
     * A code sent when the remote control's battery is low. This doesn't
     * actually correspond to a physical key at all.
     */
    Key["RcLowBattery"] = "RcLowBattery";
    /** Cycles among the available media recording speeds. */
    Key["RecordSpeedNext"] = "RecordSpeedNext";
    /**
     * Toggles radio frequency (RF) input bypass mode on and off. RF bypass
     * mode passes RF input directly to the RF output without any processing or
     * filtering.
     */
    Key["RfBypass"] = "RfBypass";
    /**
     * Toggles the channel scan mode on and off. This is a mode which flips
     * through channels automatically until the user stops the scan.
     */
    Key["ScanChannelsToggle"] = "ScanChannelsToggle";
    /** Cycles through the available screen display modes. */
    Key["ScreenModeNext"] = "ScreenModeNext";
    /** Toggles display of the device's settings screen on and off. */
    Key["Settings"] = "Settings";
    /** Toggles split screen display mode on and off. */
    Key["SplitScreenToggle"] = "SplitScreenToggle";
    /** Cycles among input modes on an external set-top box (STB). */
    Key["STBInput"] = "STBInput";
    /** Toggles on and off an external STB. */
    Key["STBPower"] = "STBPower";
    /** Toggles the display of subtitles on and off if they're available. */
    Key["Subtitle"] = "Subtitle";
    /**
     * Toggles display of teletext,
     * if available.
     */
    Key["Teletext"] = "Teletext";
    /** Cycles through the available video modes. */
    Key["VideoModeNext"] = "VideoModeNext";
    /**
     * Causes the device to identify itself in some fashion, such as by
     * flashing a light, briefly changing the brightness of indicator lights,
     * or emitting a tone.
     */
    Key["Wink"] = "Wink";
    /**
     * Toggles between fullscreen and scaled content display, or otherwise
     * change the magnification level.
     */
    Key["ZoomToggle"] = "ZoomToggle";
    /**
     * Presents a list of possible corrections for a word which was incorrectly
     * identified.
     */
    Key["SpeechCorrectionList"] = "SpeechCorrectionList";
    /**
     * Toggles between dictation mode and command/control mode. This lets the
     * speech engine know whether to interpret spoken words as input text or as
     * commands.
     */
    Key["SpeechInputToggle"] = "SpeechInputToggle";
    /** Closes the current document or message. Must not exit the application. */
    Key["Close"] = "Close";
    /** Creates a new document or message. */
    Key["New"] = "New";
    /** Opens an existing document or message. */
    Key["Open"] = "Open";
    /** Prints the current document or message. */
    Key["Print"] = "Print";
    /** Saves the current document or message. */
    Key["Save"] = "Save";
    /** Starts spell checking the current document. */
    Key["SpellCheck"] = "SpellCheck";
    /** Opens the user interface to forward a message. */
    Key["MailForward"] = "MailForward";
    /** Opens the user interface to reply to a message. */
    Key["MailReply"] = "MailReply";
    /** Sends the current message. */
    Key["MailSend"] = "MailSend";
    /**
     * The Calculator key, often labeled with an icon. This is often
     * used as a generic application launcher key
     * (APPCOMMAND_LAUNCH_APP2).
     */
    Key["LaunchCalculator"] = "LaunchCalculator";
    /** The Calendar key. Often labeled with an icon. */
    Key["LaunchCalendar"] = "LaunchCalendar";
    /** The Contacts key. */
    Key["LaunchContacts"] = "LaunchContacts";
    /** The Mail key. Often labeled with an icon. */
    Key["LaunchMail"] = "LaunchMail";
    /** The Media Player key. */
    Key["LaunchMediaPlayer"] = "LaunchMediaPlayer";
    /** The Music Player key. Often labeled with an icon. */
    Key["LaunchMusicPlayer"] = "LaunchMusicPlayer";
    /**
     * The My Computer key on Windows keyboards. This is often used
     * as a generic application launcher key
     * (APPCOMMAND_LAUNCH_APP1).
     */
    Key["LaunchMyComputer"] = "LaunchMyComputer";
    /**
     * The Phone key. Opens the phone dialer application (if one is
     * present).
     */
    Key["LaunchPhone"] = "LaunchPhone";
    /** The Screen Saver key. */
    Key["LaunchScreenSaver"] = "LaunchScreenSaver";
    /** The Spreadsheet key. This key may be labeled with an icon. */
    Key["LaunchSpreadsheet"] = "LaunchSpreadsheet";
    /**
     * The Web Browser key. This key is frequently labeled with an
     * icon.
     */
    Key["LaunchWebBrowser"] = "LaunchWebBrowser";
    /** The WebCam key. Opens the webcam application. */
    Key["LaunchWebCam"] = "LaunchWebCam";
    /**
     * The Word Processor key. This may be an icon of a specific
     * word processor application, or a generic document icon.
     */
    Key["LaunchWordProcessor"] = "LaunchWordProcessor";
    /** The first generic application launcher button. */
    Key["LaunchApplication1"] = "LaunchApplication1";
    /** The second generic application launcher button. */
    Key["LaunchApplication2"] = "LaunchApplication2";
    /** The third generic application launcher button. */
    Key["LaunchApplication3"] = "LaunchApplication3";
    /** The fourth generic application launcher button. */
    Key["LaunchApplication4"] = "LaunchApplication4";
    /** The fifth generic application launcher button. */
    Key["LaunchApplication5"] = "LaunchApplication5";
    /** The sixth generic application launcher button. */
    Key["LaunchApplication6"] = "LaunchApplication6";
    /** The seventh generic application launcher button. */
    Key["LaunchApplication7"] = "LaunchApplication7";
    /** The eighth generic application launcher button. */
    Key["LaunchApplication8"] = "LaunchApplication8";
    /** The ninth generic application launcher button. */
    Key["LaunchApplication9"] = "LaunchApplication9";
    /** The 10th generic application launcher button. */
    Key["LaunchApplication10"] = "LaunchApplication10";
    /** The 11th generic application launcher button. */
    Key["LaunchApplication11"] = "LaunchApplication11";
    /** The 12th generic application launcher button. */
    Key["LaunchApplication12"] = "LaunchApplication12";
    /** The 13th generic application launcher button. */
    Key["LaunchApplication13"] = "LaunchApplication13";
    /** The 14th generic application launcher button. */
    Key["LaunchApplication14"] = "LaunchApplication14";
    /** The 15th generic application launcher button. */
    Key["LaunchApplication15"] = "LaunchApplication15";
    /** The 16th generic application launcher button. */
    Key["LaunchApplication16"] = "LaunchApplication16";
    /**
     * Navigates to the previous content or page in the current Web view's
     * history.
     */
    Key["BrowserBack"] = "BrowserBack";
    /** Opens the user's list of bookmarks/favorites. */
    Key["BrowserFavorites"] = "BrowserFavorites";
    /** Navigates to the next content or page in the current Web view's history. */
    Key["BrowserForward"] = "BrowserForward";
    /** Navigates to the user's preferred home page. */
    Key["BrowserHome"] = "BrowserHome";
    /** Refreshes the current page or content. */
    Key["BrowserRefresh"] = "BrowserRefresh";
    /**
     * Activates the user's preferred search engine or the search interface
     * within their browser.
     */
    Key["BrowserSearch"] = "BrowserSearch";
    /** Stops loading the currently displayed Web view or content. */
    Key["BrowserStop"] = "BrowserStop";
    /**
     * The decimal point key (typically . or
     * , depending on the region).
     * In newer browsers, this value to be the character generated by the
     * decimal key (one of those two characters). [1]
     */
    Key["Decimal"] = "Decimal";
    /** The 11 key found on certain media numeric keypads. */
    Key["Key11"] = "Key11";
    /** The 12 key found on certain media numeric keypads. */
    Key["Key12"] = "Key12";
    /** The numeric keypad's multiplication key, *. */
    Key["Multiply"] = "Multiply";
    /** The numeric keypad's addition key, +. */
    Key["Add"] = "Add";
    /** The numeric keypad's division key, /. */
    Key["Divide"] = "Divide";
    /** The numeric keypad's subtraction key, -. */
    Key["Subtract"] = "Subtract";
    /**
     * The numeric keypad's places separator character.
     * (In the United States this is a comma, but elsewhere it is frequently
     * a period.)
     */
    Key["Separator"] = "Separator";
})(exports.Key || (exports.Key = {}));
});

/*
 * Copyright (C) 2021 Robert Bosch GmbH Copyright (C) 2021 Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved.
 */
var KeyboardAdditionalActionKeyCodes;
(function (KeyboardAdditionalActionKeyCodes) {
  KeyboardAdditionalActionKeyCodes["Space"] = "Space";
})(KeyboardAdditionalActionKeyCodes || (KeyboardAdditionalActionKeyCodes = {}));
var MouseActionKeyCodes;
(function (MouseActionKeyCodes) {
  MouseActionKeyCodes["MouseKey"] = "MouseKey";
})(MouseActionKeyCodes || (MouseActionKeyCodes = {}));
class KeyEventListener {
  constructor(documentElement) {
    this.allEventKeys = Object.assign(Object.assign(Object.assign({}, Key_enum.Key), KeyboardAdditionalActionKeyCodes), MouseActionKeyCodes);
    this.registeredEvents = new Map();
    this.document = document;
    this.active = false;
    if (documentElement) {
      this.document = documentElement;
    }
  }
  startEventListeners(eventMap) {
    eventMap.forEach((_, eventType) => {
      this.document.addEventListener(eventType, (event) => {
        if (event instanceof KeyboardEvent && this.allEventKeys[event.code]) {
          this.notify(eventType, this.allEventKeys[event.code]);
        }
        else if (event instanceof MouseEvent) {
          this.notify(eventType, this.allEventKeys[MouseActionKeyCodes.MouseKey]);
        }
      });
    });
  }
  addListener(eventType, callback, listenerKey) {
    if (!listenerKey || eventType === 'mousedown' || eventType === 'mouseup') {
      this.addMouseEventListener(eventType, callback);
    }
    else {
      this.addKeyboardEventListener(eventType, callback, listenerKey);
    }
    return this;
  }
  removeListener(eventType, listenerKey) {
    const targetEvent = this.registeredEvents.get(eventType);
    if (targetEvent) {
      targetEvent.delete(listenerKey);
    }
    return this;
  }
  getOrCreateEventByEventType(eventType) {
    const targetEvent = this.getTargetEvent(eventType);
    return targetEvent ? targetEvent : this.createTargetEvent(eventType);
  }
  getTargetEvent(eventType) {
    return this.registeredEvents.get(eventType);
  }
  createTargetEvent(eventType) {
    const newTargetEvent = new Map();
    this.registeredEvents.set(eventType, newTargetEvent);
    this.startEventListeners(this.registeredEvents);
    return newTargetEvent;
  }
  addKeyboardEventListener(eventType, callback, listenerKey) {
    const targetEvent = this.getOrCreateEventByEventType(eventType);
    targetEvent.set(listenerKey, callback);
  }
  addMouseEventListener(eventType, callback) {
    const targetEvent = this.getOrCreateEventByEventType(eventType);
    targetEvent.set(MouseActionKeyCodes.MouseKey, callback);
  }
  notify(eventType, key) {
    var _a;
    if (!this.active) {
      return;
    }
    const targetEvent = this.registeredEvents.get(eventType);
    // calls the function belonging to the used key
    (_a = targetEvent === null || targetEvent === void 0 ? void 0 : targetEvent.get(key)) === null || _a === void 0 ? void 0 : _a();
  }
}

/*
 * Copyright (C) 2021 Robert Bosch GmbH Copyright (C) 2021 Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved.
 */
class LoadingHandlerService {
  constructor(dataSource, onLoadingChange) {
    this.dataSource = dataSource;
    this.onLoadingChange = onLoadingChange;
    this._isLoading = false;
  }
  get isLoading() {
    return this._isLoading;
  }
  async getChildren(nodeId) {
    return this.wrapper(() => this.dataSource.getChildren(nodeId));
  }
  async getRoots() {
    return this.wrapper(this.dataSource.getRoots);
  }
  setIsLoading(value) {
    this._isLoading = value;
    this.notify();
  }
  async wrapper(func) {
    this.setIsLoading(true);
    return func().finally(tap(() => this.setIsLoading(false)));
  }
  notify() {
    this.onLoadingChange(this.isLoading);
  }
}

class TreeFilterService {
  constructor() {
    this._filter = '';
  }
  get filter() {
    return this._filter;
  }
  set filter(filter) {
    this._filter = filter.toLowerCase();
  }
  applyFilter(activeLevels) {
    if (this._filter === '') {
      return activeLevels;
    }
    const activeLevelsClone = [...activeLevels];
    const lastLevel = activeLevelsClone.pop();
    if (lastLevel === undefined) {
      return [];
    }
    const filteredLevel = Object.assign(Object.assign({}, lastLevel), { sections: lastLevel.sections.map((section) => (Object.assign(Object.assign({}, section), { items: section.items.filter((node) => node.label.toLowerCase().includes(this._filter)) }))) });
    return [...activeLevelsClone, filteredLevel];
  }
}

function groupNodesByKey(nodes, key) {
  return nodes.reduce((acc, cur) => {
    var _a;
    const arr = (_a = acc[cur[key]]) !== null && _a !== void 0 ? _a : [];
    arr.push(cur);
    acc[cur[key]] = arr;
    return acc;
  }, {});
}

/** Stateless Service to handle the Multi-Selector Tree */
/**
 * returns an array of the nodes along the given nodePath and given node link ids as a flat array
 *
 * @param tree
 * @param nodePath
 * @returns
 * @example
 * Data set (tree structure):
 * BaP
 * - A100
 * -- L1c
 * -- L1b
 * - A200
 * -- L2a
 * -- L2b
 * AnP
 * - A300
 * -- L3a
 * -- L3c
 * - A400
 * -- L4b
 * -- L4c
 *
 * Path: BaP, A200, L2a
 *
 * Result (array): [
 * {
 * BaP
 * - A100
 * -- L1c
 * -- L1b
 * - A200
 * -- L2a
 * -- L2b},
 * {
 * - A200
 * -- L2a
 * -- L2},
 * {
 * -- L2}
 * ]
 *
 * The nodes are returned in an array form, but they retain there references to there children
 */
function getNodesFromTreeByNodePath(tree, nodePath) {
  let partialTree = tree;
  let nodes = [];
  for (const nodeLink of nodePath) {
    const nextNode = partialTree.find((node) => node.id === nodeLink.id);
    if (!nextNode) {
      break;
    }
    partialTree = nextNode.children;
    nodes.push(nextNode);
  }
  return nodes;
}
/**
 * sets all nodes and subNodes inactive in the given tree (deep)
 * @param tree
 * @returns
 */
function setAllNodesInTreeToInactive(tree) {
  if (!tree || tree.length === 0) {
    return [];
  }
  tree.map((node) => {
    const dirtyNode = node.active;
    node.active = false;
    node.children = setAllNodesInTreeToInactive(node.children);
    if (dirtyNode) {
      return cloneNode(node);
    }
    return node;
  });
  return tree;
}
/**
 * clones the given node and sets also the proper connection to the parent Node (if exists)
 * !!No deep cloning!!
 * @param node
 * @returns
 */
function cloneNode(node) {
  const clone = Object.assign({}, node);
  if (clone.parent) {
    const parent = clone.parent;
    for (let childIndex = 0; childIndex < parent.children.length; childIndex++) {
      const child = parent.children[childIndex];
      if (child.id === clone.id) {
        parent.children[childIndex] = clone;
      }
    }
  }
  return clone;
}
/**
 * returns all active levels of the tree (deep)
 * @param tree
 * @returns
 */
function getActiveLevels(tree, previousLevelActiveNode = null) {
  if (tree.length === 0) {
    return [];
  }
  const firstLevel = createLevelByNodes(tree, previousLevelActiveNode);
  let activeLevels = [firstLevel];
  const activeNode = tree.find((node) => node.active);
  if (activeNode && activeNode.children) {
    activeLevels = activeLevels.concat(getActiveLevels(activeNode.children, activeNode));
  }
  return activeLevels;
}
function getNodeFromTreeByNodePath(tree, nodePath) {
  if (!nodePath) {
    return null;
  }
  const nodes = getNodesFromTreeByNodePath(tree, nodePath);
  if (nodes.length !== nodePath.length) {
    return undefined;
  }
  return nodes[nodes.length - 1];
}
/**
 * create a level with sections
 * @param nodes
 * @returns
 */
function createLevelByNodes(nodes, previousLevelActiveNode = null) {
  const level = {
    parentNode: previousLevelActiveNode,
    sections: [],
  };
  level.sections = createLevelSectionsByNodes(nodes);
  return level;
}
/**
 * create a level with sections
 * @param nodes
 * @returns
 */
function createLevelSectionsByNodes(nodes) {
  const levelObj = groupNodesByKey(nodes, 'typeLabel');
  return Object.entries(levelObj)
    .map(([key, items]) => {
    return {
      label: key === 'undefined' ? '' : key,
      items: sortByLabelAsc(items),
    };
  })
    .sort((sectionA, sectionB) => sectionA.label.localeCompare(sectionB.label));
}
function getNodesByLevel(level) {
  return level.sections.reduce((acc, levelSection) => acc.concat(levelSection.items), []);
}
function sortByLabelAsc(items) {
  return items.sort((sectionA, sectionB) => sectionA.label.localeCompare(sectionB.label));
}

class TreeSelectionService {
  constructor(onInvalidSelection, selectionMode = 'multi', initialSelection = []) {
    this.onInvalidSelection = onInvalidSelection;
    this._selections = [];
    this._logger = getLogger();
    this._selectionMode = selectionMode;
    this.setInitialSelections(initialSelection);
  }
  setInitialSelections(initialSelection) {
    this._selections = initialSelection;
  }
  resetSelection(tree) {
    this.resetSelectionByTree(tree);
    this._selections = [];
  }
  /**
   * updates selections states of giving tree according to current selection
   * In Mismatching case of Invalid set selection and existing tree nodes function triggers OnInvalidSelection
   * @param tree
   */
  updateTreeWithCurrentSelection(tree) {
    this.setSelectionsAndUpdateInTree(tree, this.selections);
  }
  /**
   * sets the selection and updates the given tree with such
   * @param tree
   * @param selections
   */
  setSelectionsAndUpdateInTree(tree = [], selections) {
    const validSelections = this.validateSelectionByLevel(tree, selections);
    this._selections = validSelections;
    if (tree.length > 0) {
      this.setSelectionsInLevelDeep(tree);
    }
  }
  get selections() {
    return this._selections;
  }
  get selectionMode() {
    return this._selectionMode;
  }
  set selectionMode(selectionMode) {
    this._selectionMode = selectionMode;
  }
  /**
   * searches and updates within the given tree a specific node and sets the given new state within
   * @param tree
   * @param changedNode
   * @param newState
   * @returns
   */
  updateNodeStateInTree(tree, changedNode, newState) {
    var _a;
    if (!tree) {
      return;
    }
    const effectedNode = getNodeFromTreeByNodePath(tree, changedNode);
    if (!effectedNode || effectedNode.selectionState === newState) {
      /** no change */
      return;
    }
    if (this.selectionMode === 'single') {
      this.resetSelection(tree);
    }
    // we only need to deselect children if children are selected, therefore the === 'indeterminate' check
    const isParentBeingChecked = effectedNode.selectionState === 'indeterminate' && newState === 'checked';
    const isBeingChecked = newState === 'checked';
    effectedNode.selectionState = newState;
    if (isBeingChecked) {
      const parentNodePaths = this.setIndeterminateOnParentsByNodePath(tree, (_a = effectedNode.parent) === null || _a === void 0 ? void 0 : _a.path);
      /** remove parents from this.selections, cause the children is selected therefore no parent can be selected (only indeterminate) */
      this.setSelectionsAndUpdateInTree(tree, this.removeNodesFromSelection(parentNodePaths));
    }
    if (isParentBeingChecked) {
      this.setUncheckedOnChildren(effectedNode.children);
      this.setSelectionsAndUpdateInTree(tree, this.removeChildrenFromSelection(changedNode));
    }
    this.setSelectionsAndUpdateInTree(tree, newState === 'checked' ? [...this._selections, changedNode] : this.removeNodeFromSelections(this._selections, changedNode));
    if (!isBeingChecked) {
      this.updateIndeterminateStateOfParents(tree, this._selections, effectedNode);
    }
  }
  setSelectionsInLevel(level, selections) {
    level.forEach((node) => {
      const selectionsContainingNode = selections.filter((selection) => selection.length > node.level && selection[node.level].id === node.id);
      if (selectionsContainingNode.length === 0) {
        if (node.selectionState === 'checked') {
          node.selectionState = 'unchecked';
        }
        return;
      }
      const nodeIsIndeterminate = selectionsContainingNode.some((selection) => selection.length > node.level + 1);
      node.selectionState = nodeIsIndeterminate ? 'indeterminate' : 'checked';
    });
    return level;
  }
  isSelectionsValidBySelectionMode(selections) {
    return !(selections.length > 1 && this.selectionMode === 'single');
  }
  /**
   * returns valid selections - validated by the selectionMode Rule
   * @param selections
   * @returns
   */
  validateSelectionsBySelectionModeRule(selections) {
    const isSelectionsValid = this.isSelectionsValidBySelectionMode(selections);
    if (!isSelectionsValid) {
      this._logger.error("The bci-multi-selector is in 'single' selection mode, but the initial selection you provided contains more that one selection. Therefore the initial selection will be empty");
    }
    return isSelectionsValid ? selections : [];
  }
  validateSelectionByLevel(checkedLevel, selections) {
    let validatedSelections = this.validateSelectionsBySelectionModeRule(selections);
    if (validatedSelections.length === 0 || checkedLevel === undefined) {
      return validatedSelections;
    }
    const { valid, invalid } = this.validateSelectionIsMappingLevelRule(validatedSelections, checkedLevel);
    validatedSelections = valid;
    if (invalid.length !== 0) {
      invalid.forEach((invalidSelection) => (this._selections = this.removeNodeFromSelections(this._selections, invalidSelection)));
      this.onInvalidSelection(invalid);
    }
    return valid;
  }
  /**
   * validates if the level related selections map to the actual level
   * Tries to find mismatches between set Selection and actual level (mismatches are invalid nodes)
   * Search is only within the given level
   * @param selections
   * @param checkedLevel
   * @returns
   */
  validateSelectionIsMappingLevelRule(selections, checkedLevel) {
    var _a, _b;
    const startSplitSelection = { valid: [], invalid: [] };
    const [ignoredNodePaths, groupedNodePaths] = this.groupByNodePathId(selections, (_b = (_a = checkedLevel[0]) === null || _a === void 0 ? void 0 : _a.parent) === null || _b === void 0 ? void 0 : _b.path);
    const searchSpaceKeySet = new Set(checkedLevel.map(({ id }) => id));
    const toSplitSelection = ({ invalid, valid }, [key, value]) => {
      if (searchSpaceKeySet.has(key)) {
        return { valid: valid.concat(value), invalid };
      }
      return { valid, invalid: invalid.concat(value) };
    };
    const validatedSelectionSplit = [...groupedNodePaths.entries()].reduce(toSplitSelection, startSplitSelection);
    validatedSelectionSplit.valid = validatedSelectionSplit.valid.concat(ignoredNodePaths);
    return validatedSelectionSplit;
  }
  /**
   * All children of the parent node will have the same 'node.id' at the parent node level (same index),
   * because the NodeLink contains the entire path to them.
   * So, filtering them is as simple as comparing at the same NodeLink level for the parent id
   * @param selection
   * @param parent
   * @returns
   */
  splitSelectionByNodePath(selection, parent) {
    const parentNode = parent[parent.length - 1];
    const parentDepthIndex = parent.length - 1;
    return selection.reduce(([match, miss], nodeLink) => {
      var _a;
      if (((_a = nodeLink[parentDepthIndex]) === null || _a === void 0 ? void 0 : _a.id) === parentNode.id) {
        match.push(nodeLink);
      }
      else {
        miss.push(nodeLink);
      }
      return [match, miss];
    }, [[], []]);
  }
  /**
   * example:
   *  input:
   *    selections: [ [ {id, label}, {id, label}, ...], [ {id, label}, {id, label}, ...] ...]
   *    nodePathOfNodeToRemove: [ {id, label}, {id, label} ...]
   *
   * @param selections
   * @param nodePathOfNodeToRemove
   * @returns
   */
  removeNodeFromSelections(selections, nodePathOfNodeToRemove) {
    const nodeToRemove = nodePathOfNodeToRemove[nodePathOfNodeToRemove.length - 1];
    return selections.filter((path) => path[path.length - 1].id !== nodeToRemove.id);
  }
  resetSelectionByTree(level) {
    level.forEach((node) => {
      node.selectionState = 'unchecked';
      this.resetSelectionByTree(node.children);
    });
  }
  setSelectionsInLevelDeep(level) {
    const validSelection = this.validateSelectionByLevel(level, this._selections);
    this.setSelectionsInLevel(level, validSelection);
    level.forEach((node) => {
      if (node.children && node.children.length > 0) {
        this.setSelectionsInLevelDeep(node.children);
      }
    });
  }
  setIndeterminateOnParentsByNodePath(tree, nodePath) {
    var _a;
    const node = getNodeFromTreeByNodePath(tree, nodePath);
    if (!node) {
      return [];
    }
    node.selectionState = 'indeterminate';
    return [node.path].concat(this.setIndeterminateOnParentsByNodePath(tree, (_a = node.parent) === null || _a === void 0 ? void 0 : _a.path));
  }
  /**
   * The result contains all NodePaths which were part of the selections parameter, but split into ignoredNodePaths and groupedNodePaths
   * @param selections
   * @param parentNodePath is used to filter the selections before grouping. Only nodes that are its children will be part of the groupedNodePaths Map
   * @returns
   */
  groupByNodePathId(selections, parentNodePath) {
    var _a;
    const [filteredSelections, ignoredNodePaths] = parentNodePath
      ? this.splitSelectionByNodePath(selections, parentNodePath)
      : [selections, []];
    const depthIndex = (_a = parentNodePath === null || parentNodePath === void 0 ? void 0 : parentNodePath.length) !== null && _a !== void 0 ? _a : 0;
    const groupedNodePaths = filteredSelections.reduce((map, nodePath) => {
      const nodeLink = nodePath[depthIndex];
      if (!nodeLink) {
        // Is only undefined when its the parentNodePath itself.
        // As this node obviously exists, it can be ignored for further validation.
        ignoredNodePaths.push(nodePath);
        return map;
      }
      const key = nodeLink.id;
      const group = map.get(key) || [];
      group.push(nodePath);
      return map.set(key, group);
    }, new Map());
    return [ignoredNodePaths, groupedNodePaths];
  }
  removeNodesFromSelection(nodePathsToRemove) {
    return nodePathsToRemove.reduce((selections, nodePath) => this.removeNodeFromSelections(selections, nodePath), this._selections);
  }
  removeChildrenFromSelection(changedNode) {
    const clickedNodePlusChildren = this.filterSelectionByNodePath(this._selections, changedNode);
    const childrenOfClickedNode = clickedNodePlusChildren.filter((nodeLink) => nodeLink.length !== changedNode.length);
    return this._selections.filter((nodeLink) => !childrenOfClickedNode.includes(nodeLink));
  }
  updateIndeterminateStateOfParents(tree, selection, effectedNode) {
    var _a;
    if (!effectedNode.parent) {
      return;
    }
    const parentNode = getNodeFromTreeByNodePath(tree, (_a = effectedNode.parent) === null || _a === void 0 ? void 0 : _a.path);
    if (selection.some((selectedPath) => selectedPath.some((node) => node.id === parentNode.id))) {
      // if this node stays indeterminate due to another selection, all of its parent will as well
      return;
    }
    parentNode.selectionState = 'unchecked';
    this.updateIndeterminateStateOfParents(tree, selection, parentNode);
  }
  filterSelectionByNodePath(selection, parent) {
    const [match] = this.splitSelectionByNodePath(selection, parent);
    return match;
  }
  setUncheckedOnChildren(nodes) {
    if (nodes.length === 0) {
      return;
    }
    nodes.forEach((node) => {
      node.selectionState = 'unchecked';
      this.setUncheckedOnChildren(node.children);
    });
  }
}

class MultiSelectorManager {
  /**
   * initiate class and load the initial root level of the tree
   * @param dataSource
   * @param singleSelectMode
   * @param onActiveChange Provide a function that is called whenever the active levels change
   */
  constructor(dataSource, onActiveChange, onSelectionChange, onClearSearch, onInvalidSelection, onLoadingChange, initialSelection = [], selectionMode = 'multi') {
    this.onActiveChange = onActiveChange;
    this.onSelectionChange = onSelectionChange;
    this.onClearSearch = onClearSearch;
    this.onInvalidSelection = onInvalidSelection;
    this.onLoadingChange = onLoadingChange;
    this._activeLevels = [];
    this._filterService = new TreeFilterService();
    this._focussedNode = null;
    this.dataSource = this.loadingHandler = new LoadingHandlerService(dataSource, (value) => this.invokeAsync(() => this.onLoadingChange(value)));
    this._selectionService = new TreeSelectionService(this.onInvalidSelection, selectionMode, initialSelection);
    this._selectionService.setInitialSelections(initialSelection);
    this.handleLoadedNodes(this.dataSource.getRoots()).then(() => {
      this.updateActiveLevels();
    });
  }
  getFilter() {
    return this._filterService.filter;
  }
  updateFilter(filter) {
    if (filter === this._filterService.filter) {
      return;
    }
    this._filterService.filter = filter;
    this.updateActiveLevels();
  }
  resetSelection(notify = true) {
    if (!this._tree) {
      return;
    }
    this._selectionService.resetSelection(this._tree);
    if (notify) {
      this.updateSelection([], 'reset');
    }
    // the tree needs to be redrawn when changing the selection, even if no OnSelectionChange event is triggered
    this.updateActiveLevels();
  }
  updateSelection(path, selectionState) {
    Promise.resolve().then(() => this.onSelectionChange({
      changedNode: path,
      reason: selectionState,
      selections: this._selectionService.selections,
    }));
  }
  updateSelectionMode(selectionMode) {
    if (this._selectionService.selectionMode === selectionMode) {
      return;
    }
    this.resetSelection(false);
    this._selectionService.selectionMode = selectionMode;
  }
  setSelectionStateOfNodeByPath(changedNode, newState) {
    if (!this._tree) {
      return;
    }
    this._selectionService.updateNodeStateInTree(this._tree, changedNode, newState);
    this.updateSelection(changedNode, newState);
    this.updateActiveLevels();
  }
  initiateSelections(selections) {
    this._selectionService.setSelectionsAndUpdateInTree(this._tree, selections);
    this.updateActiveLevels();
  }
  get isLoading() {
    return this.loadingHandler.isLoading;
  }
  getActiveLevels() {
    const filteredActiveLevels = this._filterService.applyFilter(this._activeLevels);
    return [...filteredActiveLevels];
  }
  async arrowLeftPressed() {
    if (!this._focussedNode) {
      this.initiateFocussedNode();
      this.updateActiveLevels();
      return;
    }
    else if (!this._focussedNode.parent) {
      /** no changed */
      return;
    }
    const parentNode = this._focussedNode.parent;
    if (parentNode) {
      this.setFocusedNodeByPath(parentNode.path);
      await this.setActiveStateOfNodeByPath(parentNode.path, false);
    }
    else {
      this.updateActiveLevels();
    }
  }
  async arrowRightPressed() {
    var _a;
    if (!this._focussedNode) {
      this.initiateFocussedNode();
      this.updateActiveLevels();
      return;
    }
    else if (!this._focussedNode.hasChildren) {
      /** no changed */
      return;
    }
    if (this._focussedNode.hasChildren) {
      await this.setActiveStateOfNodeByPath(this._focussedNode.path, true);
      this.setFocusedNodeByPath((_a = this._focussedNode.children[0]) === null || _a === void 0 ? void 0 : _a.path);
    }
    else {
      this.updateActiveLevels();
    }
  }
  arrowUpPressed() {
    if (!this._focussedNode) {
      this.initiateFocussedNode();
      this.updateActiveLevels();
      return;
    }
    let levelOfFocussedNode = this.getLevelOfFocussedNode();
    let index = levelOfFocussedNode.findIndex((node) => node.id === this._focussedNode.id);
    if (index === -1) {
      console.error('NODE NOT FOUND IN LEVEL', levelOfFocussedNode);
      return;
    }
    else if (index === 0) {
      index = levelOfFocussedNode.length - 1;
    }
    else {
      index = index - 1;
    }
    this.setFocusedNodeByPath(levelOfFocussedNode[index].path);
    return this.updateActiveLevels();
  }
  arrowDownPressed() {
    if (!this._focussedNode) {
      this.initiateFocussedNode();
      this.updateActiveLevels();
      return;
    }
    let levelOfFocussedNode = this.getLevelOfFocussedNode();
    let index = levelOfFocussedNode.findIndex((node) => node.id === this._focussedNode.id);
    if (index === -1) {
      console.error('NODE NOT FOUND IN LEVEL', levelOfFocussedNode);
      return;
    }
    else if (index === levelOfFocussedNode.length - 1) {
      /** index is set on last node of the level (therefore starts on first again) */
      index = 0;
    }
    else {
      index = Number(index) + 1;
    }
    this.setFocusedNodeByPath(levelOfFocussedNode[index].path);
    return this.updateActiveLevels();
  }
  mouseDown() {
    this.removeFocusOfNode();
    this.updateActiveLevels();
  }
  spacePressed() {
    if (!this._focussedNode) {
      this.initiateFocussedNode();
    }
    const newSelectionState = this._focussedNode.selectionState === 'checked' ? 'unchecked' : 'checked';
    this._selectionService.updateNodeStateInTree(this._tree, this._focussedNode.path, newSelectionState);
    this.updateSelection(this._focussedNode.path, newSelectionState);
    this.updateActiveLevels();
  }
  initiateFocussedNode() {
    const [firstNodeOfLastLevel] = getNodesByLevel(this.getLastActiveLevel());
    this.setFocusedNodeByPath(firstNodeOfLastLevel === null || firstNodeOfLastLevel === void 0 ? void 0 : firstNodeOfLastLevel.path);
  }
  /**
   * takes care of updating the references of class variables if a refresh/clone of the tree happened
   */
  refreshFocussedNodeReference() {
    if (this._focussedNode) {
      this._focussedNode = getNodeFromTreeByNodePath(this._tree, this._focussedNode.path);
    }
  }
  isFirstElementFocussed() {
    const currentActiveLevel = getNodesByLevel(this._activeLevels[this._activeLevels.length - 1]);
    return currentActiveLevel.indexOf(this._focussedNode) === 0 || !this._focussedNode;
  }
  resetFocus() {
    if (!this._focussedNode) {
      return;
    }
    this._focussedNode.focused = false;
    this._focussedNode = null;
    this.updateActiveLevels();
  }
  getLevelOfFocussedNode() {
    /** if no parent exists return current level
     * Returns the nodes of the treeLevel since the sorting is important here
     */
    const filteredActiveLevels = this.getActiveLevels();
    return getNodesByLevel(filteredActiveLevels[this._focussedNode.level]);
  }
  removeFocusOfNode() {
    if (this._focussedNode) {
      this._focussedNode.focused = false;
      this._focussedNode = null;
    }
  }
  setFocusedNodeByPath(nodePath) {
    if (this._focussedNode) {
      this._focussedNode.focused = false;
    }
    this._focussedNode = getNodeFromTreeByNodePath(this._tree, nodePath);
    this._focussedNode.focused = true;
  }
  /**
   * sets the active State of a Node by its NodePath (last element of NodePath is the effected Node)
   * @param path
   * @param active
   * @returns
   */
  async setActiveStateOfNodeByPath(path, active) {
    if (!this._tree) {
      return;
    }
    const effectedNode = getNodeFromTreeByNodePath(this._tree, path);
    if (!effectedNode || !effectedNode.hasChildren) {
      return;
    }
    const node = this.updateActiveStateOfNode(effectedNode, active);
    if (!node) {
      return;
    }
    if (this._filterService.filter) {
      // whenever children are loaded the search should be cleared
      this.onClearSearch();
    }
    if (active) {
      return this.loadChildrenOfNode(node).then(() => this.updateActiveLevels());
    }
    else {
      this.updateActiveLevels();
    }
  }
  /**
   * sets a level to inactive by setting its parent and all children to inactive
   * @param level
   */
  deactivateLevel(level) {
    if (!level.parentNode || !this._tree) {
      /** "level" is the only level left - cant be closed */
      return;
    }
    this.onClearSearch();
    const effectedNode = getNodeFromTreeByNodePath(this._tree, level.parentNode.path);
    if (!effectedNode) {
      return;
    }
    this.updateActiveStateOfNode(effectedNode, false);
    this.updateActiveLevels();
  }
  getLastActiveLevel() {
    return this._activeLevels[this._activeLevels.length - 1];
  }
  /**
   * updates the active Levels and notifies about a refresh of the activeLevels
   */
  updateActiveLevels() {
    if (!this._tree) {
      return;
    }
    this._activeLevels = getActiveLevels(this._tree);
    this._activeLevels = this._filterService.applyFilter(this._activeLevels);
    this.notifyCallback();
  }
  notifyCallback() {
    const filteredActiveLevels = this.getActiveLevels();
    Promise.resolve().then(() => this.onActiveChange(filteredActiveLevels));
  }
  mapNodesToMultiSelectorTreeNodes(nodes, parent) {
    const treeNodes = nodes.map((item) => {
      var _a;
      const itemLink = { id: item.id, label: item.label };
      return Object.assign(Object.assign({}, item), { path: parent ? [...parent.path, itemLink] : [itemLink], focused: false, active: false, hasChildren: (_a = item.hasChildren) !== null && _a !== void 0 ? _a : true, children: [], parent, level: parent ? parent.level + 1 : 0, selectionState: 'unchecked' });
    });
    if (parent) {
      parent.children = treeNodes;
      if (treeNodes.length === 0) {
        parent.hasChildren = false;
      }
    }
    return treeNodes;
  }
  /**
   * updates the active levels according to the given Path of the changed node
   * @param effectedNode represents the the node that is gonna change the node state
   * @param active the new state of the node (true=selected=open, false=unselected=close)
   * @returns reference to the selected node
   */
  updateActiveStateOfNode(effectedNode, active) {
    if (!this._tree) {
      return;
    }
    if (!effectedNode || effectedNode.active === active) {
      /** no change */
      return;
    }
    const clone = cloneNode(effectedNode);
    // node changes state from not selected(inactive) TO selected(active)
    if (clone.parent) {
      clone.parent.children = setAllNodesInTreeToInactive(clone.parent.children);
    }
    else {
      const isRootNode = this._tree.some((node) => node.id === clone.id);
      if (isRootNode) {
        this._tree = this._tree.map((child) => (child.id === clone.id ? clone : child));
        this._tree = setAllNodesInTreeToInactive(this._tree);
      }
    }
    clone.active = active && clone.hasChildren;
    this.refreshFocussedNodeReference();
    return clone;
  }
  /**
   * loads the children of a node if already loaded returns the loaded children
   * @param node
   * @returns
   */
  async loadChildrenOfNode(node) {
    if (!node) {
      return;
    }
    if (!node.hasChildren || node.children.length > 0) {
      /** Node has no Children OR the children where already loaded before */
      return node.children;
    }
    // hides the nodes that should no longer be visible while loading the next children
    this.updateActiveLevels();
    // the children are not yet loaded
    return this.handleLoadedNodes(this.dataSource.getChildren(node.id), node);
  }
  async handleLoadedNodes(nodes, parent) {
    return nodes
      .then((nodes) => this.mapNodesToMultiSelectorTreeNodes(nodes, parent))
      .then((children) => {
      //children = this._selectionService.setSelectionsInLevel(children);
      // if there is no parent, then the root nodes were loaded
      if (!parent) {
        this._tree = children;
      }
      else if (children.length > 0) {
        parent.children = children;
      }
      else {
        parent.hasChildren = false;
      }
      this._selectionService.updateTreeWithCurrentSelection(this._tree);
      return children;
    })
      .then((children) => {
      this.refreshFocussedNodeReference();
      return children;
    });
  }
  invokeAsync(func) {
    Promise.resolve().then(() => func());
  }
  get selections() {
    return this._selectionService.selections;
  }
}

const multiSelectorCss = "/*!\n *  Copyright (C) 2021 Robert Bosch GmbH Copyright (C) 2020 Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved.\n *//*!\n  *  Copyright (C) 2017 Robert Bosch GmbH Copyright (C) 2017 Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved.\n *//*!\n  *  Copyright (C) 2017 Robert Bosch GmbH Copyright (C) 2017 Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved.\n *//*!\n  *  Copyright (C) 2022 Robert Bosch GmbH Copyright (C) 2022 Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved.\n *//*!\n  *  Copyright (C) 2017 Robert Bosch GmbH Copyright (C) 2017 Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved.\n */@font-face{font-family:\"Bosch-Sans\";font-weight:400;src:url(\"..//fonts/BoschSans-Regular.eot\");src:url(\"..//fonts/BoschSans-Regular.eot?#iefix\") format(\"embedded-opentype\"), url(\"..//fonts/BoschSans-Regular.woff2\") format(\"woff2\"), url(\"..//fonts/BoschSans-Regular.woff\") format(\"woff\"), url(\"..//fonts/BoschSans-Regular.ttf\") format(\"truetype\"), url(\"..//fonts/BoschSans-RegularItalic.woff2\") format(\"woff2\"), url(\"..//fonts/BoschSans-RegularItalic.woff\") format(\"woff\"), url(\"..//fonts/BoschSans-RegularItalic.ttf\") format(\"truetype\"), url(\"..//fonts/BoschSans-Regular.svg#svgFontName\") format(\"svg\");}@font-face{font-family:\"Bosch-Sans\";font-weight:300;src:url(\"..//fonts/BoschSans-Light.eot\");src:url(\"..//fonts/BoschSans-Light.eot?#iefix\") format(\"embedded-opentype\"), url(\"..//fonts/BoschSans-Light.woff2\") format(\"woff2\"), url(\"..//fonts/BoschSans-Light.woff\") format(\"woff\"), url(\"..//fonts/BoschSans-Light.ttf\") format(\"truetype\"), url(\"..//fonts/BoschSans-LightItalic.woff2\") format(\"woff2\"), url(\"..//fonts/BoschSans-LightItalic.woff\") format(\"woff\"), url(\"..//fonts/BoschSans-LightItalic.ttf\") format(\"truetype\"), url(\"..//fonts/BoschSans-Light.svg#svgFontName\") format(\"svg\");}@font-face{font-family:\"Bosch-Sans\";font-weight:500;src:url(\"..//fonts/BoschSans-Medium.eot\");src:url(\"..//fonts/BoschSans-Medium.eot?#iefix\") format(\"embedded-opentype\"), url(\"..//fonts/BoschSans-Medium.woff2\") format(\"woff2\"), url(\"..//fonts/BoschSans-Medium.woff\") format(\"woff\"), url(\"..//fonts/BoschSans-Medium.ttf\") format(\"truetype\"), url(\"..//fonts/BoschSans-MediumItalic.woff2\") format(\"woff2\"), url(\"..//fonts/BoschSans-MediumItalic.woff\") format(\"woff\"), url(\"..//fonts/BoschSans-MediumItalic.ttf\") format(\"truetype\"), url(\"..//fonts/BoschSans-Medium.svg#svgFontName\") format(\"svg\");}@font-face{font-family:\"Bosch-Sans\";font-weight:700;src:url(\"..//fonts/BoschSans-Bold.eot\");src:url(\"..//fonts/BoschSans-Bold.eot?#iefix\") format(\"embedded-opentype\"), url(\"..//fonts/BoschSans-Bold.woff2\") format(\"woff2\"), url(\"..//fonts/BoschSans-Bold.woff\") format(\"woff\"), url(\"..//fonts/BoschSans-Bold.ttf\") format(\"truetype\"), url(\"..//fonts/BoschSans-BoldItalic.woff2\") format(\"woff2\"), url(\"..//fonts/BoschSans-BoldItalic.woff\") format(\"woff\"), url(\"..//fonts/BoschSans-BoldItalic.ttf\") format(\"truetype\"), url(\"..//fonts/BoschSans-Bold.svg#svgFontName\") format(\"svg\");}@font-face{font-family:\"Bosch-Sans\";font-weight:900;src:url(\"..//fonts/BoschSans-Black.eot\");src:url(\"..//fonts/BoschSans-Black.eot?#iefix\") format(\"embedded-opentype\"), url(\"..//fonts/BoschSans-Black.woff2\") format(\"woff2\"), url(\"..//fonts/BoschSans-Black.woff\") format(\"woff\"), url(\"..//fonts/BoschSans-Black.ttf\") format(\"truetype\"), url(\"..//fonts/BoschSans-BlackItalic.woff2\") format(\"woff2\"), url(\"..//fonts/BoschSans-BlackItalic.woff\") format(\"woff\"), url(\"..//fonts/BoschSans-BlackItalic.ttf\") format(\"truetype\"), url(\"..//fonts/BoschSans-Black.svg#svgFontName\") format(\"svg\");}@font-face{font-family:\"Bosch-Ic\";font-style:normal;font-stretch:normal;font-weight:normal;src:url(\"..//fonts/Bosch-Icon.eot?mh5qa9\");src:url(\"..//fonts/Bosch-Icon.eot?mh5qa9#iefix\") format(\"embedded-opentype\"), url(\"..//fonts/Bosch-Icon.ttf?mh5qa9\") format(\"truetype\"), url(\"..//fonts/Bosch-Icon.woff?mh5qa9\") format(\"woff\"), url(\"..//fonts/Bosch-Icon.svg?mh5qa9#Bosch-Icon\") format(\"svg\")}@font-face{font-family:\"Bosch-Sans-Condensed\";font-weight:300;src:url(\"..//fonts/BoschSansCond-Regular.otf\"), url(\"..//fonts/BoschSansCondensed-Regular.ttf\") format(\"truetype\"), url(\"..//fonts/BoschSansCondensed-RegularItalic.ttf\") format(\"truetype\")}@font-face{font-family:\"Bosch-Sans-Condensed\";font-weight:700;src:url(\"..//fonts/BoschSansCond-Bold.otf\"), url(\"..//fonts/BoschSansCondensed-Bold.ttf\") format(\"truetype\"), url(\"..//fonts/BoschSansCondensed-BoldItalic.ttf\") format(\"truetype\")}/*!\n  *  Copyright (C) 2017 Robert Bosch GmbH Copyright (C) 2017 Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved.\n *//*!\n  *  Copyright (C) 2018 Robert Bosch GmbH Copyright (C) 2018 Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved.\n *//*!\n  *  Copyright (C) 2019 Robert Bosch GmbH Copyright (C) 2019 Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved.\n *//*!\n  *  Copyright (C) 2017 Robert Bosch GmbH Copyright (C) 2017 Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved.\n *//*!\n  *  Copyright (C) 2017 Robert Bosch GmbH Copyright (C) 2017 Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved.\n *//*!\n  *  Copyright (C) 2017 Robert Bosch GmbH Copyright (C) 2017 Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved.\n *//*!\n  *  Copyright (C) 2017 Robert Bosch GmbH Copyright (C) 2017 Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved.\n *//*!\n  *  Copyright (C) 2017 Robert Bosch GmbH Copyright (C) 2017 Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved.\n *//*!\n  *  Copyright (C) 2017 Robert Bosch GmbH Copyright (C) 2017 Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved.\n *//*!\n  *  Copyright (C) 2019 Robert Bosch GmbH Copyright (C) 2019 Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved.\n *//*!\n  *  Copyright (C) 2017 Robert Bosch GmbH Copyright (C) 2017 Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved.\n *//*!\n  *  Copyright (C) 2017 Robert Bosch GmbH Copyright (C) 2017 Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved.\n *//*!\n  *  Copyright (C) 2018 Robert Bosch GmbH Copyright (C) 2018 Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved.\n *//*!\n  *  Copyright (C) 2017 Robert Bosch GmbH Copyright (C) 2017 Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved.\n *//*!\n  *  Copyright (C) 2022 Robert Bosch GmbH Copyright (C) 2022 Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved.\n *//*!\n  *  Copyright (C) 2017 Robert Bosch GmbH Copyright (C) 2017 Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved.\n *//*!\n  *  Copyright (C) 2017 Robert Bosch GmbH Copyright (C) 2017 Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved.\n *//*!\n  *  Copyright (C) 2017 Robert Bosch GmbH Copyright (C) 2017 Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved.\n *//*!\n  *  Copyright (C) 2018 Robert Bosch GmbH Copyright (C) 2018 Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved.\n *//*!\n  *  Copyright (C) 2017 Robert Bosch GmbH Copyright (C) 2017 Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved.\n *//*!\n  *  Copyright (C) 2017 Robert Bosch GmbH Copyright (C) 2017 Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved.\n *//*!\n  *  Copyright (C) 2017 Robert Bosch GmbH Copyright (C) 2017 Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved.\n *//*!\n  *  Copyright (C) 2018 Robert Bosch GmbH Copyright (C) 2018 Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved.\n *//*!\n  *  Copyright (C) 2017 Robert Bosch GmbH Copyright (C) 2017 Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved.\n *//*!\n  *  Copyright (C) 2022 Robert Bosch GmbH Copyright (C) 2022 Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved.\n *//*!\n  *  Copyright (C) 2017 Robert Bosch GmbH Copyright (C) 2017 Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved.\n *//*!\n  *  Copyright (C) 2017 Robert Bosch GmbH Copyright (C) 2017 Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved.\n *//*!\n  *  Copyright (C) 2017 Robert Bosch GmbH Copyright (C) 2017 Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved.\n *//*!\n  *  Copyright (C) 2017 Robert Bosch GmbH Copyright (C) 2017 Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved.\n *//*!\n  *  Copyright (C) 2017 Robert Bosch GmbH Copyright (C) 2017 Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved.\n *//*!\n  *  Copyright (C) 2017 Robert Bosch GmbH Copyright (C) 2017 Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved.\n *//*!\n  *  Copyright (C) 2017 Robert Bosch GmbH Copyright (C) 2017 Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved.\n *//*!\n  *  Copyright (C) 2022 Robert Bosch GmbH Copyright (C) 2022 Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved.\n *//*!\n  *  Copyright (C) 2018 Robert Bosch GmbH Copyright (C) 2018 Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved.\n *//*!\n  *  Copyright (C) 2017 Robert Bosch GmbH Copyright (C) 2017 Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved.\n *//*!\n  *  Copyright (C) 2017 Robert Bosch GmbH Copyright (C) 2017 Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved.\n *//*!\n  *  Copyright (C) 2017 Robert Bosch GmbH Copyright (C) 2017 Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved.\n *//*!\n  *  Copyright (C) 2017 Robert Bosch GmbH Copyright (C) 2017 Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved.\n *//*!\n  *  Copyright (C) 2017 Robert Bosch GmbH Copyright (C) 2017 Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved.\n *//*!\n  *  Copyright (C) 2017 Robert Bosch GmbH Copyright (C) 2017 Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved.\n *//*!\n  *  Copyright (C) 2019 Robert Bosch GmbH Copyright (C) 2019 Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved.\n *//*!\n  *  Copyright (C) 2019 Robert Bosch GmbH Copyright (C) 2019 Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved.\n *//*!\n  *  Copyright (C) 2019 Robert Bosch GmbH Copyright (C) 2019 Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved.\n *//*!\n  *  Copyright (C) 2019 Robert Bosch GmbH Copyright (C) 2019 Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved.\n *//*!\n  *  Copyright (C) 2019 Robert Bosch GmbH Copyright (C) 2019 Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved.\n *//*!\n  *  Copyright (C) 2017 Robert Bosch GmbH Copyright (C) 2017 Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved.\n *//*!\n  *  Copyright (C) 2020 Robert Bosch GmbH Copyright (C) 2020 Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved.\n *//*!\n  *  Copyright (C) 2017 Robert Bosch GmbH Copyright (C) 2017 Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved.\n *//*!\n  *  Copyright (C) 2022 Robert Bosch GmbH Copyright (C) 2022 Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved.\n *//*!\n  *  Copyright (C) 2017 Robert Bosch GmbH Copyright (C) 2017 Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved.\n *//*!\n  *  Copyright (C) 2022 Robert Bosch GmbH Copyright (C) 2022 Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved.\n *//*!\n  *  Copyright (C) 2023 Robert Bosch GmbH Copyright (C) 2023 Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved.\n */.flex-column{display:flex;flex-direction:column;box-sizing:border-box}.flex-row{display:flex;flex-direction:row;box-sizing:border-box}.flex-none{flex:0 0 auto}.flex-grow{flex:1 1 100%;height:100%}.flex-layout-start-strech{place-content:stretch flex-start;align-items:stretch}.flex-layout-center-center{place-content:center;align-items:center}.flex-fill{width:100%;box-sizing:border-box;max-width:100%}.flex-row-wrap{flex-flow:row wrap;box-sizing:border-box;display:flex}.flex-row-wrap.grow{flex:1 1 100%;max-width:100%}.flex-center{display:flex;justify-content:center;align-items:center}.flex-space-between{display:flex;justify-content:space-between;align-items:center}/*!\n  *  Copyright (C) 2017 Robert Bosch GmbH Copyright (C) 2017 Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved.\n */input{color:#000000;background-color:#e0e2e5;box-shadow:none;width:100%;min-width:160px;box-sizing:border-box;caret-color:#000000;cursor:auto;font-family:\"Bosch-Sans\";font-weight:400;font-size:16px;line-height:1.5;border-width:0px 0px 1px 0px;border-color:#000000;border-style:solid;-webkit-border-radius:0;-moz-border-radius:0;-ms-border-radius:0;border-radius:0;padding:12px 16px 11px 16px}input:hover:enabled,input:hover{background-color:#c1c7cc;box-shadow:none}input:hover:enabled~.label-top,input:hover~.label-top{background-color:#c1c7cc}input:hover:enabled::-moz-placeholder,input:hover::-moz-placeholder{color:#000000;font-family:\"Bosch-Sans\";font-weight:400;font-size:16px;line-height:1.5;opacity:0.5;transform:translateX(-0.5px)}input:hover:enabled:-ms-input-placeholder,input:hover:-ms-input-placeholder{color:#000000;opacity:0.5;font-family:\"Bosch-Sans\";font-weight:400;font-size:16px;line-height:1.5;transform:translateX(-0.5px)}input:hover:enabled::-webkit-input-placeholder,input:hover::-webkit-input-placeholder{color:#000000;opacity:0.5;font-family:\"Bosch-Sans\";font-weight:400;font-size:16px;line-height:1.5;transform:translateX(-0.5px)}input:hover:enabled::placeholder,input:hover::placeholder{color:#000000;opacity:0.5;font-family:\"Bosch-Sans\";font-weight:400;font-size:16px;line-height:1.5;transform:translateX(-0.5px)}input:hover:enabled label,input:hover label{background-color:#c1c7cc}input:active:enabled,input.active,input:active:enabled:hover,input.active:hover{background-color:#a4abb3;box-shadow:none}input:active:enabled~.label-top,input.active~.label-top,input:active:enabled:hover~.label-top,input.active:hover~.label-top{background-color:#a4abb3}input:active:enabled::-moz-placeholder,input.active::-moz-placeholder,input:active:enabled:hover::-moz-placeholder,input.active:hover::-moz-placeholder{color:#000000;font-family:\"Bosch-Sans\";font-weight:400;font-size:16px;line-height:1.5;opacity:0.5;transform:translateX(-0.5px)}input:active:enabled:-ms-input-placeholder,input.active:-ms-input-placeholder,input:active:enabled:hover:-ms-input-placeholder,input.active:hover:-ms-input-placeholder{color:#000000;opacity:0.5;font-family:\"Bosch-Sans\";font-weight:400;font-size:16px;line-height:1.5;transform:translateX(-0.5px)}input:active:enabled::-webkit-input-placeholder,input.active::-webkit-input-placeholder,input:active:enabled:hover::-webkit-input-placeholder,input.active:hover::-webkit-input-placeholder{color:#000000;opacity:0.5;font-family:\"Bosch-Sans\";font-weight:400;font-size:16px;line-height:1.5;transform:translateX(-0.5px)}input:active:enabled::placeholder,input.active::placeholder,input:active:enabled:hover::placeholder,input.active:hover::placeholder{color:#000000;opacity:0.5;font-family:\"Bosch-Sans\";font-weight:400;font-size:16px;line-height:1.5;transform:translateX(-0.5px)}input:active:enabled label,input.active label,input:active:enabled:hover label,input.active:hover label{background-color:#a4abb3}input:focus,input:focus:enabled,input:focus:hover,input:focus:enabled:hover{background-color:#d1e4ff;box-shadow:none}input:focus~.label-top,input:focus:enabled~.label-top,input:focus:hover~.label-top,input:focus:enabled:hover~.label-top{background-color:#d1e4ff}input:focus::-moz-placeholder,input:focus:enabled::-moz-placeholder,input:focus:hover::-moz-placeholder,input:focus:enabled:hover::-moz-placeholder{color:#000000;font-family:\"Bosch-Sans\";font-weight:400;font-size:16px;line-height:1.5;opacity:0.5;transform:translateX(-0.5px)}input:focus:-ms-input-placeholder,input:focus:enabled:-ms-input-placeholder,input:focus:hover:-ms-input-placeholder,input:focus:enabled:hover:-ms-input-placeholder{color:#000000;opacity:0.5;font-family:\"Bosch-Sans\";font-weight:400;font-size:16px;line-height:1.5;transform:translateX(-0.5px)}input:focus::-webkit-input-placeholder,input:focus:enabled::-webkit-input-placeholder,input:focus:hover::-webkit-input-placeholder,input:focus:enabled:hover::-webkit-input-placeholder{color:#000000;opacity:0.5;font-family:\"Bosch-Sans\";font-weight:400;font-size:16px;line-height:1.5;transform:translateX(-0.5px)}input:focus::placeholder,input:focus:enabled::placeholder,input:focus:hover::placeholder,input:focus:enabled:hover::placeholder{color:#000000;opacity:0.5;font-family:\"Bosch-Sans\";font-weight:400;font-size:16px;line-height:1.5;transform:translateX(-0.5px)}input:focus label,input:focus:enabled label,input:focus:hover label,input:focus:enabled:hover label{background-color:#d1e4ff}input:disabled,input:hover:disabled,input.disabled{color:#a4abb3;background-color:#e0e2e5;cursor:default;border-width:0px 0px 1px 0px;border-color:#a4abb3;border-style:solid;-webkit-border-radius:0;-moz-border-radius:0;-ms-border-radius:0;border-radius:0}input:disabled::-moz-placeholder,input:hover:disabled::-moz-placeholder,input.disabled::-moz-placeholder{color:#a4abb3;font-family:\"Bosch-Sans\";font-weight:400;font-size:16px;line-height:1.5;opacity:0.5;transform:translateX(-0.5px)}input:disabled:-ms-input-placeholder,input:hover:disabled:-ms-input-placeholder,input.disabled:-ms-input-placeholder{color:#a4abb3;opacity:0.5;font-family:\"Bosch-Sans\";font-weight:400;font-size:16px;line-height:1.5;transform:translateX(-0.5px)}input:disabled::-webkit-input-placeholder,input:hover:disabled::-webkit-input-placeholder,input.disabled::-webkit-input-placeholder{color:#a4abb3;opacity:0.5;font-family:\"Bosch-Sans\";font-weight:400;font-size:16px;line-height:1.5;transform:translateX(-0.5px)}input:disabled::placeholder,input:hover:disabled::placeholder,input.disabled::placeholder{color:#a4abb3;opacity:0.5;font-family:\"Bosch-Sans\";font-weight:400;font-size:16px;line-height:1.5;transform:translateX(-0.5px)}input:disabled~.label-top,input:hover:disabled~.label-top,input.disabled~.label-top{color:#a4abb3;cursor:not-allowed}input:disabled label,input:hover:disabled label,input.disabled label{background-color:#e0e2e5}input[readonly]{color:#a4abb3;background-color:#e0e2e5;cursor:default;border-width:0px 0px 1px 0px;border-color:#000000;border-style:solid;-webkit-border-radius:0;-moz-border-radius:0;-ms-border-radius:0;border-radius:0}input[readonly]::-moz-placeholder{color:#a4abb3;font-family:\"Bosch-Sans\";font-weight:400;font-size:16px;line-height:1.5;opacity:0.5;transform:translateX(-0.5px)}input[readonly]:-ms-input-placeholder{color:#a4abb3;opacity:0.5;font-family:\"Bosch-Sans\";font-weight:400;font-size:16px;line-height:1.5;transform:translateX(-0.5px)}input[readonly]::-webkit-input-placeholder{color:#a4abb3;opacity:0.5;font-family:\"Bosch-Sans\";font-weight:400;font-size:16px;line-height:1.5;transform:translateX(-0.5px)}input[readonly]::placeholder{color:#a4abb3;opacity:0.5;font-family:\"Bosch-Sans\";font-weight:400;font-size:16px;line-height:1.5;transform:translateX(-0.5px)}input[readonly]~.label-top{color:#a4abb3;cursor:not-allowed}input[readonly] label{background-color:#e0e2e5}input:focus{box-shadow:none;outline:0}input::-ms-expand{border:0;background-color:transparent}input::-moz-placeholder{color:#000000;font-family:\"Bosch-Sans\";font-weight:400;font-size:16px;line-height:1.5;opacity:0.5;transform:translateX(-0.5px)}input:-ms-input-placeholder{color:#000000;opacity:0.5;font-family:\"Bosch-Sans\";font-weight:400;font-size:16px;line-height:1.5;transform:translateX(-0.5px)}input::-webkit-input-placeholder{color:#000000;opacity:0.5;font-family:\"Bosch-Sans\";font-weight:400;font-size:16px;line-height:1.5;transform:translateX(-0.5px)}input::placeholder{color:#000000;opacity:0.5;font-family:\"Bosch-Sans\";font-weight:400;font-size:16px;line-height:1.5;transform:translateX(-0.5px)}input[type=number]{-moz-appearance:textfield}input::-webkit-outer-spin-button,input::-webkit-inner-spin-button{-webkit-appearance:none;margin:0}.search-input input{padding-right:44px}.search-input::after{font-family:\"Bosch-Ic\";content:\"\\e235\";font-size:24px;color:#000000;display:inline-block;position:relative;right:12px;bottom:14px;margin-left:-24px;z-index:1;pointer-events:none}textarea{color:#000000;background-color:#e0e2e5;box-shadow:none;width:100%;min-width:160px;box-sizing:border-box;caret-color:#000000;cursor:auto;font-family:\"Bosch-Sans\";font-weight:400;font-size:16px;line-height:1.5;border-width:0px 0px 1px 0px;border-color:#000000;border-style:solid;-webkit-border-radius:0;-moz-border-radius:0;-ms-border-radius:0;border-radius:0;padding:12px 16px 11px 16px;border-width:0px 0px 1px 0px;border-color:#000000;border-style:solid;-webkit-border-radius:0;-moz-border-radius:0;-ms-border-radius:0;border-radius:0;min-height:96px;resize:vertical}textarea:hover:enabled,textarea:hover{background-color:#c1c7cc;box-shadow:none}textarea:hover:enabled~.label-top,textarea:hover~.label-top{background-color:#c1c7cc}textarea:hover:enabled::-moz-placeholder,textarea:hover::-moz-placeholder{color:#000000;font-family:\"Bosch-Sans\";font-weight:400;font-size:16px;line-height:1.5;opacity:0.5;transform:translateX(-0.5px)}textarea:hover:enabled:-ms-input-placeholder,textarea:hover:-ms-input-placeholder{color:#000000;opacity:0.5;font-family:\"Bosch-Sans\";font-weight:400;font-size:16px;line-height:1.5;transform:translateX(-0.5px)}textarea:hover:enabled::-webkit-input-placeholder,textarea:hover::-webkit-input-placeholder{color:#000000;opacity:0.5;font-family:\"Bosch-Sans\";font-weight:400;font-size:16px;line-height:1.5;transform:translateX(-0.5px)}textarea:hover:enabled::placeholder,textarea:hover::placeholder{color:#000000;opacity:0.5;font-family:\"Bosch-Sans\";font-weight:400;font-size:16px;line-height:1.5;transform:translateX(-0.5px)}textarea:hover:enabled label,textarea:hover label{background-color:#c1c7cc}textarea:active:enabled,textarea.active,textarea:active:enabled:hover,textarea.active:hover{background-color:#a4abb3;box-shadow:none}textarea:active:enabled~.label-top,textarea.active~.label-top,textarea:active:enabled:hover~.label-top,textarea.active:hover~.label-top{background-color:#a4abb3}textarea:active:enabled::-moz-placeholder,textarea.active::-moz-placeholder,textarea:active:enabled:hover::-moz-placeholder,textarea.active:hover::-moz-placeholder{color:#000000;font-family:\"Bosch-Sans\";font-weight:400;font-size:16px;line-height:1.5;opacity:0.5;transform:translateX(-0.5px)}textarea:active:enabled:-ms-input-placeholder,textarea.active:-ms-input-placeholder,textarea:active:enabled:hover:-ms-input-placeholder,textarea.active:hover:-ms-input-placeholder{color:#000000;opacity:0.5;font-family:\"Bosch-Sans\";font-weight:400;font-size:16px;line-height:1.5;transform:translateX(-0.5px)}textarea:active:enabled::-webkit-input-placeholder,textarea.active::-webkit-input-placeholder,textarea:active:enabled:hover::-webkit-input-placeholder,textarea.active:hover::-webkit-input-placeholder{color:#000000;opacity:0.5;font-family:\"Bosch-Sans\";font-weight:400;font-size:16px;line-height:1.5;transform:translateX(-0.5px)}textarea:active:enabled::placeholder,textarea.active::placeholder,textarea:active:enabled:hover::placeholder,textarea.active:hover::placeholder{color:#000000;opacity:0.5;font-family:\"Bosch-Sans\";font-weight:400;font-size:16px;line-height:1.5;transform:translateX(-0.5px)}textarea:active:enabled label,textarea.active label,textarea:active:enabled:hover label,textarea.active:hover label{background-color:#a4abb3}textarea:focus,textarea:focus:enabled,textarea:focus:hover,textarea:focus:enabled:hover{background-color:#d1e4ff;box-shadow:none}textarea:focus~.label-top,textarea:focus:enabled~.label-top,textarea:focus:hover~.label-top,textarea:focus:enabled:hover~.label-top{background-color:#d1e4ff}textarea:focus::-moz-placeholder,textarea:focus:enabled::-moz-placeholder,textarea:focus:hover::-moz-placeholder,textarea:focus:enabled:hover::-moz-placeholder{color:#000000;font-family:\"Bosch-Sans\";font-weight:400;font-size:16px;line-height:1.5;opacity:0.5;transform:translateX(-0.5px)}textarea:focus:-ms-input-placeholder,textarea:focus:enabled:-ms-input-placeholder,textarea:focus:hover:-ms-input-placeholder,textarea:focus:enabled:hover:-ms-input-placeholder{color:#000000;opacity:0.5;font-family:\"Bosch-Sans\";font-weight:400;font-size:16px;line-height:1.5;transform:translateX(-0.5px)}textarea:focus::-webkit-input-placeholder,textarea:focus:enabled::-webkit-input-placeholder,textarea:focus:hover::-webkit-input-placeholder,textarea:focus:enabled:hover::-webkit-input-placeholder{color:#000000;opacity:0.5;font-family:\"Bosch-Sans\";font-weight:400;font-size:16px;line-height:1.5;transform:translateX(-0.5px)}textarea:focus::placeholder,textarea:focus:enabled::placeholder,textarea:focus:hover::placeholder,textarea:focus:enabled:hover::placeholder{color:#000000;opacity:0.5;font-family:\"Bosch-Sans\";font-weight:400;font-size:16px;line-height:1.5;transform:translateX(-0.5px)}textarea:focus label,textarea:focus:enabled label,textarea:focus:hover label,textarea:focus:enabled:hover label{background-color:#d1e4ff}textarea:disabled,textarea:hover:disabled,textarea.disabled{color:#a4abb3;background-color:#e0e2e5;cursor:default;border-width:0px 0px 1px 0px;border-color:#a4abb3;border-style:solid;-webkit-border-radius:0;-moz-border-radius:0;-ms-border-radius:0;border-radius:0}textarea:disabled::-moz-placeholder,textarea:hover:disabled::-moz-placeholder,textarea.disabled::-moz-placeholder{color:#a4abb3;font-family:\"Bosch-Sans\";font-weight:400;font-size:16px;line-height:1.5;opacity:0.5;transform:translateX(-0.5px)}textarea:disabled:-ms-input-placeholder,textarea:hover:disabled:-ms-input-placeholder,textarea.disabled:-ms-input-placeholder{color:#a4abb3;opacity:0.5;font-family:\"Bosch-Sans\";font-weight:400;font-size:16px;line-height:1.5;transform:translateX(-0.5px)}textarea:disabled::-webkit-input-placeholder,textarea:hover:disabled::-webkit-input-placeholder,textarea.disabled::-webkit-input-placeholder{color:#a4abb3;opacity:0.5;font-family:\"Bosch-Sans\";font-weight:400;font-size:16px;line-height:1.5;transform:translateX(-0.5px)}textarea:disabled::placeholder,textarea:hover:disabled::placeholder,textarea.disabled::placeholder{color:#a4abb3;opacity:0.5;font-family:\"Bosch-Sans\";font-weight:400;font-size:16px;line-height:1.5;transform:translateX(-0.5px)}textarea:disabled~.label-top,textarea:hover:disabled~.label-top,textarea.disabled~.label-top{color:#a4abb3;cursor:not-allowed}textarea:disabled label,textarea:hover:disabled label,textarea.disabled label{background-color:#e0e2e5}textarea[readonly]{color:#a4abb3;background-color:#e0e2e5;cursor:default;border-width:0px 0px 1px 0px;border-color:#000000;border-style:solid;-webkit-border-radius:0;-moz-border-radius:0;-ms-border-radius:0;border-radius:0}textarea[readonly]::-moz-placeholder{color:#a4abb3;font-family:\"Bosch-Sans\";font-weight:400;font-size:16px;line-height:1.5;opacity:0.5;transform:translateX(-0.5px)}textarea[readonly]:-ms-input-placeholder{color:#a4abb3;opacity:0.5;font-family:\"Bosch-Sans\";font-weight:400;font-size:16px;line-height:1.5;transform:translateX(-0.5px)}textarea[readonly]::-webkit-input-placeholder{color:#a4abb3;opacity:0.5;font-family:\"Bosch-Sans\";font-weight:400;font-size:16px;line-height:1.5;transform:translateX(-0.5px)}textarea[readonly]::placeholder{color:#a4abb3;opacity:0.5;font-family:\"Bosch-Sans\";font-weight:400;font-size:16px;line-height:1.5;transform:translateX(-0.5px)}textarea[readonly]~.label-top{color:#a4abb3;cursor:not-allowed}textarea[readonly] label{background-color:#e0e2e5}textarea:focus{box-shadow:none;outline:0}textarea::-ms-expand{border:0;background-color:transparent}textarea::-moz-placeholder{color:#000000;font-family:\"Bosch-Sans\";font-weight:400;font-size:16px;line-height:1.5;opacity:0.5;transform:translateX(-0.5px)}textarea:-ms-input-placeholder{color:#000000;opacity:0.5;font-family:\"Bosch-Sans\";font-weight:400;font-size:16px;line-height:1.5;transform:translateX(-0.5px)}textarea::-webkit-input-placeholder{color:#000000;opacity:0.5;font-family:\"Bosch-Sans\";font-weight:400;font-size:16px;line-height:1.5;transform:translateX(-0.5px)}textarea::placeholder{color:#000000;opacity:0.5;font-family:\"Bosch-Sans\";font-weight:400;font-size:16px;line-height:1.5;transform:translateX(-0.5px)}textarea[type=number]{-moz-appearance:textfield}textarea::-webkit-outer-spin-button,textarea::-webkit-inner-spin-button{-webkit-appearance:none;margin:0}input.valid,textarea.valid,select.valid{border-color:#00884a}input.warning,textarea.warning,select.warning{border-color:#ffcf00}input.invalid,input.error,textarea.invalid,textarea.error,select.invalid,select.error{border-color:#ed0007}.form-group{position:relative}.form-group input:first-child,.form-group textarea:first-child,.form-group select:first-child,.form-group .dropdown:first-child{padding:20px 16px 3px 16px}.form-group input:first-child:last-child,.form-group textarea:first-child:last-child,.form-group select:first-child:last-child,.form-group .dropdown:first-child:last-child{padding:12px 16px 11px 16px}.form-group.form-field-numeric .bosch-ic-clickable{position:absolute;top:12px;cursor:pointer}.form-group.form-field-numeric .bosch-ic-clickable:first-of-type+.bosch-ic-clickable{right:12px}.form-group.form-field-numeric .bosch-ic-clickable:first-of-type{right:60px}.form-group.form-field-numeric .label-top{width:calc(100% - 112px)}.form-group.form-field-numeric input{padding-right:106px}.form-group.form-field-numeric input:disabled~.bosch-ic-clickable{cursor:default}.form-group.form-field-numeric input:disabled~.bosch-ic-clickable,.form-group.form-field-numeric input:disabled~.bosch-ic-clickable:active,.form-group.form-field-numeric input:disabled~.bosch-ic-clickable:hover{color:#a4abb3}.form-group.form-field-numeric input:nth-last-child(3){padding:12px 16px 11px 16px;padding-right:106px}.form-group div.hint,.form-group div.valid,.form-group div.error,.form-group div.warning,.form-group span.hint,.form-group span.valid,.form-group span.error,.form-group span.warning,.form-group p.hint,.form-group p.valid,.form-group p.error,.form-group p.warning{font-size:12px;padding:8px 16px;font-weight:500}.form-group div.valid,.form-group span.valid,.form-group p.valid{color:#00884a}.form-group div.warning,.form-group span.warning,.form-group p.warning{color:#ffcf00}.form-group div.error,.form-group span.error,.form-group p.error{color:#ed0007}@-moz-document url-prefix(){.form-group{position:relative}.form-group input:first-child,.form-group textarea:first-child,.form-group select:first-child,.form-group .dropdown:first-child{padding:20px 16px 3px 16px}.form-group input:first-child:last-child,.form-group textarea:first-child:last-child,.form-group select:first-child:last-child,.form-group .dropdown:first-child:last-child{padding:12px 16px 11px 16px}.form-group select:first-child{padding-left:13px}.form-group.form-field-numeric .bosch-ic-clickable{position:absolute;top:12px;cursor:pointer}.form-group.form-field-numeric .bosch-ic-clickable:first-of-type+.bosch-ic-clickable{right:12px}.form-group.form-field-numeric .bosch-ic-clickable:first-of-type{right:60px}.form-group.form-field-numeric .label-top{width:calc(100% - 112px)}.form-group.form-field-numeric input{padding-right:106px}.form-group.form-field-numeric input:disabled~.bosch-ic-clickable{cursor:default}.form-group.form-field-numeric input:disabled~.bosch-ic-clickable,.form-group.form-field-numeric input:disabled~.bosch-ic-clickable:active,.form-group.form-field-numeric input:disabled~.bosch-ic-clickable:hover{color:#a4abb3}.form-group.form-field-numeric input:nth-last-child(3){padding:12px 16px 11px 16px;padding-right:106px}}.dark-background input{background-color:#ffffff}.dark-background input:active:enabled,.dark-background input.active,.dark-background input:focus:enabled{background-color:#eff1f2}.dark-background input:active:enabled~.label-top,.dark-background input.active~.label-top,.dark-background input:focus:enabled~.label-top{background-color:#eff1f2}.dark-background textarea{background-color:#ffffff}.dark-background textarea:active:enabled,.dark-background textarea.active,.dark-background textarea:focus:enabled{background-color:#eff1f2}.dark-background textarea:active:enabled~.label-top,.dark-background textarea.active~.label-top,.dark-background textarea:focus:enabled~.label-top{background-color:#eff1f2}/*!\n  *  Copyright (C) 2017 Robert Bosch GmbH Copyright (C) 2017 Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved.\n */.clickable-element{transition:0.4s;cursor:pointer}.clickable-element:active,.clickable-element.active{color:#007bc0}.clickable-element:active:hover,.clickable-element:hover .clickable-element:focus{color:#9dc9ff}.clickable-element:disabled,.clickable-element.disabled{color:#a4abb3}.clickable-element:disabled:active,.clickable-element:disabled.active,.clickable-element:disabled:active:hover,.clickable-element:disabled:hover,.clickable-element.disabled:active,.clickable-element.disabled.active,.clickable-element.disabled:active:hover,.clickable-element.disabled:hover{color:#a4abb3}button.button-primary,button.button-default,input.button-primary,input.button-default{color:#ffffff;font-family:\"Bosch-Sans\";font-weight:400;font-size:16px;height:48px;padding:0px 16px;display:inline-flex;justify-content:center;align-items:center;gap:8px;cursor:pointer;width:auto;background-color:#007bc0;background-size:100% 200%;border-width:0;border-color:transparent;border-style:solid;-webkit-border-radius:0;-moz-border-radius:0;-ms-border-radius:0;border-radius:0}button.button-primary:hover,button.button-primary:focus-visible,button.button-default:hover,button.button-default:focus-visible,input.button-primary:hover,input.button-primary:focus-visible,input.button-default:hover,input.button-default:focus-visible{background-color:#00629a;color:#ffffff;outline:0}button.button-primary:active,button.button-default:active,input.button-primary:active,input.button-default:active{background-color:#004975;color:#ffffff;outline:0}button.button-primary:disabled,button.button-primary.disabled,button.button-default:disabled,button.button-default.disabled,input.button-primary:disabled,input.button-primary.disabled,input.button-default:disabled,input.button-default.disabled{background-color:#c1c7cc;color:#656a6f;background-image:none;cursor:default}button.button-primary.button-lg,button.button-default.button-lg,input.button-primary.button-lg,input.button-default.button-lg{font-family:\"Bosch-Sans\";font-weight:400;font-size:20px;height:48px;padding:0 24px 0 24px;display:inline-flex;justify-content:center;align-items:center;gap:8px;cursor:pointer;width:auto}button.button-primary.button-sm,button.button-default.button-sm,input.button-primary.button-sm,input.button-default.button-sm{font-family:\"Bosch-Sans\";font-weight:400;font-size:12px;height:48px;padding:0 12px 0 12px;display:inline-flex;justify-content:center;align-items:center;gap:8px;cursor:pointer;width:auto}button.button-primary.button-xs,button.button-default.button-xs,input.button-primary.button-xs,input.button-default.button-xs{font-family:\"Bosch-Sans\";font-weight:400;font-size:10px;height:48px;padding:0 12px 0 12px;display:inline-flex;justify-content:center;align-items:center;gap:8px;cursor:pointer;width:auto}button.button-primary:not(.mat-icon-button):has(mat-icon),button.button-default:not(.mat-icon-button):has(mat-icon),input.button-primary:not(.mat-icon-button):has(mat-icon),input.button-default:not(.mat-icon-button):has(mat-icon){padding:0px 16px 0px 14px}button.button-primary.mat-icon-button,button.button-default.mat-icon-button,input.button-primary.mat-icon-button,input.button-default.mat-icon-button{padding:12px}button.button-secondary,input.button-secondary{color:#007bc0;background-color:transparent;font-family:\"Bosch-Sans\";font-weight:400;font-size:16px;height:48px;padding:0px 15px;display:inline-flex;justify-content:center;align-items:center;gap:8px;cursor:pointer;width:auto;border-width:1px;border-color:#007bc0;border-style:solid;-webkit-border-radius:0;-moz-border-radius:0;-ms-border-radius:0;border-radius:0}button.button-secondary:hover,button.button-secondary:focus-visible,input.button-secondary:hover,input.button-secondary:focus-visible{border-color:#004975;outline:0;color:#004975;background-color:#d1e4ff;border-width:1px;border-color:#004975;border-style:solid;-webkit-border-radius:0;-moz-border-radius:0;-ms-border-radius:0;border-radius:0}button.button-secondary:active,input.button-secondary:active{border-color:#004975;color:#004975;outline:0;background-color:#9dc9ff;border-width:1px;border-color:#004975;border-style:solid;-webkit-border-radius:0;-moz-border-radius:0;-ms-border-radius:0;border-radius:0}button.button-secondary:disabled,button.button-secondary.disabled,input.button-secondary:disabled,input.button-secondary.disabled{color:#979ea4;border-color:#979ea4;background-color:transparent;cursor:default}button.button-secondary.button-lg,input.button-secondary.button-lg{font-family:\"Bosch-Sans\";font-weight:400;font-size:20px;height:48px;padding:0 24px 0 24px;display:inline-flex;justify-content:center;align-items:center;gap:8px;cursor:pointer;width:auto}button.button-secondary.button-sm,input.button-secondary.button-sm{font-family:\"Bosch-Sans\";font-weight:400;font-size:12px;height:48px;padding:0 12px 0 12px;display:inline-flex;justify-content:center;align-items:center;gap:8px;cursor:pointer;width:auto}button.button-secondary.button-xs,input.button-secondary.button-xs{font-family:\"Bosch-Sans\";font-weight:400;font-size:10px;height:48px;padding:0 12px 0 12px;display:inline-flex;justify-content:center;align-items:center;gap:8px;cursor:pointer;width:auto}button.button-secondary:not(.mat-icon-button):has(mat-icon),input.button-secondary:not(.mat-icon-button):has(mat-icon){padding:0 15px 0 13px}button.button-secondary.mat-icon-button,input.button-secondary.mat-icon-button{padding:11px}button.button-tertiary,input.button-tertiary{color:#007bc0;background-color:transparent;font-family:\"Bosch-Sans\";font-weight:400;font-size:16px;height:48px;padding:0px 16px;display:inline-flex;justify-content:center;align-items:center;gap:8px;cursor:pointer;width:auto;border-style:none}button.button-tertiary:hover,button.button-tertiary:focus-visible,input.button-tertiary:hover,input.button-tertiary:focus-visible{outline:0;color:#00629a;background-color:#d1e4ff}button.button-tertiary:active,input.button-tertiary:active{color:#004975;background-color:#9dc9ff;outline:0}button.button-tertiary:disabled,button.button-tertiary.disabled,input.button-tertiary:disabled,input.button-tertiary.disabled{color:#979ea4;background-color:transparent;cursor:default}button.button-tertiary.button-lg,input.button-tertiary.button-lg{font-family:\"Bosch-Sans\";font-weight:400;font-size:20px;height:48px;padding:0 24px 0 24px;display:inline-flex;justify-content:center;align-items:center;gap:8px;cursor:pointer;width:auto}button.button-tertiary.button-sm,input.button-tertiary.button-sm{font-family:\"Bosch-Sans\";font-weight:400;font-size:12px;height:48px;padding:0 12px 0 12px;display:inline-flex;justify-content:center;align-items:center;gap:8px;cursor:pointer;width:auto}button.button-tertiary.button-xs,input.button-tertiary.button-xs{font-family:\"Bosch-Sans\";font-weight:400;font-size:10px;height:48px;padding:0 12px 0 12px;display:inline-flex;justify-content:center;align-items:center;gap:8px;cursor:pointer;width:auto}button.button-tertiary:not(.mat-icon-button):has(mat-icon),input.button-tertiary:not(.mat-icon-button):has(mat-icon){padding:0px 16px 0px 14px}button.button-tertiary.mat-icon-button,input.button-tertiary.mat-icon-button{padding:12px}button.button-integrated,input.button-integrated{color:#000000;background-color:transparent;font-family:\"Bosch-Sans\";font-weight:400;font-size:16px;height:48px;padding:0px 16px;display:inline-flex;justify-content:center;align-items:center;gap:8px;cursor:pointer;width:auto;border-style:none}button.button-integrated:hover,button.button-integrated:focus-visible,input.button-integrated:hover,input.button-integrated:focus-visible{color:#007bc0;outline:0}button.button-integrated:active,input.button-integrated:active{color:#00629a;outline:0}button.button-integrated:disabled,button.button-integrated.disabled,input.button-integrated:disabled,input.button-integrated.disabled{color:#979ea4 !important;background-color:transparent;cursor:default}button.button-integrated:not(.mat-icon-button):has(mat-icon),input.button-integrated:not(.mat-icon-button):has(mat-icon){padding:0px 16px 0px 14px}button.button-integrated.mat-icon-button,input.button-integrated.mat-icon-button{padding:12px}button.button-link,input.button-link{color:#007bc0;background-color:transparent;border:none;-webkit-box-shadow:none;box-shadow:none;font-family:\"Bosch-Sans\";font-weight:400;font-size:16px;height:48px;padding:0 16px 0 16px;display:inline-flex;justify-content:center;align-items:center;gap:8px;cursor:pointer;width:auto}button.button-link::after,input.button-link::after{position:absolute;font-family:\"Bosch-Ic\";font-style:normal;font-weight:normal;font-size:18px;content:\"\\e181\";-webkit-font-smoothing:antialiased;-moz-osx-font-smoothing:grayscale}button.button-link:hover,button.button-link:focus-visible,input.button-link:hover,input.button-link:focus-visible{color:#00629a;text-decoration:underline;outline:0}button.button-link:active,input.button-link:active{color:#004975;text-decoration:underline}button.button-link.disabled,button.button-link[disabled],button.button-link fieldset[disabled],input.button-link.disabled,input.button-link[disabled],input.button-link fieldset[disabled]{color:#c1c7cc;text-decoration:none;-webkit-transition:none;-o-transition:none;transition:none}button.button-link.disabled::after,button.button-link[disabled]::after,button.button-link fieldset[disabled]::after,input.button-link.disabled::after,input.button-link[disabled]::after,input.button-link fieldset[disabled]::after{-webkit-transform:translate(0, 0);-ms-transform:translate(0, 0);-o-transform:translate(0, 0);transform:translate(0, 0)}button.button-link.button-lg,input.button-link.button-lg{font-family:\"Bosch-Sans\";font-weight:400;font-size:20px;height:48px;padding:0 24px 0 24px;display:inline-flex;justify-content:center;align-items:center;gap:8px;cursor:pointer;width:auto}button.button-link.button-lg::after,input.button-link.button-lg::after{font-size:22px}button.button-link.button-sm,input.button-link.button-sm{font-family:\"Bosch-Sans\";font-weight:400;font-size:14px;height:48px;padding:0 12px 0 12px;display:inline-flex;justify-content:center;align-items:center;gap:8px;cursor:pointer;width:auto}button.button-link.button-sm::after,input.button-link.button-sm::after{font-size:14px}button.button-link.no-arrow::after,input.button-link.no-arrow::after{content:\"\"}button.button-link:not(.mat-icon-button):has(mat-icon),input.button-link:not(.mat-icon-button):has(mat-icon){padding:0px 16px 0px 14px}button.button-link.mat-icon-button,input.button-link.mat-icon-button{padding:12px}button.button-block,input[type=submit].button-block,input[type=reset].button-block,input[type=button].button-block{display:block;width:100%}/*!\n  *  Copyright (C) 2017 Robert Bosch GmbH Copyright (C) 2017 Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved.\n */label{font-family:\"Bosch-Sans\";font-weight:400;font-size:12px;line-height:1.5;color:#000000;display:inline;line-height:18px;padding:0 16px 0 0}label.label-top{font-family:\"Bosch-Sans\";font-weight:400;font-size:12px;line-height:1.5;color:#000000;background-color:#e0e2e5;display:block}label.label-top:last-of-type{position:absolute;left:1px;top:1px;z-index:1;padding:4px 0 0 15px;margin:0;width:calc(100% - 48px);max-width:calc(100% - 48px);white-space:nowrap;overflow:hidden;text-overflow:ellipsis}label.label-top-disabled{color:#a4abb3;cursor:not-allowed}label.label-top-focused{background-color:#d1e4ff}.dark-background label.label-top{background-color:#ffffff}.dark-background label.label-top-focused{background-color:#eff1f2}/*!\n  *  Copyright (C) 2017 Robert Bosch GmbH Copyright (C) 2017 Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved.\n */body{margin:0;display:flex;flex-direction:column}main,*{font-family:\"Bosch-Sans\"}::selection,::-moz-selection{background-color:#007bc0}a::-moz-selection{color:#ffffff}.lead{margin-bottom:24px;font-size:18px;font-weight:300;line-height:1.4}@media (min-width: 768px){.lead{font-size:24px}}:host{display:block}";

const MultiSelector = /*@__PURE__*/ proxyCustomElement(class extends H {
  constructor() {
    super();
    this.__registerHost();
    this.__attachShadow();
    this.selectionFinished = createEvent(this, "selectionFinished", 7);
    this.selectionChanged = createEvent(this, "selectionChanged", 7);
    this.invalidSelection = createEvent(this, "invalidSelection", 7);
    /**
     * Mark this element to be shown on dark background (it will adapt styling). Default: false.
     */
    this.darkBackground = false;
    /** defines the mode of selection - if single, then is only 1 selection at a time possible (default multi) */
    this.selectionMode = 'multi';
    /** pre selection */
    this.initialSelection = [];
    /** Enforce single column mode, normally only used for smaller screens / selectors. */
    this.singleColumnMode = false;
    /** Prevents going into fullscreen / responsive mode on low resolutions. */
    this.preventFullscreen = false;
    /** state that keeps the focus as long as the user interacts with any component part of this multi selector (including overlay) */
    this.focused = false;
    this.searchValue = '';
    this.activeLevels = [];
    this.isLoading = false;
    this.enforceOverlayViewport = 'vp1';
    this.inputComponents = [];
    // to be turned into property in the future when implementing and offering that feature
    this.showSave = false;
    this.overlayVP1Config = {
      placement: 'none',
    };
    this.overlayVP2And3Config = {
      placement: 'bottom-start',
    };
    this.currentOverlayConfig = this.overlayVP1Config;
    this.overlayHandler = new OverlayHandler(true);
  }
  hideDialog() {
    if (this.focused) {
      this.handleOnFinish();
    }
  }
  onDataSourceUpdate() {
    this._dataSources = Array.isArray(this.dataSource) ? this.dataSource : [{ id: '', label: '', dataSource: this.dataSource }];
    this.selectedDataSource = this._dataSources[0];
    this.activeLevels = [];
    this.initiateTreeManager(this.selectedDataSource.dataSource);
  }
  onSelectionModeChange() {
    var _a, _b;
    (_a = this === null || this === void 0 ? void 0 : this.multiSelectorManager) === null || _a === void 0 ? void 0 : _a.resetSelection();
    (_b = this === null || this === void 0 ? void 0 : this.multiSelectorManager) === null || _b === void 0 ? void 0 : _b.updateSelectionMode(this.selectionMode);
  }
  onSearchChange(newSearch) {
    if (!!this.multiSelectorManager) {
      this.multiSelectorManager.resetFocus();
      this.multiSelectorManager.updateFilter(newSearch);
    }
  }
  onInitialSelectionChange(newInitialSelection) {
    this.multiSelectorManager.initiateSelections(newInitialSelection);
  }
  componentDidLoad() {
    this.setupHideOverlayListeners();
    this.setupWidthObserver();
    this.setupKeyListeners();
  }
  async componentWillLoad() {
    await setLocale();
    this.onDataSourceUpdate();
    this.multiSelectorManager.updateFilter(this.searchValue);
  }
  render() {
    // Order of input and other elements is important for proper background color when focused!
    return (h(Host, null, this.renderStandardInput(), h("bci-overlay", { ref: (el) => (this.overlayHandler.overlay = el), config: this.currentOverlayConfig }, h("bci-multi-selector-overlay", { tabindex: "0", ref: (el) => (this.overlayHandler.dialog = el), headerLabel: this.selectedDataSource.label, filterText: this.multiSelectorManager.getFilter(), showSave: this.showSave, enforceViewport: this.enforceOverlayViewport, activeLevels: this.activeLevels, resetSelectionButtonEnabled: this.multiSelectorManager.selections.length !== 0, onNavigateBack: () => this.handleNavigateBack(), onSelectionReset: () => this.handleResetSelection(), onSelectionFinished: () => this.handleOnFinish(), onNodeSelectionChange: (event) => this.handleNodeSelectionChange(event.detail), onNodeActiveChange: (event) => this.handleNodeActiveChange(event.detail), onClearSearch: () => this.handleClearSearch(), isLoading: this.isLoading }, h("div", { slot: "input-and-label" }, this.renderOverlayInput())))));
  }
  /**
   * @returns the standard Input component
   */
  renderStandardInput() {
    const isMultiSelectorHost = true;
    return this.renderInput(isMultiSelectorHost);
  }
  /**
   * @returns a rendered Input dedicated for the overlay component
   */
  renderOverlayInput() {
    const isMultiSelectorHost = false;
    return this.renderInput(isMultiSelectorHost);
  }
  renderInput(isMultiSelectorHost) {
    return (h("bci-multi-selector-input", { ref: (el) => (isMultiSelectorHost ? this.inputComponents.push((this.overlayHandler.host = el)) : this.inputComponents.push(el)), searchValue: this.searchValue, searchPlaceholder: translate('search'), selections: this.multiSelectorManager.selections, dataSources: this._dataSources, selectedDataSource: this.selectedDataSource, onSelectSearchType: (event) => this.handleOnSelectSearchType(event.detail), onFocusInput: () => isMultiSelectorHost && this.handleOnMultiSelectorInputFocus(), onSearchChange: (value) => (this.searchValue = value.detail), onClearSearch: () => this.handleClearSearch(), class: isMultiSelectorHost ? (this.focused ? ' focused' : '') + (this.darkBackground ? ' dark-background' : '') : '' }));
  }
  initiateTreeManager(dataSource) {
    this.multiSelectorManager = new MultiSelectorManager(dataSource, (activeLevels) => this.onActiveChangeObserverFunction(activeLevels), (selection) => this.selectionUpdateObserverFunction(Object.assign(Object.assign({}, selection), { rootId: this.selectedDataSource.id })), () => this.handleClearSearch(), (invalidNodes) => this.invalidSelection.emit({ invalidNodes }), (isLoading) => (this.isLoading = isLoading), this.initialSelection, this.selectionMode);
  }
  setupHideOverlayListeners() {
    this.overlayHandler.dialog.onclick = (ev) => {
      ev.stopPropagation();
    };
    this.overlayHandler.host.onclick = (ev) => {
      ev.stopPropagation();
    };
  }
  setupWidthObserver() {
    const setVp1 = () => {
      this.currentOverlayConfig = this.overlayVP1Config;
      this.enforceOverlayViewport = this.preventFullscreen ? 'vp2' : 'vp1';
    };
    const setVp2_3 = () => {
      this.currentOverlayConfig = this.overlayVP2And3Config;
      this.enforceOverlayViewport = this.singleColumnMode ? 'vp2' : undefined;
    };
    this.widthObserver = new WidthObserver(document.documentElement, {
      onVp1: this.preventFullscreen ? setVp2_3 : setVp1,
      onVp2: setVp2_3,
      onVp3: setVp2_3,
    }, false);
    this.widthObserver.connect();
  }
  setupKeyListeners() {
    this.setupOverlayKeyListener();
    this.setupSearchInputKeyListener();
  }
  setupSearchInputKeyListener() {
    this.inputKeyObserver = new KeyEventListener(null);
    this.inputKeyObserver.addListener('keyup', this.onMultiSelectorInputArrowDown.bind(this), 'ArrowDown');
  }
  onMultiSelectorInputArrowDown() {
    this.overlayKeyEventListener.active = true;
    this.inputKeyObserver.active = false;
    if (document.activeElement instanceof H) {
      document.activeElement.blur();
      this.overlayHandler.dialog.focus();
    }
    this.multiSelectorManager.arrowDownPressed();
  }
  onArrowUp() {
    var _a, _b;
    if (this.multiSelectorManager.isFirstElementFocussed()) {
      this.multiSelectorManager.resetFocus();
      if (this.enforceOverlayViewport === 'vp1') {
        (_a = this.inputComponents[1]) === null || _a === void 0 ? void 0 : _a.setFocusOnInputField();
      }
      else {
        (_b = this.inputComponents[0]) === null || _b === void 0 ? void 0 : _b.setFocusOnInputField();
      }
    }
    else {
      this.multiSelectorManager.arrowUpPressed();
    }
  }
  setupOverlayKeyListener() {
    this.overlayHandler.focusChangeObserver = (isFocussed) => {
      this.overlayKeyEventListener.active = isFocussed;
      this.inputKeyObserver.active = !isFocussed;
    };
    this.overlayKeyEventListener = new KeyEventListener(null);
    this.overlayKeyEventListener
      .addListener('keyup', this.onArrowUp.bind(this), 'ArrowUp')
      .addListener('keyup', this.multiSelectorManager.arrowRightPressed.bind(this.multiSelectorManager), 'ArrowRight')
      .addListener('keyup', this.multiSelectorManager.arrowDownPressed.bind(this.multiSelectorManager), 'ArrowDown')
      .addListener('keyup', this.multiSelectorManager.arrowLeftPressed.bind(this.multiSelectorManager), 'ArrowLeft')
      .addListener('keyup', this.multiSelectorManager.spacePressed.bind(this.multiSelectorManager), 'Space');
  }
  handleResetSelection() {
    var _a;
    (_a = this.multiSelectorManager) === null || _a === void 0 ? void 0 : _a.resetSelection();
  }
  handleNodeActiveChange(activeChangedEvent) {
    this.multiSelectorManager.setActiveStateOfNodeByPath(activeChangedEvent.path, activeChangedEvent.active);
  }
  handleNodeSelectionChange(selectionChangeEvent) {
    this.multiSelectorManager.setSelectionStateOfNodeByPath(selectionChangeEvent.path, selectionChangeEvent.newState);
  }
  handleNavigateBack() {
    const currentLevel = this.activeLevels[this.activeLevels.length - 1];
    this.multiSelectorManager.deactivateLevel(currentLevel);
  }
  handleOnSelectSearchType(rootNode) {
    this.selectedDataSource = rootNode;
    this.searchValue = '';
  }
  handleClearSearch() {
    this.searchValue = '';
  }
  handleOnFinish() {
    this.selectionFinished.emit({ selections: this.multiSelectorManager.selections, rootId: this.selectedDataSource.id });
    this.focused = false;
    this.overlayHandler.hide();
  }
  handleOnMultiSelectorInputFocus() {
    this.overlayHandler.show();
    this.focused = true;
    this.overlayKeyEventListener.active = false;
    this.inputKeyObserver.active = true;
  }
  selectionUpdateObserverFunction(event) {
    this.searchValue = '';
    this.selectionChanged.emit(event);
  }
  onActiveChangeObserverFunction(activeLevels) {
    this.activeLevels = activeLevels;
  }
  static get watchers() { return {
    "dataSource": ["onDataSourceUpdate"],
    "selectionMode": ["onSelectionModeChange"],
    "searchValue": ["onSearchChange"],
    "initialSelection": ["onInitialSelectionChange"]
  }; }
  static get style() { return multiSelectorCss; }
}, [1, "bci-multi-selector", {
    "darkBackground": [4, "dark-background"],
    "dataSource": [16],
    "selectionMode": [1, "selection-mode"],
    "initialSelection": [16],
    "singleColumnMode": [4, "single-column-mode"],
    "preventFullscreen": [4, "prevent-fullscreen"],
    "focused": [32],
    "selectedDataSource": [32],
    "searchValue": [32],
    "activeLevels": [32],
    "isLoading": [32],
    "enforceOverlayViewport": [32],
    "currentOverlayConfig": [32]
  }, [[16, "click", "hideDialog"]]]);
function defineCustomElement$1() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["bci-multi-selector", "bci-icon", "bci-loading-indicator", "bci-multi-selector-input", "bci-multi-selector-level", "bci-multi-selector-level-section", "bci-multi-selector-overlay", "bci-multi-selector-search-filter", "bci-multi-selector-search-label", "bci-multi-selector-tree", "bci-overlay", "checkbox-input"];
  components.forEach(tagName => { switch (tagName) {
    case "bci-multi-selector":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, MultiSelector);
      }
      break;
    case "bci-icon":
      if (!customElements.get(tagName)) {
        defineCustomElement$c();
      }
      break;
    case "bci-loading-indicator":
      if (!customElements.get(tagName)) {
        defineCustomElement$b();
      }
      break;
    case "bci-multi-selector-input":
      if (!customElements.get(tagName)) {
        defineCustomElement$a();
      }
      break;
    case "bci-multi-selector-level":
      if (!customElements.get(tagName)) {
        defineCustomElement$9();
      }
      break;
    case "bci-multi-selector-level-section":
      if (!customElements.get(tagName)) {
        defineCustomElement$8();
      }
      break;
    case "bci-multi-selector-overlay":
      if (!customElements.get(tagName)) {
        defineCustomElement$7();
      }
      break;
    case "bci-multi-selector-search-filter":
      if (!customElements.get(tagName)) {
        defineCustomElement$6();
      }
      break;
    case "bci-multi-selector-search-label":
      if (!customElements.get(tagName)) {
        defineCustomElement$5();
      }
      break;
    case "bci-multi-selector-tree":
      if (!customElements.get(tagName)) {
        defineCustomElement$4();
      }
      break;
    case "bci-overlay":
      if (!customElements.get(tagName)) {
        defineCustomElement$3();
      }
      break;
    case "checkbox-input":
      if (!customElements.get(tagName)) {
        defineCustomElement$2();
      }
      break;
  } });
}

const BciMultiSelector = MultiSelector;
const defineCustomElement = defineCustomElement$1;

export { BciMultiSelector, defineCustomElement };

