/* Copyright (C) 2023. Robert Bosch GmbH Copyright (C) 2023. Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved. */
import { p as proxyCustomElement, H, c as createEvent, h, b as Host } from './p-6fc5b736.js';

const headerIconMenuLinkComponentCss = "/*!\n *  Copyright (C) 2019 Robert Bosch GmbH Copyright (C) 2019 Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved.\n */@media screen and (max-width: 480px){.mdc-list-item__text.bci-portal-header-menu-list-item{text-overflow:ellipsis;white-space:nowrap;overflow:hidden}}";

const HeaderIconLinkComponent = /*@__PURE__*/ proxyCustomElement(class extends H {
  constructor() {
    super();
    this.__registerHost();
    this.headerNavItemClicked = createEvent(this, "bci.portal.header.navItemClicked", 7);
    this.url = '';
    this.text = '';
    this.external = false;
  }
  render() {
    return (h(Host, { "data-test": "webcore.webcomponents.header-icon-menu-link.component.navitem.list-item", class: "mdc-list-item", role: "menuitem", onClick: () => (this.external ? window.open(this.url, '_blank') : this.headerNavItemClicked.emit(this.url)) }, h("span", { class: "mdc-list-item__text bci-portal-header-menu-list-item" }, this.text)));
  }
  static get style() { return headerIconMenuLinkComponentCss; }
}, [0, "bci-portal-header-icon-link", {
    "url": [1],
    "text": [1],
    "external": [4]
  }]);
function defineCustomElement$1() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["bci-portal-header-icon-link"];
  components.forEach(tagName => { switch (tagName) {
    case "bci-portal-header-icon-link":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, HeaderIconLinkComponent);
      }
      break;
  } });
}

const BciPortalHeaderIconLink = HeaderIconLinkComponent;
const defineCustomElement = defineCustomElement$1;

export { BciPortalHeaderIconLink, defineCustomElement };

