/* Copyright (C) 2023. Robert Bosch GmbH Copyright (C) 2023. Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved. */
import { TimeStamp } from '../datetime-picker.interface';
export interface TemplateEvent {
  timeStamp: TimeStamp;
  firstEmit: boolean;
  id: string;
}
export interface DateChanged {
  reason: 'date';
  startDate: string;
  endDate?: string;
  rangeCompleted: boolean;
}
export interface TimeChanged {
  reason: 'time';
  timeStart: string;
  timeEnd?: string;
}
export interface FrameChanged {
  reason: 'frame';
  timestampStart: number;
  timestampEnd: number;
  firstEmit: boolean;
  id: string;
}
/**
 * Aggregated event that expresses a change within the dateTimePicker dialog
 */
export declare type SelectionChanged = DateChanged | TimeChanged | FrameChanged;

