/* Copyright (C) 2023. Robert Bosch GmbH Copyright (C) 2023. Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved. */
import { EventEmitter } from '../../../stencil-public-runtime';
import { Template, TemplateGroup } from '../datetime-picker.interface';
import { TemplateEvent } from '../model';
export declare class TemplateList {
  /**
   * Which time frames should be displayed
   */
  templatesList: Array<Template | TemplateGroup>;
  /**
   * Whether the templatesList should be visible.
   * Using this prop instead of traditional conditional rendering to preserve the state within this component.
   */
  visible: boolean;
  /**
   * Emits if the user clicks on the time range button
   */
  showTimeRanges: EventEmitter<void>;
  /**
   * Emits whenever the value of a time frame changes
   */
  templateUpdate: EventEmitter<TemplateEvent>;
  selectedTemplateId: string;
  private timerId;
  /**
   * Clears internal timer and resets selected template
   */
  reset(): Promise<void>;
  private clearTimer;
  private updateTemplate;
  private applyTemplate;
  render(): any;
}

