/* Copyright (C) 2023. Robert Bosch GmbH Copyright (C) 2023. Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved. */
export interface Facility {
  id: string;
  name: string;
  parentLocationId?: string;
  typeId: string;
  type: string;
  hasChildren?: boolean;
  checkedState?: CheckedState;
  selected?: boolean;
  checked?: boolean;
  indeterminate?: boolean;
  children?: Facility[];
}
export declare enum CheckedState {
  checked = 0,
  unchecked = 1,
  indeterminate = 2
}
export interface CheckedItemDetails {
  levelIndex: number;
  checkedPath: Facility[];
}
export interface SearchQuery {
  searchRoot: Facility;
  searchString: string;
}
export interface RecentSearchItem {
  checkedItemsByLevel: Facility[][];
}
export interface ColumnItemSelectedOrChecked {
  item: Facility;
  isSelectedOrChecked: boolean;
}
export interface ColumnConstructionResponse {
  columns: Facility[][];
  selectionPath: Facility[];
}

