/* Copyright (C) 2023. Robert Bosch GmbH Copyright (C) 2023. Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved. */
export declare enum NotificationClass {
  Information = "info",
  Error = "error",
  Warning = "warning",
  Success = "success"
}
export interface NotificationMessage {
  timeStamp: number;
  class: NotificationClass;
  title: string;
  description?: string;
  link?: string;
  isExpanded: boolean;
  isRead: boolean;
}
interface BaseMessagesController {
  getMessages(): Array<NotificationMessage>;
  determineClassColor(message: NotificationMessage): string;
  determineClassIcon(message: NotificationMessage): string;
}
export interface MenuMessagesController extends BaseMessagesController {
  updatePreviousMessage(message: NotificationMessage): NotificationMessage;
  openDialog(): void;
  dateToDayString(message: NotificationMessage): string;
}
export interface DialogMessagesController extends BaseMessagesController {
  dateToString(message: NotificationMessage): string;
  deleteMessages(): any;
  close(): any;
  updateMessage(message: NotificationMessage, updates: Object): any;
  openLink(url: string): any;
  setSearchString(url: string): any;
  setFilterString(url: string): any;
}
export {};

