/* Copyright (C) 2023. Robert Bosch GmbH Copyright (C) 2023. Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved. */
import { EventEmitter } from '../../../../stencil-public-runtime';
import { Level } from './model/multi-selector-level';
export declare class MultiSelectorLevel {
  /** nodes that gonna be shown within one level depth of the tree */
  level: Level;
  /** The label of the back button */
  backButtonLabel: string;
  /** This string is highlighted in the labels */
  highlight: string;
  /** Event to notify, when back button was clicked */
  navigateBack: EventEmitter<void>;
  onLevelChange(level: MultiSelectorLevel['level']): void;
  render(): any;
  /**
   * Function to check if a section has any items
   * returns true if any section of the level has an item
   * returns false if no section of the level has an item
   *
   * @returns boolean
   */
  private hasSectionsWithItems;
}

