/* Copyright (C) 2023. Robert Bosch GmbH Copyright (C) 2023. Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved. */
import { Node, NodePath, SelectionState } from '../../../model';
export interface MultiSelectorTreeNode extends Omit<Node, 'hasChildren'> {
  /**
   * also contains itself. Benefit: we can simple emit this array if the node is clicked
   */
  path: NodePath;
  focused: boolean;
  active: boolean;
  selectionState: SelectionState;
  hasChildren: boolean;
  children: MultiSelectorTreeNode[];
  level: number;
  parent?: MultiSelectorTreeNode;
}
export declare type MultiSelectorTree = MultiSelectorTreeNode[];

