/* Copyright (C) 2023. Robert Bosch GmbH Copyright (C) 2023. Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved. */
import { EventEmitter } from '../../../stencil-public-runtime';
import { RootNode } from '../model';
export declare class MultiSelectorSearchFilter {
  /** the list of searchTypes to choose out of within the dropdown */
  searchTypes?: RootNode[];
  /** the default searchType */
  defaultSearchType: RootNode;
  selectedSearchType: RootNode;
  open: boolean;
  closing: boolean;
  /** emits on search type selection a new rootNode the multi-selector displays the tree for */
  selectSearchType: EventEmitter<RootNode>;
  /** emits on search type click if it is disabled */
  clickDisabledSearchType: EventEmitter<void>;
  private menuElement;
  private mdcMenu;
  private handleMenuOpened;
  private handleMenuClosed;
  private handleMenuClosing;
  componentWillLoad(): Promise<void>;
  componentDidLoad(): void;
  disconnectedCallback(): void;
  handleNewSearchTypes(newValue: RootNode[]): void;
  handleNewDefaultSearchType(newValue: RootNode): void;
  render(): any;
  private toggleMenu;
  private handleToggleKeydown;
  private handleSelectSearchType;
  private renderDropdownMenu;
  private renderToggle;
  private renderSearchTypeOptions;
  private renderSearchTypeOption;
}

