/* Copyright (C) 2023. Robert Bosch GmbH Copyright (C) 2023. Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved. */
import { Key } from 'ts-key-enum';
export declare type KnownKeyCodes = keyof typeof Key;
declare type Callback = () => void;
export declare type Listeners = Record<string, Callback>;
export declare type ListenerOfKnownKeyCodes = Record<KnownKeyCodes, Callback>;
export declare class KeyObserver {
  private listeners;
  active: boolean;
  addListener(key: KnownKeyCodes, callback: Callback): this;
  addListener(key: string, callback: Callback): this;
  removeListener(key: KnownKeyCodes): this;
  removeListener(key: string): this;
  notify(key: KnownKeyCodes | string): void;
}
export {};

