/* Copyright (C) 2023. Robert Bosch GmbH Copyright (C) 2023. Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved. */
/// <reference types="jest" />
import { Node, RootDataSource } from './model/multi-selector.interface';
import { LevelSection } from './multi-selector-overlay/multi-selector-level-section/model/multi-selector-level-section';
import { Level } from './multi-selector-overlay/multi-selector-level/model/multi-selector-level';
import { MultiSelectorTreeNode } from './multi-selector-overlay/multi-selector-tree/model';
/**
 * uniform function to create a node for e2e testing
 * @param props
 * @returns
 */
export declare function createNode(props?: Partial<MultiSelectorTreeNode>): MultiSelectorTreeNode;
/**
 * uniform function to create a node for e2e testing
 * @param props
 * @returns
 */
export declare function createLevelSection(props?: Partial<LevelSection>): LevelSection;
/**
 * uniform function to create a node for e2e testing
 * @param props
 * @returns
 */
export declare function createLevel(props?: Partial<Level>): Level;
export declare function createDataSourceMock(): {
  dataSource: RootDataSource;
  getChildren: MockFunction<(nodeId: string) => Promise<Node[]>>;
  getRoots: MockFunction<() => Promise<Node[]>>;
};
export declare function createGetChildrenMock(): MockFunction<(nodeId: string) => Promise<Node[]>>;
export declare function createGetRootMock(): MockFunction<() => Promise<Node[]>>;
declare type AnyFunction = (...args: never[]) => unknown;
export declare type MockFunction<T extends AnyFunction> = jest.Mock<ReturnType<T>, jest.ArgsType<T>>;
export declare function mockFunction<T extends AnyFunction>(_fn?: T): MockFunction<T>;
export declare function populateDataSourceMock(getRootsMock: MockFunction<RootDataSource['getRoots']>, getChildrenMock: MockFunction<RootDataSource['getChildren']>, data: NodeWithChildren[]): void;
export declare function extractResolveFromPromise<T>(): {
  promise: Promise<T>;
  resolve: (value: T | PromiseLike<T>) => void;
};
export declare function getRoots(tree: NodeWithChildren[]): Node[];
export declare function getChildren(parentId: string, tree: NodeWithChildren[]): Node[];
export interface NodeWithChildren extends Node {
  children?: NodeWithChildren[];
}
export declare const nodesPerLevel = 3;
/**
 * was used to generate the test data set. the parameter was [3,1,2]
 * @param depths
 * @returns
 */
export declare function generateMockData(depths: number[]): NodeWithChildren[];
export declare function getMockData(): NodeWithChildren[];
export {};

