/* Copyright (C) 2023. Robert Bosch GmbH Copyright (C) 2023. Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved. */
import { EventEmitter } from '../../../stencil-public-runtime';
import { SidebarNavItem } from '../../../interfaces/navigation.interface';
import { ExpanderIcon } from '../expander-icon';
export declare class NavigationItemComponent {
  /**
   * controls whether window path has hash navigations
   */
  hashNavigation: boolean;
  item: SidebarNavItem;
  expanderIcon: ExpanderIcon;
  navigationClosed: boolean;
  expanded: boolean;
  navigationItemExpanded: EventEmitter<SidebarNavItem>;
  navigationItemClicked: EventEmitter<SidebarNavItem>;
  handlePopStateEvent(): void;
  watchNavigationClosed(newValue: boolean): void;
  watchItem(newValue: SidebarNavItem): void;
  /**
   * Popstate is sometimes not triggered on page initialization. With this methiod
   * it is ensured that active and expanded state of navigation item are set.
   */
  componentWillLoad(): void;
  private pathMatch;
  /**
   * Navigation item is clicked. Expanded state is changed and a event for clicked or expanded is emitted.
   * The expanded state has to be changed because the watcher does not get this information.
   */
  private selectItem;
  /**
   * Change active state of navigation item and rerender.
   *
   * @param active new active state
   */
  private setActive;
  /**
   * Add class bci-portal-navigation-item-expandable to host element to enable expand icon rotation if expanded.
   *
   * @returns class list
   */
  private navigationItemExpandedClass;
  /**
   * Navigation item class list. Contains
   * - bci-portal-navigation-item-active to highlight if the item (or any child item if collapsed) is active
   * - bci-portal-navigation-item-has-childs to make the background of active child elements darker
   *
   * @returns class list
   */
  private navigationItemClass;
  /**
   * Class list for the div which contains the text paragraph.
   *
   * @returns class list
   */
  private navigationItemTextClass;
  private navigationPath;
  render(): any;
}

