/* Copyright (C) 2023. Robert Bosch GmbH Copyright (C) 2023. Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved. */
import { OverlayOptions } from '@spectrum-web-components/overlay';
export declare class BciOverlay {
  /**
   * Configuration
   */
  config: OverlayOptions;
  /**
   * The dialog will be positioned relative to this element
   */
  host?: HTMLElement;
  /**
   * This will be shown in the dialog
   */
  dialog?: HTMLElement;
  private _shouldReopen;
  private close?;
  onConfigChange(newConfig: OverlayOptions, oldConfig: OverlayOptions): void;
  componentDidRender(): void;
  /**
   * try to show the overlay and return the current visibility state
   */
  show(): Promise<boolean>;
  /**
   * update the overlay, e.g. to fix positioning
   */
  update(): Promise<void>;
  /**
   * try to hide the overlay and return the current visibility state
   */
  hide(): Promise<boolean>;
  render(): any;
}

