/* Copyright (C) 2023. Robert Bosch GmbH Copyright (C) 2023. Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved. */
export interface SidebarNavItem {
  title: string;
  tags: string[];
  path: string;
  navigationPath?: string[];
  children?: SidebarNavItem[];
  active?: boolean;
  icon?: string;
  expanded?: boolean;
  scsId?: string;
  scsBaseUrl?: string;
  jsFiles?: string[];
  cssFiles?: string[];
  htmlFile?: string;
  hidden?: boolean;
  showSettingsIcon?: boolean;
  explicitLeaveEventing?: boolean;
  actions?: {
    [key: string]: SidebarNavItemAction;
  };
}
export interface SidebarNavItemAction {
  title: string;
  contexts: Array<string>;
  path?: string;
  localization: {
    [key: string]: string;
  };
  canBeShownAsModal: boolean;
}

