/* Copyright (C) 2023. Robert Bosch GmbH Copyright (C) 2023. Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved. */
/**
 * Copyright (C) 2021. Robert Bosch GmbH Copyright (C) 2021. Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved.
 */
import { Facility } from '../../components/facility-selector/facility.interface';
export declare class FacilitySelectionContoller {
  private _selectedItemPerLevel;
  private _checkedItemPerLevel;
  private _selectedItems;
  private _checkedItems;
  private _indeterminateItems;
  private _enableMultiSelection;
  constructor(_selectedItemPerLevel?: Facility[], _checkedItemPerLevel?: Facility[][], _selectedItems?: Set<string>, _checkedItems?: Set<string>, _indeterminateItems?: Map<string, number>, _enableMultiSelection?: boolean);
  get selectedItemPerLevel(): Facility[];
  get checkedItemPerLevel(): Facility[][];
  get checkedItems(): Set<string>;
  get selectedItems(): Set<string>;
  get indeterminateItems(): Map<string, number>;
  get numberOfCheckedItems(): number;
  get checkedItemList(): string[];
  get isMultiSelectEnabled(): boolean;
  set isMultiSelectEnabled(enableMultiSelection: boolean);
  getSelectedItemAtLevel(level: number): Facility;
  isSelected(item: Facility): boolean;
  isChecked(item: Facility): boolean;
  isIndeterminate(item: Facility): boolean;
  selectItem(item: Facility, level: number): void;
  deselectItem(item: Facility): void;
  checkItem(item: Facility, level: number): void;
  uncheckItem(item: Facility, level: number): void;
  markAsIndeterminate(item: Facility): void;
  unmarkAsIndeterminate(item: Facility): void;
  clearCheckedItems(): void;
  clear(): void;
}

