/* Copyright (C) 2023. Robert Bosch GmbH Copyright (C) 2023. Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved. */
/**
 * Copyright (C) 2021. Robert Bosch GmbH Copyright (C) 2021. Robert Bosch Manufacturing Solutions GmbH, Germany. All rights reserved.
 */
import { Facility, RecentSearchItem, SearchQuery } from '../../components/facility-selector/facility.interface';
import { FacilitySelectionState } from './facility-selection-state';
import { FacilitySelectionContoller } from './facility-selection.controller';
export declare class FacilitySelectorController {
  getRoot: () => Promise<Facility[]>;
  getChildren: (node: Facility) => Promise<Facility[]>;
  getParent: (node: Facility) => Promise<Facility>;
  getSearchResults: (searchQuery: SearchQuery) => Promise<Record<string, Facility[]>>;
  private _columns;
  private _state;
  private _isStateSet;
  private _selectionController;
  private _isMultiSelectEnabled;
  private _update;
  constructor(getRoot: () => Promise<Facility[]>, getChildren: (node: Facility) => Promise<Facility[]>, getParent: (node: Facility) => Promise<Facility>, getSearchResults: (searchQuery: SearchQuery) => Promise<Record<string, Facility[]>>);
  get selectionState(): FacilitySelectionContoller;
  get isStateSet(): boolean;
  onChange(callback: any): void;
  setStateInstance(state: FacilitySelectionState): void;
  setSelectionStateInstance(selectionState?: FacilitySelectionContoller): void;
  initialize(checkedItems: Facility[]): void;
  enableMultiSelection(isMultiSelectEnabled: boolean): void;
  hasParent(node: Facility): boolean;
  hasColumns(): boolean;
  hasColumnAt(level: number): boolean;
  getColumns(): Facility[][];
  setColumns(columns: Facility[][]): void;
  getColumnAtLevel(level: number): Facility[];
  removeColumnsFromIndex(index: number): void;
  appendColumn(column: Facility[]): void;
  getChildColumn(node: Facility): Promise<boolean>;
  setDefaultState(checkedItems: Facility[]): void;
  resetToDefaultState(): void;
  updateDefaultState(): void;
  selectNode(node: Facility, level?: number): Promise<boolean>;
  deSelectNode(node: Facility, level: number): void;
  checkNode(node: Facility, level: number): void;
  uncheckNode(node: Facility, level: number): void;
  markNodeAsIndeterminate(node: Facility): void;
  unMarkNodeAsIndeterminate(node: Facility): void;
  checkAll(checkedItems: Facility[]): void;
  search(searchQuery: SearchQuery): Promise<Record<string, Facility[]>>;
  selectSearchResult(selectedSearchResult: Facility, searchRoot: Facility): Promise<any>;
  checkSearchResult(checked: boolean, searchResult: Facility): void;
  selectRecentSeachItem(recentSearchItem: RecentSearchItem): void;
  loadColumnsBasedOn(checkedItems: Facility[]): Promise<any>;
  resetNodeList(): void;
  reset(): void;
  private markAllParentsAsIndeterminate;
  private unmarkAllParentsAsIndeterminate;
  private checkNodeWithoutLevelInformation;
  private getCommonSelectionPath;
  private getSelectionPathFrom;
  private getDeepestCommonSelectionPath;
}

